#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <functional>
#include <bitset>
#include <deque>
#include <cmath>
#include <queue>
#include <cstdlib>
#include <stdio.h>
#include <cassert>
#include <climits>
#include <ctime>
#include <algorithm>
#include <string>

using ld = long double;
using ll = long long;
using namespace std;

void solve() {
	int n;
	cin >> n;
	if (n == 0) {
		cout << 0;
		return;
	}
	vector<int> prev(n, -1);
	vector<int> num(n);
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		vector<int> ids(k);
		for (int& x : ids) {
			cin >> x;
			--x;
		}
		int minPrev = 1;
		for (int id : ids) {
			if (prev[id] != -1) {
				minPrev = min(minPrev, num[prev[id]]);
			}
			prev[id] = i;
		}
		num[i] = minPrev - 1;
		ans = max(ans, -num[i]);
	}
	cout << ans + 1;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr);
	int t = 1;
	// cin >> t;
    while (t-- > 0) solve();
}