// chrono::system_clock::now().time_since_epoch().count()
#include <bits/stdc++.h>

#define pb push_back
#define eb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define debug(x) cerr << #x << " = " << x << endl

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int MAXN = (int)1e5 + 5;

vi adj[MAXN], vec[MAXN], ord;
bool used[MAXN];
int dp[MAXN];
int n;

void dfs(int v) {
    used[v] = 1;
    
    for (int to : adj[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    
    ord.pb(v);
}

void solve() {
    cin >> n;
    
    rep (i, 1, n + 1) {
        int k;
        cin >> k;
        
        rep (j, 0, k) {
            int x;
            cin >> x;
            vec[x].pb(i);
        }
    }
    
    rep (i, 1, 100001) {
        rep (j, 1, sz(vec[i])) {
            //cerr << vec[i][j - 1] << ' ' << vec[i][j] << endl;
            adj[vec[i][j - 1]].pb(vec[i][j]);
        }
    }
    
    rep (i, 1, n + 1) {
        if (!used[i]) {
            dfs(i);
        }
    }
    
    //reverse(all(ord));
    
    for (int v : ord) {
        dp[v] = 1;
    
        for (int to : adj[v]) {
            dp[v] = max(dp[v], dp[to] + 1);
        }
    }
    
    cout << *max_element(dp + 1, dp + n + 1) << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt = 1;
    
    while (tt--) {
        solve();
    }

    return 0;
}
