#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

#define F first
#define S second

#define en end()
#define bg begin()

#define rev reverse
#define mp make_pair
#define pb push_back

#define y1 y1234567890
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()
#define len(x) (int)strlen(x)

#define sqr(x) ((x + 0ll) * (x))
#define sqrd(x) ((x + 0.0) * (x))

#define forn(i, n) for (int i = 1; i <= n; i++)

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const int N = 800500;

int sz, ar[N];
int n, k[N], mn[N], mx[N], ans[N], t[N], a[N], b[N];
vector < int > g[N], ev[N], ev1[N], qr[N], qr1[N];

void dfs(int v) {
	mn[v] = mx[v] = k[v];
	for (auto to : g[v]) {
		dfs(to);
		mn[v] = min(mn[v], mn[to]);
		mx[v] = max(mx[v], mx[to]);
	}
	//cerr << v << " : " << mn[v] << " " << mx[v] << "\n";
}

inline void upd(int i) {
	for (; i <= sz; i += i & -i)
		t[i]++;
}
inline int get(int i) {
	int res = 0;
	for (; i >= 1; i -= i & -i)
		res += t[i];
	return res;
}

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;
	
	cin >> n;
	for (int i = 1; i <= n; i++) {
		int l, r;
		cin >> l >> r >> k[i];
		if (l) g[i].pb(l);
		if (r) g[i].pb(r);
	}
	dfs(1);
	for (int i = 1; i <= n; i++) {
		ar[++sz] = mn[i];
		ar[++sz] = mx[i];
	}
	int q;
	cin >> q;
	for (int i = 1; i <= q; i++) {
		cin >> a[i] >> b[i];
		ar[++sz] = a[i];
		ar[++sz] = b[i];
		/*int ans = 0;
		for (int j = 1; j <= n; j++) {
			if (l <= mn[j] && mx[j] <= r)
				continue;
			if (mx[j] < l || r < mn[j])
				continue;
			ans++;
		}
		cout << ans * 2 + 1 << "\n";*/
	}
	sort(ar + 1, ar + 1 + sz);
	sz = unique(ar + 1, ar + 1 + sz) - ar - 1;
	for (int i = 1; i <= n; i++) {
		mn[i] = lower_bound(ar + 1, ar + 1 + sz, mn[i]) - ar;
		mx[i] = lower_bound(ar + 1, ar + 1 + sz, mx[i]) - ar;
		ev[mx[i]].pb(i);
		ev1[mn[i]].pb(i);
	}
	for (int i = 1; i <= q; i++) {
		a[i] = lower_bound(ar + 1, ar + 1 + sz, a[i]) - ar;
		b[i] = lower_bound(ar + 1, ar + 1 + sz, b[i]) - ar;
		qr[b[i]].pb(i);
		qr1[a[i]].pb(i);
		ans[i] = n;
	}
	for (int i = 1, cur = 0; i <= sz; i++) {
		for (auto j : qr1[i]) {
			ans[j] -= cur;
			//cerr << "+ " << cur << "\n";
		}
		for (auto j : ev[i]) {
			upd(mn[j]);
			cur++;
		}
		for (auto j : qr[i]) {
			ans[j] -= get(i) - get(a[j] - 1);
			//cerr << "- " << get(i) - get(a[j] - 1) << "\n";
		}
	}
	memset(t, 0, sizeof(t));
	for (int i = sz, cur = 0; i >= 1; i--) {
		for (auto j : qr[i]) {
			ans[j] -= cur;
			//cerr << "? " << cur << "\n";
		}
		cur += sz(ev1[i]);
	}
	for (int i = 1; i <= q; i++)
		cout << ans[i] * 2 + 1 << "\n";
	
	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;

	return 0;
}
