#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define ferrari ios_base::sync_with_stdio(false); cin.tie(NULL)
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const ll mod = 1e9 + 7; // 998244353
const ll INF = 1e18;
const int inf = 2e9;
const int N = 100100;

int n, last[N];
vector<int> g[N];

bool can(int cur) {
	memset(last, -1, sizeof last);
	for (int i = 0; i < n; i++) {
		int mn = inf;
		if (cur == 0) return false;
		for (int j: g[i]) {
			if (last[j] != -1) mn = min(mn, last[j]);
		}
		if (mn == inf) {
			for (int j: g[i])
				last[j] = cur;
		} else {
			cur = mn - 1;
			if (cur < 1) return false;
			for (int j: g[i]) last[j] = cur;
		}
	}
	return true;
}

int main() {
	ferrari;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int k; cin >> k;
		while (k--) {
			int x; cin >> x;
			g[i].pb(x);
		}
	}
	int l = 1, r = n, ans = n;
	while (l <= r) {
		int mid = (l + r) >> 1;
		if (can(mid)) {
			ans = mid;
			r = mid - 1;
		} else l = mid + 1;
	}
	cout << ans;
}
