#include <bits/stdc++.h>


using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template <typename T>
int sz(T &x) {
  return (int)(x.size());
}

int power(int x, int y, int mod) {
  if (y == 0) {
    return 1;
  }
  int z = power(x, y >> 1, mod);
  z = z * 1ll * z % mod;
  if (y & 1) {
    z = z * 1ll * x % mod;
  }
  return z;
}

const int mod = 998244353;
const int inf = 1'000'000'007;

vector<vector<int> > g;
vector<int> cur;

vector<int> gen(int v) {

  vector<int> ans;
  for (int i = 0; i < sz(g[v]); ++i) {

    vector<int> cur = gen(g[v][i]);
    vector<int> kek = ans;
    for (int j = 0; j < sz(cur); ++j) {
      ans.push_back(cur[j]);
      if (j % 2 == 0) {
        for (int j = sz(kek) - 1; j >= 0; --j) {
          ans.push_back(kek[j]);
        }
      } else {
        for (int j = 0; j < sz(kek); ++j) {
          ans.push_back(kek[j]);
        }
      }
    }
  }
  ans.insert(ans.begin(), v);
  return ans;
}

void solve() {
  int n;
  cin >> n;
  g.resize(n + 1);
  for (int i = 2; i <= n; ++i) {
    int x;
    cin >> x;
    g[x].push_back(i);
  }
  vector<int> ans = gen(1);
  ans.erase(ans.begin());
  cout << sz(ans) << "\n";
  for (int i : ans) {
    cout << i << " ";
  }

}

int main() {
  #ifdef LOCAL58
    // don't forget to remove if interactive
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
  #endif

  int t;
  t = 1;
  while (t--) {
    solve();
  }
  return 0;
}
