#include <bits/stdc++.h>


using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template <typename T>
int sz(T &x) {
  return (int)(x.size());
}

int power(int x, int y, int mod) {
  if (y == 0) {
    return 1;
  }
  int z = power(x, y >> 1, mod);
  z = z * 1ll * z % mod;
  if (y & 1) {
    z = z * 1ll * x % mod;
  }
  return z;
}

const int mod = 998244353;
const int inf = 1'000'000'007;

string reversed(string x) {
  reverse(x.begin(), x.end());
  return x;

}

void solve() {
  string a, b;
  cin >> a >> b;

  int n;
  cin >> n;
  unordered_map<string, int> has;
  for (int i = 0; i < n; ++i) {
    string x;
    cin >> x;
    reverse(x.begin(), x.end());
    has[x] = 1;
  }

  reverse(a.begin(), a.end());
  reverse(b.begin(), b.end());

  string c = a + b;
  sort(c.begin(), c.end());
  c.resize(unique(c.begin(), c.end()) - c.begin());

  if (sz(c) > 10) {
    cout << "0\n";
    return;
  }

  vector<int> idc(26, -1);
  for (int i = 0; i < sz(c); ++i) {
    idc[c[i] - 'A'] = i;
  }

  vector<int> p;
  for (int i = 0; i < 10; ++i) {
    p.push_back(i);
  }

  unordered_map<string, int> ans;
  int tot = 0;

  vector<int> id(10, 0);
  map<vector<int>, int> neko;

  do {
    for (int i = 0; i < 10; ++i) {
      id[p[i]] = i;
    }
    vector<int> cf;
    for (int i = 0; i < sz(c); ++i) {
      cf.push_back(p[i]);
    }
    if (neko.count(cf)) {
      continue;
    }
    neko[cf] = 1;

    int carry = 0;
    int cnt = 0;
    int pos = -1;

    int operations = 0;
    string res = "";
    for (int i = 0; carry || i < max(sz(a), sz(b)); ++i) {
      int val = (i < sz(a) ? p[idc[a[i] - 'A']] : 0) + (i < sz(b) ? p[idc[b[i] - 'A']] : 0) + carry;
      int d = (val % 10);
      carry = val / 10;
      if (id[d] < sz(c)) {
        res += c[id[d]];
      } else {
        res += '?';
        pos = i;
        cnt++;
        if (cnt > 1) {
          break;
        }
      }
      operations++;
    }
    if (cnt > 1) {
      continue;
    }
    if (pos == -1) {

      if (has.count(res)) {
        ans[res]++;
      }
    } else if (sz(c) < 10) {
      for (int i = 0; i < 26; ++i) {
        if (idc[i] != -1) {
          continue;
        }
        res[pos] = char(i + 'A');
        if (has.count(res)) {
          ans[res]++;
        }
      }
    }

  } while (next_permutation(p.begin(), p.end()));

  vector<string> full;
  for (auto i : ans) {
    if (i.second == 1) {
      full.push_back(i.first);
    }
  }
  cout << sz(full) << "\n";
  for (auto i : full) {
    cout << i << "\n";
  }

}

int main() {
  //freopen("brainteaser2.in", "r", stdin);
  #ifndef LOCAL58
    // don't forget to remove if interactive
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
  #endif

  int t;
  t = 1;
  while (t--) {
    solve();
  }
  return 0;
}
