#include <bits/stdc++.h>
#include <vector>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
 
using namespace std;
using namespace __gnu_pbds;
 
typedef unsigned long long ull;
typedef long long ll;

#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define speedhack() ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define form(i, n) for (size_t i = 0; i < size_t(n); ++i)
#define forn(i, n) for (size_t i = 1; i <= size_t(n); ++i)

template<class T> using ordered_set=tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

ll mod(ll a, ll b) { return (a%b+b)%b; }
ll gcd(ll x, ll y) { return __gcd(x, y); }
ll lcm(ll x, ll y) { return x * 1ll * y / gcd(x, y); }
 
const ll MAXN = 1e18;
const ll SIZE = 2e5 + 5;
const ll MOD  = 1e9 + 7;
const ll MODY = 998244353;

ll n, a, b, color[2][500500];
map<ll, ll> mp;
bool res = true;

void calc (ll o, ll t, ll v) {
    if (t) {
        --t;
        color[0][v] = 2;
        color[1][v] = 2;
    } else if (o) {
        --o;
        color[0][v] = 1;
        color[1][v] = 1;
    } else return;

    ll addero = o % 2, addert = t % 2;
    calc ((o / 2) + addero, (t / 2) + addert, v * 2);
    calc (o / 2, t / 2, v * 2 + 1);
}

void dfs (ll v) {
    if (color[1][v] == 0) return;
    dfs (v * 2);
    dfs (v * 2 + 1);
    color[0][v] += color[0][v * 2];
    color[0][v] += color[0][v * 2 + 1];

    ll diff = color[0][v * 2] - color[0][v * 2 + 1];
    if (diff > 1)
        res = false;
}

int main() { speedhack()

    cin >> a >> b;
    calc (a, b, 1);
    dfs (1);
    if (res == false) {
        cout << -1;
        return 0;
    }

    for (int i = 1, j = 1; i < 500500; i++)
        if (color[1][i]) mp[i] = j++;

    for (int i = 1; i < 500500; i++) {
        if (color[1][i]) {
            cout << color[1][i];
            if (color[1][i * 2]) cout << " " << mp[i * 2];
            else cout << " 0";
            if (color[1][i * 2 + 1]) cout << " " << mp[i * 2 + 1];
            else cout << " 0";
            cout << endl;
        }
    }
    

    return 0;
}
