#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2")
//#pragma GCC optimize("O0")

#include <bits/stdc++.h>

using namespace std;

const int maxn = 300'000;
int n;
int a[maxn];
bool dp[maxn];
bool isEdge(int i, int j) {
  return j - i <= 8 - __builtin_popcount(a[i] ^ a[j]);
}

int ans[maxn];
bool update(int i) {
  bool ok = false;
  for (int j = i + 1; j <= i + 8; j++) {
    if (j >= n) break;
    ok |= isEdge(i, j) && !dp[j];
  }
  if (ok != dp[i]) {
    dp[i] = ok;
    return true;
  }
  return false;
}
void solve() {
  cin >> n;
  for (int i = 0; i < n; i++) {
    string s;
    cin >> s;
    for (int j = 0; j < 8; j++) if (s[j] == 'W') a[i] |= 1 << j;
  }
  for (int i = n - 1; i >= 0; i--) {
    update(i);
  }
  for (int i = n - 1; i >= 0; i--) {
    ans[i] = dp[0] ? 1 : 2;
    if (i == 0) break;
    set<int> active;
    active.insert(i);
    dp[i] = true;
    while (!active.empty()) {
      int v = *active.rbegin();
      active.erase(v);
      for (int j = v - 1; j >= v - 8; j--) {
        if (j < 0) break;
        if (isEdge(j, v) && update(j)) {
          active.insert(j);
        }
      }
    }
  }
  for (int i = 0; i < n; i++) cout << ans[i];
}

int main() {
//  freopen("police.in", "r", stdin);
//  freopen("police.out", "w", stdout);
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
}