#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<algorithm>
#include<map>
#include<vector>
#include<set>
#include<stack>
#include<iostream>
#include<stdio.h>
#include<math.h>
#include<string>
#include<iomanip>
#include<unordered_set>
#include <random>
#include <time.h> 
#include<climits>
#pragma comment(linker, "/STACK:512777215")

using namespace std;

typedef long long ll;
const long double eps = 1e-8;
const int inf = 1e9;
const ll INF = 1e18;
const ll mod = inf + 7;
const double pi = 3.1415926535;
#define max_n 10000000
#define nl '\n'
#define cint(n) int n; cin >> n
#define cill(n) ll n; cin >> n
#define dbg(x) cout << (#x) << ": " << x << nl
#define elif else if

inline void io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef NoSteam
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
}

inline int input() {
	char c = ' ';
	int ans = 0;
	bool m = 0;
	while (!isdigit(c)) {
		c = _getc_nolock(stdin);
		if (c == '-')
			m = 1;
	}
	while (isdigit(c)) {
		ans *= 10;
		ans += c - '0';
		c = _getc_nolock(stdin);
	}
	return (m ? -ans : ans);
}

ll gcd(ll a, ll b) {
	while (b != 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

struct node {
	int key;
	int left;
	int right;
	int min;
	int max;
	int count;
};

vector<node> tree;

void calc(int v) {
	if (v == -1) {
		return;
	}
	tree[v].max = tree[v].key;
	tree[v].min = tree[v].key;
	tree[v].count = 1;
	if (tree[v].left != -1) {
		calc(tree[v].left);
		tree[v].max = max(tree[v].max, tree[tree[v].left].max);
		tree[v].min = min(tree[v].min, tree[tree[v].left].min);
		tree[v].count += tree[tree[v].left].count;
	}
	if (tree[v].right != -1) {
		calc(tree[v].right);
		tree[v].max = max(tree[v].max, tree[tree[v].right].max);
		tree[v].min = min(tree[v].min, tree[tree[v].right].min);
		tree[v].count += tree[tree[v].right].count;
	}
}

int lookup(int v, int L, int R) {
	if (v == -1)
		return 1;
	if (L <= tree[v].min && tree[v].max <= R) {
		return 1;
	}
	if (tree[v].max < L || R < tree[v].min)
		return 1;
	int res = 1;
	res += lookup(tree[v].left, L, R);
	res += lookup(tree[v].right, L, R);
	return res;
}

int main()
{
	io();
	int n = input();
	tree.resize(n);
	for (int i = 0; i < n; i++) {
		tree[i].left = input() - 1;
		tree[i].right = input() - 1;
		tree[i].key = input();
	}
	calc(0);
	cint(q);
	int l, r;
	for (int i = 0; i < q; i++) {
		l = input();
		r = input();
		cout << lookup(0, l, r) << nl;
	}
}