//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O2")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
////
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define allp(x) (x)->begin(), (x)->end()

#define pb push_back


using namespace std;
void dout() { cerr << endl; }
//typedef long long ll;
template <typename Head, typename... Tail>
void dout(Head H, Tail... T) {
    cerr << H << ' ';
    dout(T...);
}

using ll = long long;
//#ifdef __int128
//using hll = __int128;
//#endif
using pii = pair<ll, ll>;
using ld = long double;

template <typename T>
void do_uniq(vector<T> &vec){
    sort(all(vec));
    vec.resize(unique(all(vec)) - vec.begin());
}

#ifndef ONLINE_JUDGE

clock_t timestamp_start = clock();
void time_calc()
{
    cerr << (ld)(clock() - timestamp_start) / CLOCKS_PER_SEC << "\n";
}
#endif


#ifdef _getchar_nolock
#else
#    define _getchar_nolock getchar_unlocked
#endif

#define integer int

integer mod = 1e9 + 7;

integer ml(integer a, integer b) {
    return (a * 1ll * b) % mod;
}

integer add(integer a, integer b) {
    return (a + b) % mod;
}

integer sub(integer a, integer b) {
    return add(a, mod - b);
}

integer sq(integer a) {
    return ml(a, a);
}

integer b_p(integer b, integer p) {
    if (p == 0) return 1;
    if (p & 1) return ml(b, b_p(b, p - 1));
    return sq(b_p(b, p >> 1));
}

integer bback(integer e) {
    return b_p(e, mod - 2);
}

#define solvsh
#define multi

#ifdef solvsh


struct vec {
    ll x, y;

    vec operator-(vec other) {
        return {x - other.x, y - other.y};
    }

};



struct vec2 {
    ld x, y;
};

ll sqre(vec a, vec b) {
    return abs(a.x * b.y - a.y * b.x);
}

vec a, b, c;

struct line {
    vec st, ed;
    ll a, b, c;
};

bool on(vec p, line l){
    return sqre(l.ed - p, l.st - p) == 0;
}

vector<line> lns;
const int MAXN = 1e6 + 32;

integer facts[MAXN];
integer backs[MAXN];

integer nCr(int n, int r) {
    if (r > n) return 0;
    return ml(facts[n], ml(bback(facts[r]), bback(facts[n - r])));
}

integer calc_prf(int k, int x) {
    return nCr(k + x + 1, k + 1);
}

integer calc_seg(int l, int r, int k) {

    if (l > r) return 0;


    return sub(calc_prf(k, r), calc_prf(k, l - 1));
}

bool inn(vec a, vec b, vec c, vec p) {
    ll sgin = 0;


    sgin += sqre(a - p, b - p);
    sgin += sqre(c - p, b - p);
    sgin += sqre(c - p, a - p);

    return abs(sgin) == sqre(a - b, c - b);
}

ld det (ld a, ld b, ld c, ld d) {
    return a * d - b * c;
}

bool intersect_l (line m, line n, vec2 & res) {
    ld zn = det (m.a, m.b, n.a, n.b);
    if (abs (zn) < 1e-7)
        return false;
    res.x = - det (m.c, m.b, n.c, n.b) / zn;
    res.y = - det (m.a, m.c, n.a, n.c) / zn;
    return true;
}

integer intrec(ll k) {

    ll minindx = 1e18;
    ll maxindx = -1e18;


    line curr = {
            {-k,     k},
            {-k + 1, k + 1}
    };

    curr.a = 1;
    curr.b = -1;
    curr.c = 2 * k;

    bool okk = false;

    for (auto l : lns) {
        if (on(l.st, curr)) {
            ll diff = l.st.x + k;
            minindx = min(minindx, diff);
            maxindx = max(maxindx, diff);
            okk = true;
        }

        if (on(l.ed, curr)) {
            ll diff = l.ed.x + k;
            minindx = min(minindx, diff);
            maxindx = max(maxindx, diff);
            okk = true;
        }
    }

    if (okk) {
        return calc_seg(minindx, maxindx, k);
    }

    bool once = false;

    for (auto l : lns) {
        vec2 res;
        if (intersect_l(l, curr, res)) {
            ll xx = floor(res.x);
            ll yy = floor(res.y);
            if (inn(a, b, c, {xx, yy})) {
                ll diff = xx + k;
                minindx = min(minindx, diff);
                maxindx = max(maxindx, diff);
                once = true;
            }
            if (inn(a, b, c, {xx + 1, yy + 1})) {
                ll diff = xx + 1 + k;
                minindx = min(minindx, diff);
                maxindx = max(maxindx, diff);
                once = true;
            }
        }
    }

    if (!once) return 0;

    return calc_seg(minindx, maxindx, k);
}

void solve() {

    cin >> a.x >> a.y;
    cin >> b.x >> b.y;
    cin >> c.x >> c.y;

    integer answr = 0;

    lns.clear();

    lns.push_back({
                          a, b
                  });
    lns.back().a = a.y - b.y;
    lns.back().b = b.x - a.x;
    lns.back().c = a.x * b.y - b.x * a.y;

    lns.push_back({
                          c, b
                  });

    lns.back().a = c.y - b.y;
    lns.back().b = b.x - c.x;
    lns.back().c = c.x * b.y - b.x * c.y;

    lns.push_back({
                          a, c
                  });

    lns.back().a = a.y - c.y;
    lns.back().b = c.x - a.x;
    lns.back().c = a.x * c.y - c.x * a.y;

    for (ll x = 0; x <= MAXN / 2; ++x) {
        answr = add(answr, intrec(x));
    }

    cout << answr << "\n";
}

void precalc(){
    facts[0] = 1;

    for (int i = 1; i < MAXN; ++ i) {
        facts[i] = ml(facts[i - 1], i);
    }
}

#else

#endif

void multisolve() {
    precalc();

    int t;
    cin >> t;

    int i = 1;
    while (t--) {
        solve();
        i++;
    }
}

#ifndef ONLINE_JUDGE

void gen() {
}

#endif

#define int int
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    cout << fixed << setprecision(20);

#ifndef ONLINE_JUDGE
#define NAME "../input"
    freopen(NAME".in", "r", stdin);
//    freopen("../output.out", "w", stdout);
#else
#endif
#ifdef multi
    //            gen();
        multisolve();
#else

    solve();
//    gen();
#endif
//     time_calc();
}
