#define F first
#define S second
 
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,mmx,abm,popcnt")
 
#include <bits/stdc++.h>
     
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef long double ld;
 
 
using namespace std;
 
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());




int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    auto starttime = chrono::steady_clock::now();
#else
    // freopen("incredible.in", "r", stdin);
    // freopen("incredible.out", "w", stdout);
#endif
    int p;
    string s;
    int n;
    cin >> n;
    int bid = 0;
    int best = 1e9;
    for(int i = 0; i < n; ++i) {
        cin >> p >> s;
        int c[26] = {0};
        for(auto ch: s) {
            ++c[ch - '0'];
        }
        if(c[0] >= 1 && c[1] >= 1 && c[2] >= 2) {
            if(p < best) {
                bid = i + 1;
                best = p;
            }
        }
    }
    cout << bid;
#ifdef LOCAL
    auto endtime = chrono::steady_clock::now();
    printf("\n[Finished in %.3lfs]\n",1e-6*(ll)chrono::duration_cast
        <chrono::microseconds>(endtime-starttime).count());
#endif
    return 0;
}