fun main() {
    val n = readInt()
    val lastSeen = IntArray(100_500) { n + 1 }
    val boughtSigns = ArrayList<Int>()
    boughtSigns.add(n + 1)
    for (day in n downTo 1) {
        val data = readInts()
        val k = data[0]
        val minSeen = IntRange(1, k).map { lastSeen[data[it]] }.minOrNull() ?: (n + 1)
        val maxSign = maxSign(boughtSigns, minSeen)
        val toSet = if (maxSign == null) {
            boughtSigns.add(day)
            day
        } else {
            maxSign
        }
        IntRange(1, k).forEach { lastSeen[data[it]] = toSet }
    }
    println(boughtSigns.size - 1)
}

fun maxSign(boughtSigns: ArrayList<Int>, minSeen: Int): Int? {
    if (boughtSigns.last() >= minSeen) {
        return null
    }
    var l = -1
    var r = boughtSigns.lastIndex
    while (l + 1 < r) {
        val mid = (l + r) / 2
        if (boughtSigns[mid] < minSeen) {
            r = mid
        } else {
            l = mid
        }
    }
    return r
}

/**
 * IO functions
 */
private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readLong() = readLn().toLong()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
private fun readLongs() = readStrings().map { it.toLong() }
private fun readDoubles() = readStrings().map { it.toDouble() }