/*
#define _CRT_SECURE_NO_WARNINGS
#include<algorithm>
#include<vector>
#include<map>
#include<set>
#include<string>
#include<queue>
#include<stack>
#include<cmath>
#include<iostream>
#include<random>
#include<time.h>
#include<iomanip>
#include"stdio.h"
#include<chrono>
*/
#include <bits/stdc++.h>
using namespace std;

//mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());

__int128_t gcd(__int128_t a, __int128_t b, __int128_t& x, __int128_t& y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	__int128_t x1, y1;
	__int128_t d = gcd(b % a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}

bool find_any_solution(__int128_t a, __int128_t b, __int128_t c, __int128_t& x0, __int128_t& y0, __int128_t& g) {
	g = gcd(abs(a), abs(b), x0, y0);
	if (c % g != 0)
		return false;
	x0 *= c / g;
	y0 *= c / g;
	if (a < 0)   x0 *= -1;
	if (b < 0)   y0 *= -1;
	return true;
}

void shift_solution(__int128_t& x, __int128_t& y, __int128_t a, __int128_t b, __int128_t cnt) {
	x += cnt * b;
	y -= cnt * a;
}

__int128_t find_all_solutions(__int128_t a, __int128_t b, __int128_t c, __int128_t minx, __int128_t maxx, __int128_t miny, __int128_t maxy) {
	__int128_t x, y, g;
	if (!find_any_solution(a, b, c, x, y, g))
		return 0;
	a /= g;  b /= g;

	__int128_t sign_a = a > 0 ? +1 : -1;
	__int128_t sign_b = b > 0 ? +1 : -1;

	shift_solution(x, y, a, b, (minx - x) / b);
	if (x < minx)
		shift_solution(x, y, a, b, sign_b);
	if (x > maxx)
		return 0;
	__int128_t lx1 = x;

	shift_solution(x, y, a, b, (maxx - x) / b);
	if (x > maxx)
		shift_solution(x, y, a, b, -sign_b);
	__int128_t rx1 = x;

	shift_solution(x, y, a, b, -(miny - y) / a);
	if (y < miny)
		shift_solution(x, y, a, b, -sign_a);
	if (y > maxy)
		return 0;
	__int128_t lx2 = x;

	shift_solution(x, y, a, b, -(maxy - y) / a);
	if (y > maxy)
		shift_solution(x, y, a, b, sign_a);
	__int128_t rx2 = x;

	if (lx2 > rx2)
		swap(lx2, rx2);
	__int128_t lx = max(lx1, lx2);
	__int128_t rx = min(rx1, rx2);

	return (rx - lx) / abs(b) + 1;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	//cout.tie(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		long long x, y;
		cin >> x >> y;
		__int128_t f, e;
		//if ((x * x) % gcd(x, y, f, e) == 0&&find_all_solutions(x, y, x * x, 1, 1e16, 1, 1e16) < 0)throw 1;
		if ((x*x)%gcd(x, y,f,e)==0) {
			cout << max((long long)(0),(long long)(find_all_solutions(x, y, x * x, 1, 1e18, 1, 1e18))) << endl;
		}
		else cout << 0 << endl;
	}



}


/*
a x
c y
x y


3 9
7 6
9 6


a 100
c 10
10 100


a/x+/y=x/y

ay+cx=x^2


1
10000000 1000000000

999999999

*/