#include <iostream>

using namespace std;

struct node { // узел дерева
    int key;
    node *left, *right;
    //int min, max;
    //int count;
};

struct info { //входная инфа о дереве
    int li;
    int ri;
    int ki;
};

int num; //скока раз вызвалось
int most_left(node*);
int most_right(node*);

int lookup(node *v, int L, int R) { // функция из условия
    num++;
    if(v == nullptr) {
        return 0;
    }
    int mi = most_left(v), ma = most_right(v);
    if(L <= mi && ma <= R  || ma < L || R < mi) {
        return 0;
    }
    lookup(v->left, L, R);
    lookup(v->right, L, R);
    return 0;
}

info *mas; // массив с инфой о дереве
node *tree; // дерево

node* maketree(int ind) { // создаем дерево по данным из массива
    if(ind == 0) {
        return nullptr;
    }
    node *x = new node;
    x->key = mas[ind-1].ki;

    if(mas[ind-1].li == 0) {
        x->left = nullptr;
    } else {
        x->left = maketree(mas[ind-1].li);
    }

    if(mas[ind-1].ri == 0) {
        x->right = nullptr;
    } else {
        x->right = maketree(mas[ind-1].ri);
    }


    return x;
}

int most_left(node *ptr){ //самый левый - наименьший
    while(ptr->left != nullptr) {
        ptr = ptr->left;
    }
    return ptr->key;
}

int most_right(node *ptr){ // самый правый - наибольший
    while(ptr->right != nullptr) {
        ptr = ptr->right;
    }
    return ptr->key;
}

int main() {
    node *bintr;
    int countnodes;
    cin >> countnodes;
    mas = new info[countnodes];

    int li, ri, ki;
    for(int i = 0; i < countnodes; i++) {
        cin >> li >> ri >> ki;
        mas[i].li = li;
        mas[i].ri = ri;
        mas[i].ki = ki;
    }

    tree = maketree(1);

    int nq;
    cin >> nq;
    for(int i = 0; i < nq; i++) {
        int L, R;
        cin >> L >> R;
        num = 0;
        lookup(tree, L, R);
        cout << num << endl;
    }
}
