#include <iostream>

using namespace std;

struct info { //входная инфа о дереве
    int li;
    int ri;
    int ki;
    int minn;
    int maxx;
    bool hasmin, hasmax;
};

int num; //скока раз вызвалось
info *mas; // массив с инфой о дереве

void lookup(int ind, int L, int R) { // функция из условия
    num++;
    if(ind == -1) {
        return;
    }

    if(!mas[ind-1].hasmin) {
        int i = ind - 1;
        while(mas[i].li != 0) {
            i = mas[i].li - 1;
        }
        mas[ind-1].minn = mas[i].ki;
        mas[ind-1].hasmin = true;
    }

    if(!mas[ind-1].hasmax) {
        int i = ind - 1;
        while(mas[i].ri != 0) {
            i = mas[i].ri - 1;
        }
        mas[ind-1].maxx = mas[i].ki;
        mas[ind-1].hasmax = true;
    }

    if(L <= mas[ind-1].minn && mas[ind-1].maxx <= R  || mas[ind-1].maxx < L || R < mas[ind-1].minn) {
        return;
    }
    if(mas[ind-1].li == 0) {
        lookup(-1, L, R);
    } else {
        lookup(mas[ind-1].li, L, R);
    }
    if(mas[ind-1].ri == 0) {
        lookup(-1, L, R);
    } else {
        lookup(mas[ind-1].ri, L, R);
    }
    return;
}

int main() {
    int countnodes;
    cin >> countnodes;
    mas = new info[countnodes];
    int maxxr, minnr;
    int li, ri, ki;
    for(int i = 0; i < countnodes; i++) {
        cin >> li >> ri >> ki;
        if(i == 0) {
            maxxr = ki;
            minnr = ki;
        }
        mas[i].li = li;
        mas[i].ri = ri;
        mas[i].ki = ki;
        mas[i].hasmin = false;
        mas[i].hasmax = false;
        if(ki > maxxr) {
            maxxr = ki;
        }
        else if(ki < minnr) {
            minnr = ki;
        }
    }

    int nq;
    cin >> nq;
    for(int i = 0; i < nq; i++) {
        int L, R;
        cin >> L >> R;
        num = 0;
        if(L <= minnr && maxxr <= R  || maxxr < L || R < minnr) {
            cout << 1 << endl;
        }
        else {
            lookup(1, L, R);
            cout << num << endl;
        }
    }
}
