#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <map>
#include <assert.h>
#include <fstream>
#include <tuple>
#include <queue>
#include <unordered_set>
#include <cstdlib>
#include <random>
#include <iomanip>

using namespace std;

#define sqr(a) ((a)*(a))
#define all(a) (a).begin(), (a).end()

const long long MOD = (int) 1e9 + 7;

long long binPow(long long a, long long b) {
    if (b == 0)
        return 1;

    long long ans = binPow(a, b / 2);
    ans = ans * ans % MOD;

    if (b % 2)
        ans = ans * a % MOD;

    return ans;
}

map<string, vector<int> > orge;
vector<int> p;
bool used[10];
vector<char> kek;
string A, B;
vector<int> h;

void go(int pos) {
    if (pos == kek.size()) {
        string MDA = "??????????";
        int mda[26] = {0};
        for (int i = 0; i < kek.size(); ++i) {
            mda[kek[i] - 'A'] = p[i];
            MDA[p[i]] = kek[i];
        }

        long long a = 0;
        long long b = 0;

        if (mda[A[0] - 'A'] == 0 || mda[B[0] - 'A'] == 0)
            return;

        for (auto i : A) {
            a = a * 10 + mda[i - 'A'];
        }
        for (auto i : B) {
            b = b * 10 + mda[i - 'A'];
        }

        long long sum = a + b;

        string t = "";
        long long tm = sum;
        char last = 'a';
        while (tm) {
            t += MDA[tm % 10];
            if (t[t.size() - 1] == '?') {
                t[t.size() - 1] = last;
                MDA[tm % 10] = last;
                ++last;
            }

            tm /= 10;
        }

        if ((last - 'a') + kek.size() != 10)
            return;

        reverse(all(t));
        for (auto org : orge[t]) {
            ++h[org];
        }

        return;
    }

    for (int i = 0; i < 10; ++i) {
        if (used[i])
            continue;

        used[i] = true;
        p.push_back(i);
        go(pos + 1);
        p.resize(p.size() - 1);
        used[i] = false;
    }
}

int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("iq.in", "r", stdin);
    // freopen("iq.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(228);

    cin >> A >> B;

    int n;
    cin >> n;

    set<char> lol;
    for (char i : A)
        lol.insert(i);
    for (char i : B) 
        lol.insert(i);

    if (lol.size() > 10) {
        cout << "0\n";
        return 0;
    }

    for (auto i : lol)
        kek.push_back(i);

    vector<string> org;
    for (int i = 0; i < n; ++i) {
        string a;
        cin >> a;
        org.push_back(a);

        set<char> w;
        for (auto j : a)
            w.insert(j);

        // if (w.size() <= 10) {
            string MDA = "??????????????????????????";
            for (auto j : kek)
                MDA[j - 'A'] = j;
            char last = 'a';

            for (int j = a.size() - 1; j >= 0; --j) {
                if (MDA[a[j] - 'A'] == '?') {
                    MDA[a[j] - 'A'] = last;
                    a[j] = last;
                    ++last; 
                }
            }

            orge[a].push_back(i);
        // }
    }

    h.resize(n);
    go(0);

    vector<string> ans;
    for (int i = 0; i < n; ++i) {
        if (h[i] == 1) {
            ans.push_back(org[i]);
        }
    }

    cout << ans.size() << "\n";
    for (auto i : ans)
        cout << i << "\n";
}