def gcd(a, b, x, y):
    if b == 0:
        x[0] = 1
        y[0] = 0
        return a
    x1, y1 = [0], [0]
    d = gcd(b, a % b, x1, y1)
    x[0] = y1[0]
    y[0] = x1[0] - y1[0] * (a // b)
    return d


def find_any_solution(a, b, c, x0, y0, g):
    g[0] = gcd(abs(a), abs(b), x0, y0)
    if c % g[0]:
        return False
    x0[0] *= c // g[0]
    y0[0] *= c // g[0]
    if a < 0:
        x0[0] = -x0[0]
    if b < 0:
        y0[0] = -y0[0]
    return True


def shift_solution(x, y, a, b, cnt):
    x[0] += cnt * b
    y[0] -= cnt * a


def find_all_solution(a, b, c, minx, maxx, miny, maxy):
    x, y, g = [0], [0], [0]
    if not find_any_solution(a, b, c, x, y, g):
        return 0
    a //= g[0]
    b //= g[0]
    sign_a = +1 if a > 0 else -1
    sign_b = +1 if b > 0 else -1

    shift_solution(x, y, a, b, (minx - x[0]) // b)
    if x[0] < minx:
        shift_solution(x, y, a, b, sign_b)
    if x[0] > maxx:
        return 0
    lx1 = x[0]

    shift_solution(x, y, a, b, (maxx - x[0]) // b)
    if x[0] > maxx:
        shift_solution(x, y, a, b, -sign_b)
    rx1 = x[0]
    shift_solution(x, y, a, b, -(miny - y[0]) // a)
    if y[0] < miny:
        shift_solution(x, y, a, b, -sign_a)
    if y[0] > maxy:
        return 0

    lx2 = x[0]

    shift_solution(x, y, a, b, -(maxy - y[0]) // a)
    if y[0] > maxy:
        shift_solution(x, y, a, b, sign_a)
    rx2 = x[0]
    if lx2 > rx2:
        lx2, rx2 = rx2, lx2

    lx = max(lx1, lx2)

    rx = min(rx1, rx2)

    if lx > rx:
        return 0
    return (rx - lx) // abs(b) + 1


n = int(input())
for _ in range(n):
    b, d = map(int, input().split())
    print(find_all_solution(d, b, b * b, 1, int(1e18 + 111), 1, int(1e18 + 111)))
