#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1e5;

int countLayers(int x) {
    int i = 0;
    while (x > 0) {
        x >>= 1;
        ++i;
    }
    return i;
}

int a, b;
int baseLayers;
int weights[N];
vector<pair<int, int>> tree;

void go(int u, int layer, int toBalance) {
    if ((1 << layer) & b) {
        weights[u] = 2;
    } else {
        weights[u] = 1;
    }
    if (layer >= baseLayers) {
        toBalance--;
    }
    int l = 0;
    int r = 0;
    if (layer + 1 < baseLayers) {
        l = tree.size();
        tree.push_back({0, 0});
        go(l, layer + 1, toBalance / 2 + toBalance % 2);
        r = tree.size();
        tree.push_back({0, 0});
        go(r, layer + 1, toBalance / 2);
    } else {
        if (toBalance >= 1) {
            l = tree.size();
            tree.push_back({0, 0});
            go(l, layer + 1, toBalance / 2 + toBalance % 2);
        }
        if (toBalance >= 2) {
            r = tree.size();
            tree.push_back({0, 0});
            go(r, layer + 1, toBalance / 2);
        }
    }
    tree[u] = {l, r};
}

void solve() {

    cin >> a >> b;

    baseLayers = countLayers(b);
    int baseVerticesCount = (1 << baseLayers) - 1;
    if (a + b < baseVerticesCount) {
        cout << -1;
        return;
    }

    int aLeft = a + b - baseVerticesCount;
    tree.push_back({0, 0});
    go(0, 0, aLeft);

    for (int u = 0; u < tree.size(); ++u) {
        cout << weights[u] << ' ';
        cout << (tree[u].first == 0 ? 0 : tree[u].first + 1);
        cout << ' ' << (tree[u].second == 0 ? 0 : tree[u].second + 1) << '\n';
    }

}

int main() {
    ios::sync_with_stdio(0);
    cout.tie(0), cin.tie(0);

    //freopen("input.txt", "r", stdin);

    int z = 1;
    /// cin >> z;

    while (z--) {
        solve();
    }

    return 0;
}


