#include <iostream>
#include <fstream>
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
typedef long long ll;
#define FR(i,n) for (ll i = 0; i < n; i++)
#define FRB(i,n) for (ll i = n; i >= 0; i--)

#define PI 3.141592653589793

using namespace std;
struct node {
    node* l = 0, * r = 0;
    int id, w;
    int d = 0;
    node(int ID, int W) :id(ID), w(W) {}
};

int a, b;
node* arr[100001];

void add(node* x, node* y) {
    if (x->d > 0) {
        x->d -= y->w;
        if (x->l) add(x->l, y);
        else x->l = y;
    }
    else {
        x->d += y->w;
        if (x->r) add(x->r, y);
        else x->r = y;
    }
}


node* run() {
    int cnt = 1;
    node* root = new node(cnt, 2);
    arr[cnt++] = root;
    FR(i, b-1) {
        node* nd = new node(cnt, 2);
        arr[cnt++] = nd;
        add(root, nd);
    }
    FR(i, a) {
        node* nd = new node(cnt, 1);
        arr[cnt++] = nd;

        add(root, nd);
    }
    return root;
}

bool check(node* x) {
    if (x == NULL) return true;
    if (abs(x->d) >= 2)
        return false;
    else return check(x->l) && check(x->r);
}


int main() {
    cin.sync_with_stdio(0);
    cin.tie(0);
    cin >> a >> b;
    node* root = run();
    if (check(root)) {
        for (int i = 1; i <= a + b; i++) {
            cout << arr[i]->w << ' ' << (arr[i]->l ? arr[i]->l->id : 0) << ' ' << (arr[i]->r ? arr[i]->r->id : 0) << endl;
        }
    }
    else cout << -1;
}