#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <random>
#include <algorithm>
#include <functional>

typedef long long int int64;
typedef unsigned long long int uint64;

using namespace std;

int n;
int cur_size = 1;

struct foo {
    int a;
    int b;
    int c;
};

vector<foo> nodes;

void print_node(int val, int offset) {
    int left = offset + cur_size + 1;
    int right = offset + cur_size * 2 + 1;
    if (left >= n)
        left = 0;
    if (right >= n)
        right = 0;
    nodes.push_back({val, left, right});
}

void print_all() {
    for (auto a : nodes)
        cout << a.a << ' ' << a.b << ' ' << a.c << endl;
}

void print_negative() {
    cout << -1 << endl;
    exit(0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int a, b;
    cin >> a >> b;

    n = a + b;
    int cur_offset = 0;

    for (int i = 0; i < n; ++i) {
        if (cur_size - cur_offset - 1 < b)
            print_node(2, i);
        else
            print_node(1, i);
        if (++cur_offset == cur_size) {
            b -= cur_size;
            int rem = n - i -1 ;
            if (cur_size * 2 > rem && b > 0)
                print_negative();
            cur_offset = 0;
            cur_size *= 2;
        }
    }
    print_all();

    return 0;
}