#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

const int MAXN = 300000;

int dp[MAXN + 5];
int quant = 0;
int value[MAXN + 5];
pair <int, int> answer[MAXN + 5];

void recalc(int w, int A, int B)
{
	quant++;
	int num = quant;
	if (w == 1)
	{
	 	value[num] = 1;
	 	return;
	}

	int var1 = w - 1;
	int lef1 = var1 / 2;
	int rig1 = var1 - lef1;
	if (dp[lef1] + dp[rig1] >= B)
	{
	 	value[num] = 1;
	 	int Blef = min(B, dp[lef1]);
	 	int Alef = lef1 - 2 * Blef;
	 	int Brig = B - Blef;
	 	int Arig = rig1 - 2 * Brig;
	 		
	 	if (lef1 != 0)
	 	{
	 		answer[num].x = quant + 1;
	 		recalc(lef1, Alef, Blef);
	 	}
	 	if (rig1 != 0)
	 	{
	 		answer[num].y = quant + 1;
	 		recalc(rig1, Arig, Brig);
	 	}
	 	return;
	}

	int var2 = w - 2;
	int lef2 = var2 / 2;
	int rig2 = var2 - lef2;
	value[num] = 2;
	int Blef = min(B - 1, dp[lef2]);
	int Alef = lef2 - 2 * Blef;
	int Brig = B - 1 - Blef;
	int Arig = rig2 - 2 * Brig;

	if (lef2 != 0)
	{
		answer[num].x = quant + 1;
		recalc(lef2, Alef, Blef);
	}
	if (rig2 != 0)
	{
		answer[num].y = quant + 1;
		recalc(rig2, Arig, Brig);
	}
	return;
}

int main()
{
 	//freopen("input.txt", "r", stdin);
 	//freopen("output.txt", "w", stdout);
 	ios_base::sync_with_stdio(0); cin.tie(0);

 	dp[1] = 0, dp[2] = 1;
 	for (int i = 3; i <= MAXN; i++)
 	{
 	 	for (int j = 1; j <= 2; j++)
 	 	{
 	 	 	int w = i - j;
 	 	 	int lef = w / 2;
 	 	 	int rig = w - lef;
 	 	 	dp[i] = max(dp[i], dp[lef] + dp[rig] + (j == 2));
 	 	}
 	}

 	int A, B;
 	cin >> A >> B;
 	int W = A + 2 * B;
 	if (dp[W] < B) cout << "-1\n", exit(0);

 	recalc(W, A, B);
 	for (int i = 1; i <= quant; i++) cout << value[i] << ' ' << answer[i].x << ' ' << answer[i].y << '\n';
 	return 0;
}
