﻿/*
X⣿⣷⡁⢆⠈⠕⢕⢂⢕⢂⢕⢂⢔⢂⢕⢄⠂⣂⠂⠆⢂⢕⢂⢕⢂⢕⢂⢕⢂
X⣿⣿⡷⠊⡢⡹⣦⡑⢂⢕⢂⢕⢂⢕⢂⠕⠔⠌⠝⠛⠶⠶⢶⣦⣄⢂⢕⢂⢕
X⣿⠏⣠⣾⣦⡐⢌⢿⣷⣦⣅⡑⠕⠡⠐⢿⠿⣛⠟⠛⠛⠛⠛⠡⢷⡈⢂⢕⢂
X⣡⣾⣿⣿⣿⣿⣦⣑⠝⢿⣿⣿⣿⣿⣿⡵⢁⣤⣶⣶⣿⢿⢿⢿⡟⢻⣤⢑⢂
X⣿⣿⡿⢟⣛⣻⣿⣿⣿⣦⣬⣙⣻⣿⣿⣷⣿⣿⢟⢝⢕⢕⢕⢕⢽⣿⣿⣷⣔
X⣿⠵⠚⠉⢀⣀⣀⣈⣿⣿⣿⣿⣿⣿⣿⣿⣿⣗⢕⢕⢕⢕⢕⢕⣽⣿⣿⣿⣿
X⣂⣠⣴⣾⡿⡿⡻⡻⣿⣿⣴⣿⣿⣿⣿⣿⣿⣷⣵⣵⣵⣷⣿⣿⣿⣿⣿⣿⡿
X⠻⣿⡿⡫⡪⡪⡪⡪⣺⣿⣿⣿⣿⣿⠿⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠃
X⡁⠹⡪⡪⡪⡪⣪⣾⣿⣿⣿⣿⠋⠐⢉⢍⢄⢌⠻⣿⣿⣿⣿⣿⣿⣿⣿⠏⠈
X⡘⢄⠙⣾⣾⣾⣿⣿⣿⣿⣿⣿⡀⢐⢕⢕⢕⢕⢕⡘⣿⣿⣿⣿⣿⣿⠏⠠⠈
X⢊⢂⢣⠹⣿⣿⣿⣿⣿⣿⣿⣿⣧⢐⢕⢕⢕⢕⢕⢅⣿⣿⣿⣿⡿⢋⢜⠠⠈
X⠁⠕⢝⡢⠈⠻⣿⣿⣿⣿⣿⣿⣿⣷⣕⣑⣑⣑⣵⣿⣿⣿⡿⢋⢔⢕⣿⠠⠈
X⡂⡀⢑⢕⡅⠂⠄⠉⠛⠻⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⡿⢋⢔⢕⢕⣿⣿⠠
*/

#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const ll mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

const ll P = 1e9 + 7;
const ll Q = 150001;

mt19937 rng(228);

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int A, B;
	cin >> A >> B;

	if (A == 0 && B % 2 == 0) {
		cout << -1 << endl;
	}
	else {
		vector<pair<int, int>> tree;
		vector<int> labels;

		if (A == 0) {
			tree.pb(mp(-1, -1));
			labels.pb(2);

			while (sz(tree) < B) {
				tree.back() = mp(sz(tree), sz(tree) + 1);
				tree.pb(mp(-1, -1));
				tree.pb(mp(-1, -1));
				labels.pb(2);
				labels.pb(2);
			}
		}
		else {
			if (B == 0) {
				tree.pb(mp(-1, -1));
				labels.pb(1);

				while (sz(tree) < A) {
					tree.back() = mp(sz(tree), -1);
					tree.pb(mp(-1, -1));
					labels.pb(1);
				}
			}
			else if (B % 2 == 0) {
				tree.pb(mp(1, -1));
				tree.pb(mp(-1, -1));
				labels.pb(2);
				labels.pb(2);

				while (sz(tree) < B) {
					tree.back() = mp(sz(tree), sz(tree) + 1);
					tree.pb(mp(-1, -1));
					tree.pb(mp(-1, -1));
					labels.pb(2);
					labels.pb(2);
				}

				if (A > 0) {
					tree[0].second = sz(tree);
					tree.pb(mp(-1, -1));
					labels.pb(1);

					while (sz(tree) < A + B) {
						tree.back() = mp(sz(tree), -1);
						tree.pb(mp(-1, -1));
						labels.pb(1);
					}
				}
			}
			else if (A > 1) {
				tree.pb(mp(1, -1));
				tree.pb(mp(-1, -1));
				labels.pb(1);
				labels.pb(2);

				while (sz(tree) < B + 1) {
					tree.back() = mp(sz(tree), sz(tree) + 1);
					tree.pb(mp(-1, -1));
					tree.pb(mp(-1, -1));
					labels.pb(2);
					labels.pb(2);
				}

				if (A > 1) {
					tree[0].second = sz(tree);
					tree.pb(mp(-1, -1));
					labels.pb(1);

					while (sz(tree) < A + B) {
						tree.back() = mp(sz(tree), -1);
						tree.pb(mp(-1, -1));
						labels.pb(1);
					}
				}
			}
			else {
				tree.pb(mp(-1, -1));
				labels.pb(2);

				while (sz(tree) < B) {
					tree.back() = mp(sz(tree), sz(tree) + 1);
					tree.pb(mp(-1, -1));
					tree.pb(mp(-1, -1));
					labels.pb(2);
					labels.pb(2);
				}

				tree.back().first = sz(tree);
				tree.pb(mp(-1, -1));
				labels.pb(1);
			}
		}

		for (int i = 0; i < sz(tree); i++) {
			cout << labels[i] << ' ' << tree[i].first + 1 << ' ' << tree[i].second + 1 << endl;
		}
	}
}