#ifdef ONPC
    #define _GLIBCXX_DEBUG
    #define deb(a) cerr << "========" << #a << " = " << a << endl;
#else
    #define deb(a)
#endif
#define sz(a) ((int)((a).size()))
#include <bits/stdc++.h>
#define char unsigned char

using namespace std;
mt19937 rnd(239);
// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

const int N = 612345;
const int INF = 1e9 + 7;

int lc[N], rc[N], x[N];
int L[N], R[N];

pair<int, int> dfs(int v) {
    if (v == -1) {
        return {INF, -INF};
    }
    L[v] = R[v] = x[v];
    auto le = dfs(lc[v]);
    auto ri = dfs(rc[v]);
    L[v] = min(L[v], min(le.first, ri.first));
    R[v] = max(R[v], max(le.second, ri.second));
    return {L[v], R[v]};
}

int ql[N], qr[N];
int ans[N];

vector<pair<int, int>> q[N];
vector<pair<int, int>> verts[N];

int solve()
{
    int n;
    if (!(cin >> n))
        return 1;
    set<int> vals;
    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        lc[i] = a;
        rc[i] = b;
        x[i] = c;
        vals.insert(c);
    }
    int qq;
    cin >> qq;
    for (int i = 0; i < qq; i++) {
        int le, ri;
        cin >> le >> ri;
        vals.insert(le);
        vals.insert(ri);
        ql[i] = le;
        qr[i] = ri;
    }
    map<int, int> mapa;
    int curcnt = 0;
    for (int i : vals) {
        mapa[i] = curcnt++;
    }
    for (int i = 0; i < n; i++) {
        x[i] = mapa[x[i]];
    }
    for (int i = 0; i < qq; i++) {
        ql[i] = mapa[ql[i]];
        qr[i] = mapa[qr[i]];
    }
    dfs(0);
    for (int i = 0; i < qq; i++) {
        q[ql[i]].push_back({-1, i});
        q[qr[i]].push_back({1, i});
    }
    for (int i = 0; i < n; i++) {
        verts[L[i]].push_back({-1, i});
        verts[R[i]].push_back({1, i});
    }
    vector<int> st;
    for (int i = 0; i < curcnt; i++) {
        for (auto [tp, ind] : q[i]) {
            if (tp == -1) {
                ans[ind] += sz(st);
            }
        }
        for (auto [tp, ind] : verts[i]) {
            if (tp == -1) {
                st.push_back(i);
            } else {
                st.pop_back();
            }
        }
        for (auto [tp, ind] : q[i]) {
            if (tp == 1) {
                int curL = ql[ind];
                int curR = qr[ind];
                int posL = lower_bound(st.begin(), st.end(), curL) - st.begin();
                int posR = upper_bound(st.begin(), st.end(), curR) - st.begin();
                ans[ind] += posR - posL;
            }
        }
    }
    for (int i = 0; i < qq; i++) {
        cout << ans[i] * 2 + 1 << ' ';
    }
    cout << endl;
    return 1;
}

int32_t main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int TET = 1e9;
    //cin >> TET;
    for (int i = 1; i <= TET; i++)
    {
        if (solve())
            break;
        cout << '\n';
        #ifdef ONPC
            cout << "\n__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
