#include <bits/stdc++.h>

using namespace std;

const int maxN = 21;
int par[maxN];
vector<int> ch[maxN];

vector<int> solve(int v);

vector<int> solve_ch(int v, int i) {
    if (ch[v].size() == i) return {};
    auto res1 = solve(ch[v][i]);
    auto res2 = solve_ch(v, i + 1);

    vector<int> ans = res2;
    for (int i = 0; i < res1.size(); i++) {
        reverse(res2.begin(), res2.end());
        ans.push_back(res1[i]);
        ans.insert(ans.end(), res2.begin(), res2.end());
    }

    return ans;
}

vector<int> solve(int v) {
    vector<int> ans = solve_ch(v, 0);
    ans.insert(ans.begin(), v);
    return ans;
}

int main() {
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    for (int i = 1; i < n; i++) {
        cin >> par[i];
        par[i]--;
        ch[par[i]].push_back(i);
    }

    auto ans = solve(0);
    ans.erase(ans.begin());
    cout << ans.size() << endl;
    for (int x : ans) cout << x + 1 << " ";

    return 0;
}
