#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>
#include <cassert>

using namespace std;

const int MAXN = 2e5 + 10;

vector <int> kek[MAXN];
vector <int> gr[MAXN];

int dp[MAXN];

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	
	ios_base::sync_with_stdio(false);
	
	int n; cin >> n;
	
	for (int i = 0; i < n; i++) {
		int k; cin >> k;
		for (int j = 0; j < k; j++) {
			int a; cin >> a;
			a--;
			kek[a].push_back(i);
		}
	}
	
	for (int i = 0; i < MAXN; i++) {
		for (int j = 1; j < (int)kek[i].size(); j++) {
			gr[kek[i][j]].push_back(kek[i][j - 1]);
		}
	}
	dp[0] = 1;
	int res = 1;
	for (int i = 1; i < MAXN; i++) {
		dp[i] = 1;
		for (int from : gr[i])
			dp[i] = max(dp[i], dp[from] + 1);
		res = max(res, dp[i]);
	}
	
	cout << res << endl;
	
	
	return 0;
}
