#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

const int N = 500500;
vector<int> color(N);
vector<int> sum(N);

void add(int x, int toAdd) {
  if (!color[x]) {
    sum[x] = color[x] = toAdd;
    return;
  }
  if (sum[x * 2] <= sum[x * 2 + 1]) {
    add(x * 2, toAdd);
  } else {
    add(x * 2 + 1, toAdd);
  }
  sum[x] = sum[x * 2] + sum[x * 2 + 1] + color[x];
}

int counter = 0;

vector<tuple<int, int, int>> ans(N);

int print(int x) {
  if (!color[x]) {
    return 0;
  }
  if (abs(sum[x * 2] - sum[x * 2 + 1]) > 1) {
    cout << "-1";
    exit(0);
  }
  int myNum = ++counter;
  ans[myNum] = {color[x], print(x * 2), print(x * 2 + 1)};
  return myNum;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int a, b;
  cin >> a >> b;
  for (int i = 0; i < b; i++) {
    add(1, 2);
  }
  for (int i = 0; i < a; i++) {
    add(1, 1);
  }
  print(1);
  for (int i = 1; i <= counter; i++) {
    auto [a, b, c] = ans[i];
    cout << a << " " << b << " " << c << "\n";
  }
}
