#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int maxN = 20;

vector<int> g[maxN];

void push_all(vector<int> &v, vector<int> r) {
  for (int e : r) {
    v.push_back(e);
  }
}

vector<int> get_order_from_red(int v, int i) { 
  vector<int> ans;
  if (g[v].size() == 0) {
    return ans;
  }
  if (i == g[v].size() - 1) {
    ans.push_back(g[v][i]);
    push_all(ans, get_order_from_red(g[v][i], 0));
    return ans;
  }
  auto next = get_order_from_red(v, i + 1);
  vector<int> cur;
  cur.push_back(g[v][i]);
  push_all(cur, get_order_from_red(g[v][i], 0));
  push_all(ans, next);
  for (int e : cur) {
    ans.push_back(e);
    reverse(next.begin(), next.end());
    push_all(ans, next);
  }
  return ans;
}

int main() {
  int n;
  cin >> n;
  for (int i = 1; i < n; i++) {
    int p;
    cin >> p;
    p--;
    g[p].push_back(i);
  }
  auto ans = get_order_from_red(0, 0);
  cout << ans.size() << "\n";
  for (int e : ans) {
    cout << e + 1 << " ";
  }
}
