from math import gcd, ceil

def gcdC(a, b, x, y):
    if a == 0:
        return b, 0, 1
    d, x1, y1 = gcdC(b % a, a, x, y)
    x = y1 - (b // a) * x1
    y = x1
    return d, x, y

def sol(a, b, c):
    g, x0, y0 = gcdC(a, b, 0, 0)
    x0 *= c / g
    y0 *= c / g
    """
    if (x0 < 0):
        x0 *= -1
    if (y0 < 0):
        y0 *= -1
    """

    return x0, y0

def main():
    n = int(input())
    for _ in range(n):
        b, d = (int(k) for k in input().split())

        g = int(gcd(b, d))

        if b == 1 or d >= b**2:
            print(0)
            continue

        if d == b or d == 1 or b**2 % g != 0:
            print(b - 1)
            continue
        k = 0

        c0 = sol(b, d, b**2)[0]
        #print('c0', c0)
        mul = d / g

        c0 = c0 % mul
        if c0 == 0:
            c0 += mul
        #print('c0', c0)
        a0 = ((b**2) - b * c0) // d

        #print(d * a0 + b * c0, b**2)

        if d * a0 + b * c0 > b**2:
            a0 -= mul

        #print('a0', a0)
        mul = b / g

        print(ceil(a0 / mul))

        '''
        for a in range(1, int((b ** 2 - b) / d) + 1):
            c = (b ** 2 - a * d) // b
            if b * c + a * d == b * b:
                k = ceil(c / mul)
                break
        print(k)
        '''

main()