#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;
vector<vector<int> > prec;

struct G {
    int root;
    vector<int> sg;
    vector<int> ans;
    G(){}
    G(int x){root=x;}
    void add(int subg){sg.push_back(subg);}
};

vector<G> vc;

void solvesub1(vector<int>& sbs, vector<int>& vans, int ind){
    if (ind == sbs.size())
        return;
    for (int i: vc[sbs[ind]].ans){
        solvesub1(sbs, vans, ind+1);
        vans.push_back(i);
    }
    solvesub1(sbs, vans, ind+1);
}

int n;

void solvesub(vector<bool>& q, vector<int>& vans, int nxt){
    vector<int> sbs;
    if (q[nxt-1])
        sbs.push_back(nxt);
    for (int i=0;i<q.size();i++)
        if (q[i]){
            if (i+1 != nxt)
                sbs.push_back(i+1);
        }
    solvesub1(sbs, vans, 0);
}

void solveg(int r){
    for (int subg: vc[r].sg)
        solveg(subg);
    vector<bool> q(n);
    for (int i=0;i+1<prec[vc[r].sg.size()].size();++i){
        int sgind1 = prec[vc[r].sg.size()][i+1];
        int sw1 = vc[vc[r].sg[sgind1-1]].root;
        int sgind = prec[vc[r].sg.size()][i];
        int sw = vc[vc[r].sg[sgind-1]].root;
        vc[r].ans.push_back(sw);
        q[sw-1] = q[sw-1] ^ true;
        solvesub(q, vc[r].ans, sw1);
    }
}

void solve(int test_ind){
    cin >> n;
    vc = vector<G>(n+1);
    vc[1] = G(1);
    vector<vector<int>> v(n+1);
    for(int i=2;i<=n;++i){
        int x;
        cin >> x;
        v[x].push_back(i);
    }
    
    prec = vector<vector<int> > (n+1);
    prec[0].push_back(0);
    for (int i=1;i<=n;++i){
        for (int j: prec[i-1])
            prec[i].push_back(j+1);
        prec[i].pop_back();
        prec[i].push_back(1);
        for (int j: prec[i-1])
            prec[i].push_back(j+1);
        prec[i].pop_back();
        prec[i].push_back(1);
    }

    vector<int> q(1, 1);
    for (int i=1;i<=n;i++){
        int x = q.back();
        q.pop_back();
        for (int j=0;j<v[x].size();j++){
            q.push_back(v[x][j]);
            vc[v[x][j]] = G(v[x][j]);
            vc[x].add(v[x][j]);
        }
        sort(vc[x].sg.begin(), vc[x].sg.end());
    }
    solveg(1);
    cout << (vc[1].ans).size() << endl;
    for (int i: (vc[1].ans)){
        cout << i << " ";
    }
    cout << endl;
    return;
}

int main(){
	int t=1;
	//cin >> t;
	for(int i=0;i<t;i++){
		solve(i);
	}
	return 0;
}
