#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1e5 + 7;

bool used[N];
vector <int> f[N];
vector <int> g[N];

int ans = 0;

void dfs(int v, int x) {
    ans = max(ans, x);
    if (used[v]) return;
    used[v] = true;
    for (auto to : g[v]) {
        dfs(to, x + 1);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            f[x].push_back(i);
        }
    }
    for (int i = 0; i < N; i++) {
        for (int j = 0; j + 1 < f[i].size(); j++) {
            g[f[i][j]].push_back(f[i][j + 1]);
        }
    }
    for (int i = 0; i < N; i++) {
        if (!used[i]) {
            dfs(i, 1);
        }
    }
    cout << ans << endl;
    return 0;
}
