#!/usr/bin/env python3

n = int(input())
tree = {}
tree[1] = {'v': [], 'c': True}
for i, j in zip([int(x) for x in input().split(' ')], range(1, n + 1)):
    tree[j+1] = {'v': [], 'c': False}
    tree[i]['v'].append(j+1)

masks = [False] * (2 ** 20 + 100)
def get():
    res = 0
    for i in tree:
        if tree[i]['c']:
            res |= 1 << (i-1)
    return res

def hype(pos):
    tree[pos]['c'] = not tree[pos]['c']
    res = get()
    tree[pos]['c'] = not tree[pos]['c']
    return res

def check(pos):
    res = True
    for c in tree[pos]['v']:
        res = res and not tree[c]['c'] and check(c)
    return res

masks[get()] = True
# for i in tree:
#     print(f'{i}: {tree[i]}')
changes = []

def f(pos):
    if pos != 1:
        if not tree[pos]['c'] and not masks[hype(pos)]:
            tree[pos]['c'] = True
            changes.append(pos)
            return 1
        elif tree[pos]['c'] and not masks[hype(pos)] and check(pos):
            tree[pos]['c'] = False
            changes.append(pos)
            return 1

    if tree[pos]['c']:
        for c in tree[pos]['v']:
            res = f(c)
            if res == 1:
                return 1
    return 0

while True:
    res = f(1)
    if res == 0:
        break
    masks[get()] = True

print(len(changes))
print(*changes, sep=' ')