#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <unordered_map>
#include <queue>
#include <cstring>
#include <iomanip>

using namespace std;

int main() {
    int a, b;
    cin >> a >> b;

    if (a + b < 2) {
        cout << "-1\n";
        return 0;
    }

    if (a && (a - 1 + b * 2) % 2) {
        int sum = a - 1 + b * 2;
        a--;
        int part1 = sum / 2;
        int part2 = sum / 2 + 1;
        vector<int> parts1, parts2;
        while (part1) {
            if (b > 0 && part1 >= 2) {
                part1 -= 2;
                b--;
                parts1.push_back(2);
            } else if (a > 0) {
                part1 -= 1;
                a--;
                parts1.push_back(1);
            }
        }

        while (part2) {
            if (b > 0 && part2 >= 2) {
                part2 -= 2;
                b--;
                parts2.push_back(2);
            } else if (a > 0) {
                part2 -= 1;
                a--;
                parts2.push_back(1);
            }
        }

        int index = 1;
        if (!parts1.empty()) {
            cout << "1 " << index + 1 << " " << index + 1 + parts1.size() << endl;
        } else {
            cout << "1 0 " << index + 1 << endl;
        }

        index++;
        for (int i = 0; i < parts1.size(); i++) {
            int part = parts1[i];
            cout << part << " " << (i == parts1.size() - 1 ? 0 : index + 1) << " 0\n";
            index++;
        }
        for (int i = 0; i < parts2.size(); i++) {
            int part = parts2[i];
            cout << part << " " << (i == parts2.size() - 1 ? 0 : index + 1) << " 0\n";
            index++;
        }
    } else if (b && (a + b * 2 - 2) % 2) {
        int sum = a + b * 2 - 2;
        b--;
        int part1 = sum / 2;
        int part2 = sum / 2 + 1;
        vector<int> parts1, parts2;
        while (part1) {
            if (b > 0 && part1 >= 2) {
                part1 -= 2;
                b--;
                parts1.push_back(2);
            } else if (a > 0) {
                part1 -= 1;
                a--;
                parts1.push_back(1);
            }
        }

        while (part2) {
            if (b > 0 && part2 >= 2) {
                part2 -= 2;
                b--;
                parts2.push_back(2);
            } else if (a > 0) {
                part2 -= 1;
                a--;
                parts2.push_back(1);
            }
        }

        int index = 1;
        if (!parts1.empty()) {
            cout << "1 " << index + 1 << " " << index + 1 + parts1.size() << endl;
        } else {
            cout << "1 0 " << index + 1 << endl;
        }

        index++;
        for (int i = 0; i < parts1.size(); i++) {
            int part = parts1[i];
            cout << part << " " << (i == parts1.size() - 1 ? 0 : index + 1) << " 0\n";
            index++;
        }
        for (int i = 0; i < parts2.size(); i++) {
            int part = parts2[i];
            cout << part << " " << (i == parts2.size() - 1 ? 0 : index + 1) << " 0\n";
            index++;
        }
    } else {
        cout << "-1\n";
    }
}