import java.io.*;
import java.util.StringTokenizer;

public class E {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(System.out));
        StringTokenizer tk;
        int n = Integer.parseInt(br.readLine());

        for (int i = 0; i < n; i++) {
            tk = new StringTokenizer(br.readLine());
            int b = Integer.parseInt( tk.nextToken());
            int d = Integer.parseInt( tk.nextToken());

            int counter = 0;

            int gcdBD = gcd(b, d);
            int nominator = d / gcdBD; // * a
            int denominator = b / gcdBD;

            for (int a = denominator; a * nominator / denominator >= 1 && a * nominator / denominator <= b - 1; a+=denominator) {
                counter++;
            }
            bw.write(counter + "\n");
        }
        bw.flush();
    }

    public static int gcd(int a, int b) {
        if (b == 0)
            return a;
        return gcd(b,a % b);
    }
}
