import sys

def mygcd(a, b):
    if a == 0:
        return (0, 1, b)
    else:
        x1, y1, g = mygcd(b % a, a)
        x = y1 - (b // a) * x1
        y = x1
        return (x, y, g)

def solve(b, d):
    x, y, g = mygcd(d, b)
    r2 = b * b
    if (r2 % g):
        return 0

    mul = b * b // g
    x *= mul
    y *= mul

    a = d
    stepx = b // g
    stepy = a // g

    if (x <= 0):
        need = 1 + (-x) // stepx;
        x += need * stepx;
        y -= need * stepy;
    
    if (x > stepx):
        need = (x - 1) // stepx;
        x -= need * stepx;
        y += need * stepy;
    
    if (y <= 0):
        need = 1 + (-y) // stepy;
        x -= need * stepx;
        y += need * stepy;


    if (x <= 0):
        return 0
    else:
        res = (y - 1) // stepy;
        return res + 1;

n = int(sys.stdin.readline())
for line in sys.stdin:
    b, d = map(int, line.split())
    print(solve(b, d))
