#include <bits\stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using uint = unsigned int;
using ld = long double;

long long x, y, d;

void extendedEuclid(long long a, long long b) {
    if (b == 0) {
        x = 1;
        y = 0;
        d = a;
        return;
    }
    extendedEuclid(b, a % b);
    long long x1 = y;
    long long y1 = x - (a / b) * y;
    x = x1;
    y = y1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        ll a, b;
        cin >> a >> b;
        extendedEuclid(b, a);
        x *= (a*a) / d;
        y *= (a*a) / d;
        ll left = -x / (a / d);
        ll right = y / (b / d);
        if (x + (a/d)*right <= 0 || y - (b/d)*right <= 0) --right;
        if (x + (a/d)*left <= 0 || y - (b/d)*left <= 0) ++left;
        cout << right-left+1 << '\n';
    }
    return 0;
}
