#include<bits/stdc++.h>

using namespace std;
struct bin{
    int L;
    int R;
    int val;

    bool operator<(const bin &a) const{
        return val < a.val;
    }
};
set<pair<int, int> > q;
bin arr[200002];
int par[20][200002], val[20][200002], lv[200002], mn[200002], mx[200002];

void dfs(int idx, int l){
    lv[idx] = l;
    mn[idx] = arr[idx].val;
    mx[idx] = arr[idx].val;
    if(arr[idx].L) {
        dfs(arr[idx].L, l+1);
        mn[idx] = min(mn[idx], mn[arr[idx].L]);
        mx[idx] = max(arr[idx].val, mx[arr[idx].L]);
    }
    if(arr[idx].R) {
        dfs(arr[idx].R, l+1);
        mn[idx] = min(mn[idx], mn[arr[idx].R]);
        mx[idx] = max(arr[idx].val, mx[arr[idx].R]);
    }
}

int lca(int a, int b){

    if(lv[a] > lv[b]) {
        swap(a, b);
    }

    for(int i = 18; i >= 0 && lv[a] < lv[b]; i --){
        if((1 << i) <= lv[b] - lv[a]){
            b = par[i][b];
        }
    }
    if(a == b) return a;

    for(int i = 18; i >= 0; i --){
        if(par[i][a] != par[i][b]) {
            a = par[i][a];
            b = par[i][b];
        }
    }

    return par[0][a];

}

int get(int a, int b, int lf, int rg){
    for(int i = 18; i >= 0; i --) {
        //cout << mn[par[i][a]] << " " << mx[par[i][a]] << " " << lf << " " << rg << "\n";
        if(par[i][a] && mn[par[i][a]] >= lf && mx[par[i][a]] <= rg) {
            a = par[i][a];

        }
    }
    if(mn[a] >= lf && mx[a] <= rg) {
        a = par[0][a];
    }
    //cout << a << " " << b << endl;
    return 2 * (lv[a] - lv[b]);
}
main() {
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    for(int i = 1; i <= n; i ++){
        cin >> arr[i].L >> arr[i].R >> arr[i].val;
        q.insert({arr[i].val, i});
        if(arr[i].L) par[0][arr[i].L] = i;
        if(arr[i].R) par[0][arr[i].R] = i;
        val[0][i] = 2;
    }
    dfs(1, 1);
    for(int i = 1; i < 19; i ++){
        for(int a = 1; a <= n; a ++){
            par[i][a] = par[i-1][par[i-1][a]];
            val[i][a] = val[i-1][a] + val[i-1][par[i-1][a]];
        }
    }

    int m;
    cin >> m;

    for(int i = 0; i < m; i ++){
        int a,s, a0, s0;
        cin >> a >> s;
        a0=a;
        s0=s;
        if(a > (q.rbegin())->first || s < q.begin()->first) {
            cout << 1 << endl;
            continue;
        }

        a = q.lower_bound({a, -1})->second;
        s = (--q.lower_bound({s, 100000000}))->second;
        int l = lca(a, s);

        int ans = 2*lv[l];
        if(mn[l] == arr[a].val && mx[l] == arr[s].val) {
            cout << ans - 1 << endl;
            continue;
        }//cout <<">>" << a << " " << s << " "<< l <<" "<< ans << endl;
        if(arr[a].val <= arr[s].val){
            ans += get(a, l, a0, s0);
            ans += get(s, l, a0, s0);
        }

        cout << ans+1 << endl;
    }
}
