#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

void solve() {
    int n;
    cin >> n;
    vector<string>stairs(n);
    for (int i = 0; i < n; i++)
        cin >> stairs[i];
    vector<vector<int>>g(n);
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= 8; j++) {
            if (i + j >= n)
                continue;
            int x = 0;
            for (int k = 0; k < 8; k++) {
                if (stairs[i][k] == stairs[i + j][k])
                    x++;
            }
            if (j <= x) {
                g[i].push_back(i + j);
                g[i + j].push_back(i);
            }
        }
    }
    /*cout << "tree" << endl;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++)
            cout << g[i][j] << " ";
        cout << endl;
    }*/
    vector<int>used(n);        //1 - loose, 2 - win
    used[n - 1] = 1;
    for (int i = n - 1; i >= 0; i--) {
        if (!used[i]) {
            used[i] = 1;
        }
        if (used[i] == 1) {
            for (int j = 0; j < g[i].size(); j++) {
                if(!used[g[i][j]])
                    used[g[i][j]] = 2;
            }
        }
    }
    /*for (int i = 0; i < n; i++)
        cout << used[i];*/
    for (int i = 1; i < n; i++) {
        bool f = 0;
        for (int j = 0; j < g[i].size(); j++) {
            if (g[i][j] == 1) {
                cout << 1;
                f = 1;
                break;
            }
        }
        if (!f)
            cout << 2;
    }
    cout << 1;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i)
        solve();
    return 0;
}