#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <cmath>

#define ll long long

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    ll n;
    cin >> n;
    vector< pair <ll, vector<ll> > > mm = vector<pair<ll, vector<ll>>>();
    for (ll i = 0; i < n; i++) {
        ll a;
        cin >> a;
        vector<ll> newV = vector<ll>(0, 0);
        for (int j = 0; j < a; j++) {
            ll k;
            cin >> k;
            newV.push_back(k);
        }
        mm.emplace_back(a, newV);
    }
    reverse(mm.begin(), mm.end());

    vector<ll> prev = vector<ll>(100000, 0);

    ll ans = 1;

    for (ll i = 0; i < n; i++) {
        int f = mm[i].first;
        vector<ll> d = mm[i].second;

        bool flag = false;
        ll maxX = 0;
        for (ll j = 0; j < f; j++) {
            prev[d[j]]++;
            maxX = max(maxX, prev[d[j]]);
        }

        for (ll j = 0; j < f; j++) {
            prev[d[j]] = maxX;
        }
        ans = max(maxX, ans);
    }

    cout << ans;
    return 0;
}