#include<bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;
const char *yes = "YES", *no = "NO";

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    T el;
    if(v.size() == 0) {
        while(in >> el) {
            v.push_back(el);
        }
    } else {
        for(auto& x : v) {
            in >> x;
        }
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T> v) {
    for(const auto& x : v) out << x << ' ';
    return out;
}

int mod(const int& num, const int& module) {
    return ((num % module) + module) % module;
}

inline void solve() {
    int n; cin >> n;
    int pans = 1e7, indexans = 0;
    for(int i = 0; i < n; ++i) {
        int p; cin >> p;
        string digits; cin >> digits;
        map<int, int> mp;
        for(auto& x : digits) {
            mp[x - '0']++;
        }
        if(mp[2] >= 2 and mp[0] and mp[1] and pans > p) {
            pans = p;
            indexans = i + 1;
        }
    }
    cout << indexans;    
}   

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;// cin >> t;
    while(t--) {
        solve();
        cout << '\n';
    }
}