#include <iostream>

using namespace std;

#define NO (2000000000)

struct {
	int left;
	int right;
	long key;
} tree[200500];

struct {
	long min;
	long max;
} mm[200500];

int fun(int v, long L, long R) {
	if (v == 0) {
		return 1;
	}
		
	if (L <= mm[v].min and mm[v].max <= R) {
		return 1;
	}
	
	if (mm[v].max < L or R < mm[v].min) {
		return 1;
	}
		
	int res = 1;
	
	res += fun(tree[v].left, L, R);
	res += fun(tree[v].right, L, R);
	
	return res;
}

void funmm(int v) {
	long min, max;
	
	if (tree[v].left == 0) {
		min = tree[v].key;
	} else {
		if (mm[tree[v].left].min == NO) {
			funmm(tree[v].left);
		}
		
		min = mm[tree[v].left].min;
	}
	
	if (tree[v].right == 0) {
		max = tree[v].key;
	} else {
		if (mm[tree[v].right].max == NO) {
			funmm(tree[v].right);
		}
		
		max = mm[tree[v].right].max;
	}
	
	mm[v].min = min;
	mm[v].max = max;
}

int main() {
	int n;
	
	cin >> n;
	
	for (int i = 1; i < n + 1; ++i) {
		cin >> tree[i].left >> tree[i].right >> tree[i].key;
		mm[i].min = NO;
		mm[i].max = NO;
	}
	
	funmm(1);
	
	int q;
	
	cin >> q;
	
	for (int i = 0; i < q; ++i) {
		long L, R;
		
		cin >> L >> R;
		cout << fun(1, L, R) << endl;
	}

	return 0;
}
