x0, y0, g, = 0, 0, 0

def gcd(a, b):
	global x0, y0
	if a == 0:
		x0, y0 = 0, 1
		return b
	d = gcd(b % a, a)
	x0, y0 = y0 - (b // a) * x0, x0
	return d
	
def find_any_solution(a, b, c):
	global x0, y0, g
	g = gcd(abs(a), abs(b))
	if c % g != 0:
		return False
	x0 *= c // g
	y0 *= c // g
	if a < 0:
		x0 *= -1
	if b < 0:
		y0 *= -1
	return True

def shift_solution(x, y, a, b, cnt):
	x += cnt * b
	y -= cnt * a
	return (x, y)
	
def find_all_solutions(a, b, c, minx, maxx, miny, maxy):
	global g
	if not find_any_solution(a, b, c):
		return 0
	a //= g
	b //= g
	
	sign_a = 1 if a > 0 else -1
	sign_b = 1 if b > 0 else -1
	x, y = x0, y0
	x, y = shift_solution(x, y, a, b, (minx - x) // b)
	if x < minx:
		x, y = shift_solution(x, y, a, b, sign_b)
	if x > maxx:
		return 0
	lx1 = x
	
	x, y = shift_solution(x, y, a, b, (maxx - x) // b)
	if x > maxx:
		x, y = shift_solution(x, y, a, b, -sign_b)
	rx1 = x
	
	x, y = shift_solution(x, y, a, b, -(miny - y) // a)
	if y < miny:
		x, y = shift_solution(x, y, a, b, -sign_a);
	if y > maxy:
		return 0
	lx2 = x
	
	x, y = shift_solution(x, y, a, b, - (maxy - y) // a)
	if y > maxy:
		x, y = shift_solution (x, y, a, b, sign_a)
	rx2 = x
 
	if lx2 > rx2:
		lx2, rx2 = rx2, lx2
	lx = max(lx1, lx2)
	rx = min(rx1, rx2)
	
	return (rx - lx) // abs(b) + 1
	
for _ in range(int(input())):
	b, d = map(int, input().split())
	print(find_all_solutions(b, d, b * b, 1, 10**18, 1, 10**18))
