#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <fstream>
#include <stack>
#include <cstring>
#include <math.h>
#include <queue>
#include <list>
#include <stdlib.h>

using namespace std;


typedef int intor;
#define int long long
#define ll long long
#define ld long double
#define vi vector<int>
#define vd vector<double>
#define pii pair<int,int>
#define pdd Pair<double, double>

#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()

#ifdef int
#define INF (1000ll*1000ll*1000ll*1000ll*1000ll*1000ll)
#else
#define INF (1000*1000*10)
#endif
#define LL_INF (1000ll*1000ll*1000ll*1000ll*1000ll*1000ll)
#define EPS 1e-10

#define NMAX (500ll)
#define MMAX (0x200)
#define MOD ((long long)1e9 +7ll)


vector<int> get_div(int val)
{
	vector<int> res;
	for (int i = 2; i * i < val; i++)
	{
		while (val % i == 0)
		{
			res.push_back(i);
			val /= i;
		}
	}
	if (val != 1) res.push_back(val);
	return res;
}

void solve(int test_id)
{
	int b, d;
	cin >> b >> d;
	if (b % d == 0)
	{
		cout << b << endl;
		return;
	}
	vector<int> divs = get_div(d);
	int b0 = b;
	int ost = 1;
	for (int cur : divs)
	{
		if (b % cur == 0)
		{
			b /= cur;
		}
		else
		{
			ost *= cur;
		}
	}

	int ans = b0 / ost;
	if (b0 % ost == 0)ans -= 1;
	cout << max(ans, 0ll) << endl;
	return;
}

intor main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.precision(10);
	
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		solve(i);
	}
	
	
	return 0;
}

/*
2 3 3 2
.**
**.
*/