#include <iostream>
#include <cstdio>
#include <string>
#include <cstdlib>
#include <set>
#include <utility>
#include <vector>
#include <list>
#include <algorithm>
#include <regex>
#include <cmath>
#include <map>
#include <iterator>
#include <climits>
#include <numeric>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <queue>
#include <deque>
#include <stack>
#include <array>
#include <valarray>
#include <complex>
#include <random>
#include <functional>
#include <cassert>
#include <chrono>
#include <memory>

using namespace std;

#define int long long
//region TEMPLATE
////@formatter:off
typedef long long ll;
typedef unsigned long long ull;
template<typename T>void __read(T&a){cin >> a;}
template<typename T,typename ... Args>void __read(T&a,Args&... args){cin >> a;__read(args...);}
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(a, n) VI a(n); for(auto&v:(a)) cin >> v;
#define ALL(x) (x).begin(), (x).end()
#define RALL(x) (x).rbegin(), (x).rend()
typedef vector<int> VI;
typedef vector<vector<int>> VVI;
typedef pair<int, int> PII;
constexpr ll M7 = 1000000007;
constexpr ll M9 = 1000000009;
constexpr ll MFFT = 998244353;
constexpr double PI = 3.14159265358979323846;
template<class T> void outv(const T&a,char d=' ', bool nl=false){for(auto&x:a)cout<<x<<d;if(nl)cout<<'\n';}
static mt19937_64 rnd(static_cast<unsigned>(chrono::steady_clock::now().time_since_epoch().count())); // NOLINT(cert-err58-cpp)
auto __fast_io__=(ios_base::sync_with_stdio(false),cin.tie(nullptr)); // NOLINT(cert-err58-cpp,cppcoreguidelines-interfaces-global-init)
////@formatter:on
//endregion


int32_t main() {
    make(int, n);
    vector<string> a(n);
    for (auto &s : a) {
        cin >> s;
    }
    vector<char> win(n);
    for (int i = 0; i < n; ++i) {
        vector<char> pos(8, 0);
        for (int j = 1; j <= pos.size(); ++j) {
            if (i - j < 0) break;
            int cnt = 0;
            for (int k = 0; k < 8; ++k) {
                if (a[i][k] == a[i - j][k]) {
                    cnt++;
                }
            }
            if (cnt >= j) {
                pos[j - 1] = 1;
            }
        }
        int cntLose = 0;
        for (int j = 1; j <= 8; ++j) {
            if (i - j < 0) break;
            if (pos[j - 1] == 1 && win[i - j] == 0) {
                cntLose++;
            }
        }
        if (cntLose > 0) {
            win[i] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << (win[i] ? 1 : 2);
    }

    return 0;
}