#include <bits/stdc++.h>
#include <random>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef double ld;
//#define ll __int128
#define int ll
//#define char ll
//#define double ld
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;
typedef pair<int, int> pii;
typedef pair<pii, pii> piii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<pii> vpi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<short> vs;
typedef vector<vs> vvs;
typedef vector<vvs> vvvs;
typedef vector<ll> vl;
typedef vector<vl> vvl;
typedef vector<vvl> vvvl;
typedef vector<ld> vld;
typedef vector<vld> vvld;
typedef vector<vvld> vvvld;
typedef vector<string> vst;
typedef vector<vst> vvst;
typedef pair<ld, ld> pld;

#define inmin(a, b) a = min(a, (b))
#define inmax(a, b) a = max(a, (b))
#define ALL(a) a.begin(),a.end()
#define RALL(a) a.rbegin(),a.rend()
#define sqr(x) ((x) * (x))
#define fori(i, n) for(int i = 0; i < int(n); ++i)
#define SZ(a) ((int)((a).size()))
#define triple(T) tuple<T, T, T>
#define quad(T) tuple<T, T, T, T>
#define watch(x) cerr << (#x) << " = " << (x) << endl;

#ifdef MAX_HOME
#define cerr cout
#else
#define cerr if (false) cerr
#endif

const double PI = 2 * acos(0.0);
//#define rand shittttty_shit
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng_64(chrono::steady_clock::now().time_since_epoch().count());

const string DIGITS = "0123456789";
const string ALPH = "abcdefghijklmnopqrstuvwxyz";


template<class T0, class T1>
inline ostream &operator<<(ostream &out, pair<T0, T1> &a) {
    return out << "{" << a.first << ", " << a.second << "}";
}

template<class T0, class T1>
inline istream &operator>>(istream &in, pair<T0, T1> &a) {
    return in >> a.first >> a.second;
}

template<class T0, class T1, class T2>
inline ostream &operator<<(ostream &out, tuple<T0, T1, T2> &a) {
    return out << "{" << get<0>(a) << ", " << get<1>(a) << ", " << get<2>(a) << "}";
}

template<class T0, class T1, class T2, class T3>
inline ostream &operator<<(ostream &out, tuple<T0, T1, T2, T3> &a) {
    return out << "{" << get<0>(a) << ", " << get<1>(a) << ", " << get<2>(a) << ", " << get<3>(a) << "}";
}

template<class T>
inline ostream &operator<<(ostream &out, vector<T> &a) {
    out << "[";
    fori (i, a.size())out << a[i] << vector<string>{", ", "]  "}[i + 1 == a.size()];
    return out;
}


void smain();


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef MAX_HOME
    freopen("input.txt", "r", stdin);
    clock_t start = clock();
#else
    //        freopen("grass.in", "r", stdin);
//        freopen("grass.out", "w", stdout);
#endif
#ifdef HK_CUP
    freopen("finput.txt", "r", stdin);
    freopen("output.txt", "g", stdout);
#endif

    cout << setprecision(12) << fixed;
    smain();
#ifdef MAX_HOME
#ifndef HK_CUP
    cout << "\n\nTOTAL EXECUTION TIME: " << float(clock() - start) / CLOCKS_PER_SEC << endl;
#endif
#endif
    return 0;
}

int gcd(int a, int b, int &x, int &y) {
    if (b == 0) {
        x = 1, y = 0;
        return a;
    }
    if (a == 0) {
        x = 0, y = 1;
        return b;
    }
    int cx, cy;
    int g = gcd(b, a % b, cx, cy);
    x = cy;
    y = cx - a / b * cy;
    return g;
}

int find_any_solution(int a, int b, int c, int &x, int &y) {
    int g = gcd(abs(a), abs(b), x, y);
    if (c % g) return -1;
    x *= c / g;
    y *= c / g;
    if (a < 0) x = -x;
    if (b < 0) y = -y;
    return g;
}

int find_xmin(int a, int b, int c, int &x, int &y) {
    int g = find_any_solution(a, b, c, x, y);
    if (g == -1) {
        return 0;
    }

    auto shift = [&](int k) -> void {
        x += b / g * k;
        y -= a / g * k;
    };
    if (x <= 0)
        shift((-x + 1 + (b / g) - 1) / (b / g));
    else
        shift(-((x - 1) / (b / g)));
    if (y <= 0)
        return 0;
    int ymin = y % (a / g);
    if (ymin == 0)
        ymin += (a / g);
    int ret = (y - ymin) / (a / g) + 1;
    if (ymin > y)
        ret = 0;
    return ret;
}


int solve(int b, int d) {
    int x, y;
    int ans = find_xmin(b, d, b * b, x, y);
    return ans;
}

int naive(int b, int d) {
    const int N = 1e4;
    int ans = 0;
    for (int x = 1; x <= N; ++x) {
        for (int y = 1; y <= N; ++y) {
            if (b * x + d * y == b * b)
                ans++;
        }
    }
    return ans;
}

void stress() {
    int cnt = -1;
    while (true) {
        if (++cnt % 20 == 0) {
            watch(cnt);
        }
        int b = 1 + rng() % 50;
        int d = 1 + rng() % 50;
        int sl = solve(b, d);
        int nv = naive(b, d);
        if (nv != sl) {
            cout << b << ' ' << d << endl;
            watch(nv);
            watch(sl);
            watch(cnt);
            exit(0);
        }
    }
}



void smain() {

//    stress();

    __int128 f = 102;
    
    int t;
    cin >> t;
    while (t--) {
        int b, d;
        cin >> b >> d;
        int ret = solve(b, d);
        cout << ret << '\n';
        watch(naive(b, d));
    }
}