#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <random>
#include <ctime>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
#include <numeric>
#include <limits>
#include <fstream>
#include <stack>
#include <unordered_set>
#include <sstream>
#include <array>
#include <chrono>
#include <unordered_map>
#include <cassert>

using namespace std;

typedef unsigned long long uli;
typedef long long li;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
//#define x first
//#define y second
#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0; i < int(n); ++i)
#define fore(i, l, r) for(int i = int(l); i < int(r); ++i)
#define forb(i, n) for(int i = int(n) - 1; i >= 0; --i)
#define left 2 * v + 1
#define right 2 * v + 2

const int INF = 1e9 + 1000;
const li INF64 = 1e18;

const int N = 5e5 + 1000;
const int MOD = 998244353;
const double EPS = 1E-9;
const double PI = acos(-1.);

li gcd(li a, li b) {
	return a == 0 ? b : gcd(b % a, a);
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	string file = "join";
	//ifstream cin(file + ".in");
	//ofstream cout(file + ".out");

	int n;
	cin >> n;

	int day = 1;
	map<int, int> d; //  ->    
	set<int> s;
	s.insert(1);

	forn(i, n) {
		int cur = 1;
		int m; cin >> m;
		vector<int> a(m);
		forn(j, m) {
			cin >> a[j];

			if (d.count(a[j]) != 0) {
				cur = max(cur, d[a[j]] + 1);
			}
			else d[a[j]] = 1;
		}

		auto it = s.lower_bound(cur);
		if (it != s.end()) cur = *it;
		else {
			s.insert(cur);
		}
		forn(j, m) d[a[j]] = cur;
		
	}

	cout << s.size();
}

