#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <set>
#include <cmath>
#include <iomanip>
#include <fstream>
#include <list>
#include <queue>
#include <deque>
#include <sstream>
#include <memory>
#include <stdint.h>
#include <functional>

typedef long long ll;

using namespace std;

const int INF = 1 << 30;
const ll LINF = 1ll << 60;
const int MOD = 1000000007;

vector<vector<int>> g(25);
vector<int> u(25);

vector<int> rec(int v, vector<int> & p_x, vector<int> & p_y) {
	vector<int> x = p_x, y = p_y, res;

	u[v] = 1;

	if (v != 1)
		res.push_back(v);

	res.insert(res.end(), p_y.begin(), p_y.end());

	for (auto& i : g[v]) {
		if (!u[i]) {
			auto t = rec(i, x, y);
			x.insert(x.end(), t.begin(), t.end());
			res.insert(res.end(), t.begin(), t.end());
			swap(p_x, p_y);
			y = x;
			reverse(y.begin(), y.end());
		}
	}

	return res;
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	for (int i = 2; i <= n; i++) {
		int r;
		cin >> r;
		g[i].push_back(r);
		g[r].push_back(i);
	}
	vector<int> x, y;
	vector<int> ans = rec(1, x, y);
	cout << ans.size() << '\n';
	for (auto& i : ans) {
		cout << i << ' ';
	}
	return 0;
}