#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 1000 + 228;

int n;
map<int, int> pr;
vector<int> g[MAX_N];
int dp[MAX_N];
bool used[MAX_N];

void dfs(int v) {
    used[v] = true;
    dp[v] = 1;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
        dp[v] = max(dp[v], dp[u] + 1);
    }
}

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        int sz;
        scanf("%d", &sz);
        for (int j = 0; j < sz; ++j) {
            int cur;
            scanf("%d", &cur);
            if (pr.find(cur) != pr.end()) {
                g[pr[cur]].push_back(i);
            }
            pr[cur] = i;
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
        ans = max(ans, dp[i]);
    }

    printf("%d\n", ans);

    return 0;
}

