// #pragma GCC optimize("Ofast,unroll-all-loops")
#include <bits/stdc++.h>
#define int long long
#define fi first
#define se second
#define pb push_back
#define len(x) (int)(x).size()
#define all(x) begin(x), end(x)
#define debug(x) cerr << #x << " = " << x << endl;
using namespace std;
typedef pair<int, int> pii;
// const int MOD = 1e9 + 9;
// const int p = 314227;
// const int MOD = 998244353;
typedef long double ld;
// const ld EPS = 1e-3;
// const ld EPS = 1e-8;
// const int MAXN = 2e5 + 10;
const int INF = 1e18;
// const int MAX = (1ll << 60);

bool cmin(int& a, int b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

bool cmax(int& a, int b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

struct Node {
	Node *l = 0, *r = 0;
	int push_val = 0;
	int val = 0;
};

// const int MAX_NODES = 1e7 + 10;
// Node nodes[MAX_NODES];
// int nptr = 0;

Node* new_node() {
	return new Node();
	// return &nodes[nptr++];
}

struct Segtree {
	int n = 1e9 + 10;
	Node* root = new_node();

	void push(Node* t, int l, int r) {
		if (t->push_val) {
			t->val += t->push_val * (r - l);
			if (r - l > 1) {
				t->l->push_val += t->push_val;
				t->r->push_val += t->push_val;
			}
			t->push_val = 0;
		}
	}

	void update(Node* t, int l, int r, int ql, int qr, int val) {
		if (!t->l)
			t->l = new_node();
		if (!t->r)
			t->r = new_node();
		push(t, l, r);
		if (l >= qr || r <= ql)
			return;
		if (ql <= l && r <= qr) {
			t->push_val += val;
			push(t, l, r);
			return;
		}
		int c = (l + r) / 2;
		update(t->l, l, c, ql, qr, val);
		update(t->r, c, r, ql, qr, val);
	}

	void upd(int ql, int qr, int val) {
		update(root, -n, n, ql, qr, val);
	}

	int query(Node* t, int l, int r, int i) {
		if (!t)
			return 0;
		if (l > i || r <= i)
			return 0;
		if (!t->l)
			t->l = new_node();
		if (!t->r)
			t->r = new_node();
		push(t, l, r);
		if (r - l == 1) {
			return t->val;
		}
		int c = (l + r) / 2;
		return query(t->l, l, c, i) + query(t->r, c, r, i);
	}

	int get(int i) {
		return query(root, -n, n, i);
	}
};

const int MAXN = 2e5 + 10;
int ans[MAXN];

void run() {
	int n;
	cin >> n;
	vector<int> ls(n), rs(n), ks(n);
	vector<int> p(n, -1);
	set<int> T;
	map<int, vector<pii>> add_act;
	for (int i = 0; i < n; ++i) {
		cin >> ls[i] >> rs[i] >> ks[i];
		--ls[i], --rs[i];
		if (ls[i] != -1) {
			p[ls[i]] = i;
		}
		if (rs[i] != -1) {
			p[rs[i]] = i;
		}
	}
	vector<int> mn(n, INF), mx(n, -INF);
	for (int i = n - 1; i >= 0; --i) {
		mn[i] = ks[i];
		if (ls[i] != -1)
			cmin(mn[i], mn[ls[i]]);
		if (rs[i] != -1)
			cmin(mn[i], mn[rs[i]]);

		mx[i] = ks[i];
		if (ls[i] != -1)
			cmax(mx[i], mx[ls[i]]);
		if (rs[i] != -1)
			cmax(mx[i], mx[rs[i]]);

		// int real_c = (int)(ls[i] != -1) + (int)(rs[i] != -1);
		int real_c = 2;
		add_act[mx[i]].pb({mn[i] + 1, -real_c});
		T.insert(mx[i]);

		// if (p[i] != -1) {
		// 	add_act[mn[i]].pb({mx[i] + 1, 1});

		// }
		
		// T.insert(mn[i]);



		// if (ls[i] == -1) {
			add_act[mn[i]].pb({mx[i] + 1, +1});
			T.insert(mn[i]);

			// add_act[mx[i]].pb({mn[i] + 1, -1});
			// T.insert(mx[i]);
		// }
		// if (rs[i] == -1) {
			add_act[mn[i]].pb({mx[i] + 1, +1});
			T.insert(mn[i]);

			// add_act[mx[i]].pb({mn[i] + 1, -1});
			// T.insert(mx[i]);
		// }
	}
	map<int, vector<pii>> act_query;
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int l, r;
		cin >> l >> r;
		// ++r;
		// if (l > mx[0] || r < mn[0]) {
		// 	ans[i] = 1;
		// } else {
			act_query[r].pb({l, i});
			T.insert(r);
		// }
	}
	Segtree st;
	for (auto t : T) {
		for (auto act : add_act[t]) {
			st.upd(-st.n, act.fi, act.se);
		}
		for (auto act : act_query[t]) {
			ans[act.se] = st.get(act.fi);
		}
	}
	for (int i = 0; i < q; ++i) {
		cout << ans[i] + 1 << '\n';
	}
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    // cout << setprecision(10) << fixed;
    run();
    return 0;
}
