#include <bits/stdc++.h>
#include <cinttypes>
using namespace std;

bool was[256];
int was_size{0};
vector<char> was_all;

using String = array<char, 16>;

inline void init(String& s)
{
        memset(s.data(), '\0', 16);
}

map<String, pair<vector<String>, int>> groups;
// group_sz, cnt

inline void validate(String& s) {
        int pos = strlen(s.data());
        memset(s.data() + pos, '\0', 16 - pos);
}

inline
pair<String, bool> normalize_s(String s)
{
        char used[256];
        int used_size{0};
        memset(used, 0, 256);
        char new_c = 'A';
        for (char& c : s) {
                if ('\0' == c)
                        break;
                if (was[c])
                        continue;
                if (!used[c]) {
                        while (was[new_c])
                                ++new_c;
                        used[c] = new_c++;
                        ++used_size;
                }
                c = used[c];
        }
        validate(s);
        return {s, was_size + used_size <= 10};
}

String a, b;

uint64_t to_int(String s, const int mapping[256]) {
        uint64_t x{0};
        for (char c : s) {
                if ('\0' == c)
                        break;
                x = x * 10 + mapping[c];
        }
        return x;
}

String to_s(uint64_t x) {
        String s;
        init(s);
        sprintf(s.data(), "%llu", (long long unsigned)x);
        return s;
}

volatile int ___;

inline void calc(const String& s)
{
         /*if ('9' ==  s[0] && '5' == s[1] && '6' == s[2] && '7' == s[3]
         && '1' == s[4] && '0' == s[5] && '8' == s[6]) {
                ++___;
        }*/
        int mapping[256];
        memset(mapping, -1, sizeof mapping);
        char rev_mapping[10];
        memset(rev_mapping, '\0', 10);
        auto it{was_all.begin()};
        for (char c : s) {
                if (!c) break;
                mapping[*it] = c - '0';
                rev_mapping[c - '0'] = *it;
                ++it;
        }
        auto ia{to_int(a, mapping)};
        auto ib{to_int(b, mapping)};
        auto ires = ia + ib;
        if (ires > 999'999'999'999'999)
                return;
        String res{to_s(ires)};
        char new_c{'A'};
        for (char& c : res) {
                if (!c) break;
                if (!rev_mapping[c - '0']) {
                        while (-1 != mapping[new_c])
                                ++new_c;
                        mapping[new_c] = c - '0';
                        rev_mapping[c - '0'] = new_c++;
                }
                c = rev_mapping[c - '0'];
        }
        ++groups[res].second;
}

int main()
{
        freopen("brainteaser2.in", "r", stdin);
        ios_base::sync_with_stdio(false);
        String s;
        cin >> a.data() >> b.data();
        validate(a);
        validate(b);
        for (char c : a) {
                if (!c) break;
                if (was[c])
                        continue;
                was[c] = true;
                was_all.push_back(c);
                ++was_size;
        }
        for (char c : b) {

                if (!c) break;
                if (was[c])
                        continue;
                was[c] = true;
                was_all.push_back(c);
                ++was_size;
        }
        int n;
        cin >> n;
        while (n--) {
                cin >> s.data();
                validate(s);
                auto [nn, ok] = normalize_s(s);
                if (ok)
                        groups[nn].first.push_back(s);
        }
        set<String> subst;
        String cur;
        init(cur);
        for (int i{0}; i < 10; ++i)
                cur[i] = '0' + i;
        int D = was_size;
        if (D > 10) {
                cout << "0\n";
                return 0;
        }
        do {
                auto tmp{cur};
                memset(tmp.data() + D, '\0', 16 - D);
                if (!subst.count(tmp)) {
                        subst.insert(tmp);
                        calc(tmp);
                }
        } while (next_permutation(cur.begin(), cur.begin() + 10));
        vector<string> ans;
        for (const auto& [key, group] : groups) {
                if (1 != group.second)
                        continue;
                for (const auto& word : group.first)
                        ans.emplace_back(word.data());
        }
        sort(ans.begin(), ans.end());
        cout << ans.size() << '\n';
        for (const auto& word : ans)
                cout << word << '\n';
}
