#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1000000000 + 500;

#define pb push_back
#define X first
#define Y second

vector<int> d;

void dfs(int v, vector<int>& dp, vector<pair<pair<int, int>, int>> gr, int pr = -1, int depth=0) {
    d[v] = depth;
    if (v == 0) {
        return;
    }
    if (v == 1) {
        dp[v] = 1;
    //    return;
    }
    int u = pr;
    if (v != 1) {
    if (gr[u].X.X == v) {
        if (gr[u].X.Y != 0) {
            dp[v] = dp[u] + 2;
        } else {
            dp[v] = dp[u] + 1;
        }
    } else {
        if (gr[u].X.X != 0) {
            dp[v] = dp[u] + 2;
        } else {
            dp[v] = dp[u] + 1;
        }
    }
    }
    if (gr[v].X.X != 0) {
        dfs(gr[v].X.X, dp, gr, v, depth + 1);
    }
    if (gr[v].X.Y != 0) {
        dfs(gr[v].X.Y, dp, gr, v, depth + 1);
    }
}

int lca(int v, int u, vector<vector<int>>& pr, vector<int>& d) {
    //cout << v << ' ' << u << endl;
    if (v == u) {
        return v;
    }
    if (d[v] > d[u]) {
        swap(v, u);
    }
    //cout << v << ' ' << u << endl;
    for (int i = 19; i >= 0; --i) {
        if (d[u] - (1 << i) >= d[v]) {
            u = pr[i][u];
        }
    }
    //cout << v << ' ' << u << endl;
    if (v == u) {
        return v;
    }
    for (int i = 19; i >= 0; --i) {
        if (pr[i][u] != pr[i][v]) {
            v = pr[i][v];
            u = pr[i][u];
        }
    }
    return pr[0][v];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    d.resize(n + 1);
    vector<pair<pair<int, int>, int>> gr(n + 1);
    vector<int> dp(n + 1);
    set<pair<int, int>> st, st1;
    vector<vector<int>> pr(20);
    pr[0].resize(n + 1);
    int min1 = 1e9 + 500;
    int max1 = -1e9 - 500;
    pr[0][1] = 1;
    for (int i = 1; i <= n; ++i) {
        cin >> gr[i].first.first >> gr[i].first.second >> gr[i].second;
        //--v[i].first.first;
        //--v[i].first.second;
        st.insert({gr[i].second, i});
        st1.insert({-gr[i].second, i});
        if (gr[i].first.first != 0) {
            pr[0][gr[i].first.first] = i;
        }
        if (gr[i].first.second != 0) {
            pr[0][gr[i].first.second] = i;
        }
        min1 = min(min1, gr[i].second);
        max1 = max(max1, gr[i].second);
    }
    dfs(1, dp, gr, -1, 0);
    for (int i = 1; i < 20; ++i) {
        pr[i].resize(n + 1);
        for (int j = 1; j <= n; ++j) {
            pr[i][j] = pr[i - 1][pr[i - 1][j]];
        }
    }
    // cout << lca(4, 2, pr, d) << endl;
    //cout << pr[0][4] << ' ' << pr[1][4] << endl;

    //for (int i = 1; i <= n; ++i) {
    //    cout << d[i] << ' ';
    //}
    //cout << endl;
    //cout << lca(4, 2, pr, d) << endl;
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        if (l > max1 || r < min1) {
            cout << 1 << "\n";
            continue;
        }
        if (l <= min1 && max1 <= r) {
            cout << 1 << "\n";
            continue;
        }
        auto it = st.upper_bound({r, INF}); // > r
        auto it1 = st1.upper_bound({-l, INF}); // < l
        auto it2 = st.lower_bound({l, -INF}); // >= l
        auto it3 = st1.lower_bound({-r, -INF}); // <= r
        if (it == st.end()) {
            int v = it1->second;
            int u = it2->second;
            cout << dp[lca(v, u, pr, d)] + 2 << "\n";
            continue;
        }
        if (it1 == st1.end()) {
            int v = it->second;
            int u = it3->second;
            cout << dp[lca(v, u, pr, d)] + 2 << "\n";
            continue;
        }
        int v = it->second;
        int u = it3->second;
        int v1 = it1->second;
        int u1 = it2->second;
        //cout << i << ' ' << v << ' ' << u << ' ' << v1 << ' ' << u1 << endl;
        int w = lca(v, u, pr, d);
        int w1 = lca(v1, u1, pr, d);
        int w2 = lca(w, w1, pr, d);
        //cout << w << ' ' << w1 << ' ' << w2 << endl;
        int ans = 0;
        if (w2 != w && w2 != w1) {
            ans += dp[w] + dp[w1] - dp[w2] + 4 - 2;
        } else {
            if (w == w2) {
                ans = dp[w] + 2;
            } else {
                ans = dp[w1] + 2;
            }
        }
        cout << ans << "\n";
    }

    //for (int i = 0; i )
}
