#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>

using namespace std;

vector<int> gr[25];

vector<int> merge(vector<int> a, vector<int> b) {
    vector<int> res;
    for (int i = 0; i <= b.size(); i++) {
        for (int j = 0; j < a.size(); j++) {
            res.push_back(a[j]);
        }
        reverse(a.begin(), a.end());
        if (i != b.size()) res.push_back(b[i]);
    }
    return res;
}

vector<int> gen(int v) {
    vector<int> res;
//    std::cerr << v << endl;

    for (auto to : gr[v]) {
//        gen(to);
//        std::cerr << res.size() << '\n';
        res = merge(gen(to), res);
//        std::cerr << res.size() << '\n';
    }

    reverse(res.begin(), res.end());
    res.push_back(v);
    reverse(res.begin(), res.end());
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef HOME
    freopen("in", "r", stdin);
#endif

    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        --p;
        gr[p].push_back(i);
    }

    auto ans = gen(0);

    cout << ans.size() - 1 << '\n';
    for (int i = 1; i < ans.size(); i++) {
        cout << ans[i] << ' ';
    }
    return 0;
}
