#include <stdio.h>
#include <bits/stdc++.h>

typedef long long ll;

#define fi first
#define se second

using namespace std;

const int N = 1e5 + 10;

map<int, vector<int> > p;

vector<int> g[N];

bool used[N];

int ans[N];

void dfs(int v) {
    used[v] = 1;
    ans[v] = 1;
    for (int to : g[v]) {
        if (!used[to]) {
            dfs(to);
            ans[v] = max(ans[v], ans[to] + 1);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "rt", stdin);
    freopen("output.txt", "wt", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int id;
            cin >> id;
            p[id].push_back(i);
        }
    }

    for (auto x : p) {
        for (int i = 0; i + 1 < x.se.size(); ++i) {
            g[x.se[i]].push_back(x.se[i + 1]);
        }
    }

    int res = 0;
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            dfs(i);
            res = max(res, ans[i]);
        }
    }

    cout << res;
    return 0;
}
