﻿#pragma comment(linker, "/STACK:9759095000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,abm,mmx,tune=native")
#include<vector>
#include<iostream>
#include<stack>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<string>
#include<tuple>
#include<bitset>
#include<queue>
#include<unordered_map>
#include<random>
#include<ctime>
//#define double long double
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
using namespace std;
long long gcd(long long i, long long j) {
    if (j == 0)return i;
    else return gcd(j, i % j);
}
template<typename T> inline T getint() {
    T val = 0;
    char c;

    bool neg = false;
    while ((c = getchar()) && !(c >= '0' && c <= '9')) {
        neg |= c == '-';
    }

    do {
        val = (val * 10) + c - '0';
    } while ((c = getchar()) && (c >= '0' && c <= '9'));

    return val * (neg ? -1 : 1);
}
const long long INF = 1e9;
const int mod = 1000000009;
const double eps = 1e-12, pi = acos(-1);
const int maxN = 200100, maxT = 100010;
vector<int>vertex;
vector<vector<int>>G;
vector<int>dp_min;
vector<int>dp_max;
vector<int>deep;
int p[20][maxN];
void dfs(int v) {
    dp_min[v] = dp_max[v] = vertex[v];
    for (auto x : G[v]) {
        deep[x] = deep[v] + 1;
        p[0][x] = v;
        dfs(x);
        dp_min[v] = min(dp_min[x], dp_min[v]);
        dp_max[v] = max(dp_max[x], dp_max[v]);
    }
}
int upper(int vertex, int l, int r) {
    for (int i = 19; i >= 0; --i) {
        if (p[i][vertex] == -1)continue;
        int n_v = p[i][vertex];
        if (l <= dp_min[n_v] && dp_max[n_v] <= r)vertex = n_v;
    }
    return vertex;
}
int ggo(int vertex, int len) {
    for (int i = 0; i < 20; ++i) {
        if ((len & (1 << i)) != 0) {
            vertex = p[i][vertex];
        }
    }
    return vertex;
}
int lca(int a, int b) {
    if (deep[b] > deep[a])swap(a, b);
    a = ggo(a, deep[a] - deep[b]);
    if (a == b)return a;
    for (int i = 19; i >= 0; --i) {
        if (p[i][a] == -1)continue;
        if (p[i][a] != p[i][b]) {
            a = p[i][a];
            b = p[i][b];
        }
    }
    return p[0][a];
}
int solve(int vl, int vr, int l, int r) {
    vl = upper(vl, l, r);
    vr = upper(vr, l, r);
    if (r < l) {
        return max(deep[vl], deep[vr]) * 2 + 1;
    }
    int vv = lca(vl, vr);
    int ans = (deep[vl] + deep[vr] - deep[vv]) * 2 + 1;
    if (vl != vv && vr != vv)ans -= 2;
    if (!(l <= dp_min[vl] && dp_max[vl] <= r))ans += 2;
    if (vl != vr) {
        vl = vr;
        if (!(l <= dp_min[vl] && dp_max[vl] <= r))ans += 2;
    }
    return ans;
}
int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    cout.precision(11);
#ifdef _MY
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    for (int j = 0; j < 20; ++j) {
        for (int i = 0; i < maxN; ++i) {
            p[j][i] = -1;
        }
    }
    vector<int>vals;
    vertex.assign(n, 0);
    dp_min.assign(n, 0);
    dp_max.assign(n, 0);
    deep.assign(n, 0);
    G.resize(n);
    map<int, int>mp;
    for (int i = 0; i < n; ++i) {
        ll a, b, c;
        cin >> a >> b >> c;
        mp[c] = i;
        vals.push_back(c);
        vertex[i] = c;
        if (a != 0)G[i].push_back(--a);
        if (b != 0)G[i].push_back(--b);
    }
    sort(vals.begin(), vals.end());
    dfs(0);
    for (int j = 1; j < 20; ++j) {
        for (int i = 0; i < maxN; ++i) {
            if (p[j - 1][i] != -1)
                p[j][i] = p[j - 1][p[j - 1][i]];
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;
        if (r<vals[0] || l>vals.back()) {
            cout << "1\n";
            continue;
        }
        l = vals[lower_bound(vals.begin(), vals.end(), l) - vals.begin()];
        r = vals[upper_bound(vals.begin(), vals.end(), r) - vals.begin() - 1];
        cout << solve(mp[l], mp[r], l, r) << "\n";
    }
}