#include <bits/stdc++.h>

typedef unsigned long long ull;
typedef long long ll;

using namespace std;

struct Node {
    int w;
    int c1;
    int c2;
};

vector<Node> ans;
int a, b;

int find_solution(int sum) {
    if (sum == 0) {
        return 0;
    } else if (sum == 1) {
        if (a > 0) {
            ans.push_back({1, 0, 0});
            --a;
            return ans.size();
        }
        return -1;
    } else if (sum == 2) {
        if (b > 0) {
            ans.push_back({2, 0, 0});
            --b;
            return ans.size();
        }
        size_t index = ans.size();
        ans.push_back({1, 0, 0});
        --a;
        --sum;
        int first = (sum + 1) / 2;
        int second = sum - first;
        int c1 = find_solution(first);
        int c2 = find_solution(second);
        ans[index].c1 = c1;
        ans[index].c2 = c2;
        if (ans[index].c1 == -1 || ans[index].c2 == -1) {
            return -1;
        }
        return index + 1;
    } else if (b > 0) {
        size_t index = ans.size();
        ans.push_back({2, 0, 0});
        --b;
        sum -= 2;
        int first = (sum + 1) / 2;
        int second = sum - first;
        int c1 = find_solution(first);
        int c2 = find_solution(second);
        ans[index].c1 = c1;
        ans[index].c2 = c2;
        if (ans[index].c1 == -1 || ans[index].c2 == -1) {
            return -1;
        }
        return index + 1;
    } else {
        size_t index = ans.size();
        ans.push_back({1, 0, 0});
        --a;
        --sum;
        int first = (sum + 1) / 2;
        int second = sum - first;
        int c1 = find_solution(first);
        int c2 = find_solution(second);
        ans[index].c1 = c1;
        ans[index].c2 = c2;
        if (ans[index].c1 == -1 || ans[index].c2 == -1) {
            return -1;
        }
        return index + 1;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> a >> b;
    if (find_solution(a + 2 * b) == -1) {
        cout << -1 << endl;
        return 0;
    }
    for (size_t i = 0; i < ans.size(); ++i) {
        cout << ans[i].w << " " << ans[i].c1 << " " << ans[i].c2 << endl;
    }
}
