#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;
  
#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define endl '\n'
#define x first
#define y second
#define int long long
#define double long double
#define pii pair<int, int>
#define pb push_back
#define vec vector
#define beg begin
#define dbg(x) cout << #x << " = " << x << endl;
  
template<class T> ostream& operator<<(ostream& str, const vector<T>& a) {
    for (auto &i : a) {
        str << i << " ";
    }
    return str;
}
  
template<class T> istream& operator>>(istream& str, vector<T>& a) {
    for (auto &i : a) {
        str >> i;
    }
    return str;
}
  
template<class T> ostream& operator<<(ostream& str, const pair<T, T>& a) {
    str << a.first << " " << a.second;
    return str;
}
  
template<class T> istream& operator>>(istream& str, pair<T, T>& a) {
    str >> a.first >> a.second;
    return str;
}
  
void solve(); signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cout.setf(ios::fixed); cout.precision(20);
    solve();
    return 0;
}
const int MAXN = 1e6 + 10, INF = 1e10 + 10;
vec<pii> sg;

struct node {   
    int left, right, key;
    int mx = -INF, mn = INF, cnt = 0;
} ns[MAXN];

void fill(int root) {
    if (root == 0) {
        return;
    }
    fill(ns[root].left);
    fill(ns[root].right);
    ns[root].mx = max(ns[root].key, ns[ns[root].right].mx);
    ns[root].mn = min(ns[root].key, ns[ns[root].left].mn);
    ns[root].cnt = 1 + ns[ns[root].left].cnt + ns[ns[root].right].cnt;
    sg.pb({ns[root].mn, ns[root].mx});
}

struct bit {
    vec<int> a;
    bit() {
        a.resize(MAXN);
    }
    void add(int i, int d) {
        while (i < MAXN) {
            a[i] += d;
            i = (i | (i + 1));
        }
    }
    int sum(int i) {
        int res = 0;
        while (i >= 0) {
            res += a[i];
            i = (i & (i + 1)) - 1;
        }
        return res;
    }
};

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> ns[i].left >> ns[i].right >> ns[i].key;
    }

    int q;
    cin >> q;
    vec<vec<int>> qs(q, vec<int>(3));
    for (int i = 0; i < q; ++i) {
        qs[i][2] = i;
        cin >> qs[i][0] >> qs[i][1];
    }
    sort(all(qs));

    fill(1);

    int T = 1;
    set<int> se;
    map<int, int> mp;
    for (auto it : sg) {
        se.insert(it.x);
        se.insert(it.y);
    }
    for (auto it : qs) {
        se.insert(it[0]);
        se.insert(it[1]);
    }
    for (auto it : se) {
        mp[it] = T++;
    }

    for (auto &it : sg) {
        it.x = mp[it.x];
        it.y = mp[it.y];
    }
    for (auto &it : qs) {
        it[0] = mp[it[0]];
        it[1] = mp[it[1]];
    }

    map<int, int> ans;
    bit t;
    
    vec<vec<pair<int, int>>> QL(MAXN);
    for (auto it : qs) {
        QL[it[0]].pb({it[1], it[2]});
    }
    vec<vec<int>> addL(MAXN);
    for (auto it : sg) {
        addL[it.x].pb(it.y);
    }

    for (int i = 1; i < MAXN; ++i) {
        for (auto Q : QL[i]) {
            ans[Q.y] += (t.sum(MAXN - 1) - t.sum(i - 1));
        }
        for (auto r : addL[i]) {
            t.add(r, 1);
        }
    }

    for (int i = 0; i < MAXN; ++i) {
        t.a[i] = 0;
    }

    vec<vec<pair<int, int>>> QR(MAXN);
    for (auto it : qs) {
        QR[it[1]].pb({it[0], it[2]});
    }
    vec<vec<int>> addR(MAXN);
    for (auto it : sg) {
        addR[it.y].pb(it.x);
    }

    for (int i = MAXN - 1; i >= 1; i--) {
        for (auto Q : QR[i]) {
            ans[Q.y] += (t.sum(i) - t.sum(Q.x - 1));
        }
        for (auto l : addR[i]) {
            t.add(l, 1);
        }
    }

    for (int i = 0; i < q; ++i) {
        cout << ans[i] * 2 + 1 << endl;
    }
}