#include <bits/stdc++.h>
using namespace std;

// definitions
using ld = long double;
using ll = long long;
using ull = unsigned long long;

// other
#define endl '\n'
#define fast_io              \
    ios::sync_with_stdio(0); \
    cin.tie(0);              \
    cout.tie(0)

ll mod(ll a, ll b)
{
    return ((a % b) + b) % b;
}

template <typename V = int32_t>
inline V extGcd(V a, V b, V &x, V &y)
{
    bool negativeA = false;
    if (a < 0) {
        negativeA = true;
        a = -a;
    }
    bool negativeB = false;
    if (b < 0) {
        negativeB = true;
        b = -b;
    }
    x = 1;
    y = 0;
    V xTmp = 0;
    V yTmp = 1;
    while (b) {
        V q = a / b;
        tie(x, xTmp) = make_tuple(xTmp, x - q * xTmp);
        tie(y, yTmp) = make_tuple(yTmp, y - q * yTmp);
        tie(a, b) = make_tuple(b, a - q * b);
    }
    if (negativeA) {
        x = -x;
    }
    if (negativeB) {
        y = -y;
    }
    return a;
}

inline long long linearDiophantineSolutionCount(
    long long a,
    long long b,
    const long long &c,
    long long xmin,
    long long xmax,
    long long ymin,
    long long ymax)
{
    if (xmin > xmax || ymin > ymax) {
        return 0;
    }
    long long xCount = xmax - xmin + 1;
    long long yCount = ymax - ymin + 1;
    if (!a && !b) {
        return c ? 0 : xCount * yCount;
    }
    if (!a) {
        if (c % b) {
            return 0;
        }
        long long y = c / b;
        return ymin <= y && y <= ymax ? xCount : 0;
    }
    if (!b) {
        if (c % a) {
            return 0;
        }
        long long x = c / a;
        return xmin <= x && x <= xmax ? yCount : 0;
    }
    bool negativeA = false;
    if (a < 0) {
        negativeA = true;
        a = -a;
    }
    bool negativeB = false;
    if (b < 0) {
        negativeB = true;
        b = -b;
    }
    long long x, y;
    long long gcd = extGcd(a, b, x, y);
    if (c % gcd) {
        return 0;
    }
    if (negativeA) {
        swap(xmin, xmax);
        xmin = -xmin;
        xmax = -xmax;
    }
    if (negativeB) {
        swap(ymin, ymax);
        ymin = -ymin;
        ymax = -ymax;
    }
    long long mul = c / gcd;
    x *= mul;
    y *= mul;
    long long dx = b / gcd, dy = a / gcd;
    auto shift = [&x, &y, &dx, &dy](const long long &delta) {
        x += delta * dx;
        y -= delta * dy;
    };
    if (x < xmin) {
        shift((xmin - x + dx - 1) / dx);
    }
    else {
        shift(-((x - xmin) / dx));
    }
    if (x > xmax || y < ymin) {
        return 0;
    }
    if (y > ymax) {
        shift((y - ymax + dy - 1) / dy);
    }
    if (xmax < x || y < ymin) {
        return 0;
    }
    return min((xmax - x) / dx, (y - ymin) / dy) + 1;
}

int main()
{
    fast_io;

    ll n, a, b, c, d, ans, x0, y0, g;

    cin >> n;
    while (n--) {
        cin >> b >> d;
        cout << linearDiophantineSolutionCount(d, b, b * b, 1, 1e18 - 1e9 + 1, 1, b) << endl;
        /* cout << (int)find_any_solution(d, b, b * b, x0, y0, g) << endl;
        cout << x0 << " " << y0 << " " << g << endl; 
        cout << "---\n";
        cout << (-floor(-1.0*g*y0/d)-floor(-1.0*g*x0/b) - 1) << endl; 
        continue;

        // 123123123 -
        ans = find_all_solutions(d, b, b * b, 1, 1e18 - 1e9 + 1, 1, b + 1);
        cout << ans << endl; */
    }
}

// 4536 * 674 -84888*36