#define _CRT_SECURE_NO_WARNINGS
//#pragma comment(linker,"/STACK:1000000000,1000000000")
#include <algorithm>
#include <deque>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <bitset>
#include <iomanip>
#include <complex>
#define sp << " "
#define sps << " " <<
#define ln << "\n"
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define optimise cin.sync_with_stdio(false); cout.sync_with_stdio(false); cin.tie(NULL);

using namespace std;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long ll;

template<class T>
istream& operator>> (istream& is, vector<T>& vec) { for (int i = 0; i < (int)vec.size(); ++i)is >> vec[i]; return is; }
template<class T>
ostream& operator<< (ostream& os, vector<T>& vec) { for (int i = 0; i < (int)vec.size(); ++i)os << vec[i] << " "; return os; }
template<class T>
istream& operator>> (istream& is, pair<T, T>& a) { is >> a.first >> a.second; return is; }

const double pi = acos(-1.0);
const ll mod = (int)1e9 + 9; /*1e9;*/ /*(1ll << 30);*/ /*998244353*/;
const ll INF = 2e18;
const int inf = (int)1e9 + 7;
const int maxlen = (int)1e5 + 100;
const double eps = 1e-7;
//------------------------
vector<vector<int>> child;
vector<int> parent;
vector<int> ans;
vector<int> tin;

void dfs(int x)
{
	tin[x]=ans.size();

	ans.push_back(x);
	for (int i = ans.size()-2; i > tin[parent[x]]; i--)
	{
		ans.push_back(ans[i]);
	}

	for (auto y : child[x])
	{
		dfs(y);
	}
}

void solve()
{
	int n;
	scanf("%d", &n);
	parent.resize(n + 1);
	child.resize(n + 1);
	tin.resize(n + 1);
	for (int i = 2; i <= n; i++)
	{
		int a;
		scanf("%d", &a);
		child[a].push_back(i);
		parent[i] = a;
	}

	dfs(1);
	printf("%d\n",ans.size()-1);
	for (int i = 1; i < ans.size(); i++)
		printf("%d ",ans[i]);
}



int main() {
	//optimise
#ifdef _DEBUG //__MINGW_DEBUGBREAK_IMPL
	freopen("input.txt", "r", stdin);
#else
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
#endif
	int T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
	return 0;
}