#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <functional>
#include <bitset>
#include <deque>
#include <cmath>
#include <queue>
#include <cstdlib>
#include <stdio.h>
#include <cassert>
#include <climits>
#include <ctime>
#include <algorithm>
#include <string>

using ld = long double;
using ll = long long;
using namespace std;

vector<int> ans;

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> next(n);
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		next[p - 1].push_back(i);
	}
	vector<int> ans;
	function<void(int, int)> f = [&](int cur, int prev) {
		ans.push_back(cur);
		if (prev >= 0) {
			for (int i = ans.size() - 2; i >= 0 && ans[i] != prev; --i) {
				ans.push_back(ans[i]);
			}
		}
		for (int v : next[cur]) {
			f(v, cur);
		}
	};
	f(0, -1);
	cout << ans.size() - 1 << endl;
	for (int i = 1; i < ans.size(); ++i) {
		cout << ans[i] << ' ';
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr);
	int t = 1;
	// cin >> t;
    while (t-- > 0) solve();
}