#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef double db;
typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

typedef pair < db, db > pdd;
typedef pair < db, ld > pdl;
typedef pair < ld, db > pld;
typedef pair < ld, ld > ldp;

typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;
typedef pair < int, int > pii;

#define F first
#define S second

#define en end()
#define bg begin()

#define rev reverse
#define mp make_pair
#define pb push_back

#define y1 y1234567890
#define um unordered_map

#define all(x) x.bg, x.en
#define sz(x) (int)x.size()
#define len(x) (int)strlen(x)

#define sqr(x) ((x + 0ll) * (x))
#define sqrd(x) ((x + 0.0) * (x))

#define forn(i, n) for (int i = 1; i <= n; i++)

const ll inf = (ll)1e18;
const ll mod = (ll)1e9 + 7;

const db eps = (db)1e-9;
const db pi = acos(-1.0);

const int dx[] = {0, 0, 1, 0, -1};
const int dy[] = {0, 1, 0, -1, 0};

const int N = 100500;

int ptr, val[N], l[N], r[N];

bool ok;

void rec(int a, int b, int pr = -1, bool ch = 0) {
	if (!a && !b) return;
	if (!a) {
		cout << -1;
		exit(0);
	}
	ptr++;
	int cur = ptr;
	if (pr != -1) {
		if (ch)
			r[pr] = ptr;
		else
			l[pr] = ptr;
	}
	if (b) {
		val[ptr] = 2;
		if (b & 1) {
			rec(a / 2, b / 2, cur, 0);
			rec((a + 1) / 2, b / 2, cur, 1);
		}
		else {
			if (!(a & 1)) {
				rec(a / 2 - 1, b / 2, cur, 0);
				rec(a / 2 + 1, b / 2 - 1, cur, 1);
			}
			else {
				rec(a / 2, b / 2, cur, 0);
				rec(a / 2 + 1, b / 2 - 1, cur, 1);
			}
		}
	}
	else {
		val[ptr] = 1;
		rec(a / 2, b, cur, 0);
		rec((a - 1) / 2, b, cur, 1);
	}
}

int main() {
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	//freopen(".err", "w", stderr);

	//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);

	//cout << setprecision(10) << fixed;
	
	int a, b;
	cin >> a >> b;
	rec(a, b);
	assert(ptr == a + b);
	for (int i = 1; i <= ptr; i++)
		cout << val[i] << " " << l[i] << " " << r[i] << "\n";
	
	//cerr << (clock() + 0.0) / CLOCKS_PER_SEC;

	return 0;
}
