#include<bits/stdc++.h>
using namespace std;
int graph[400001] = {0};

int graph_sum(int cur){
    if(graph[cur] == 0){
        return 0;
    }
    int left = graph_sum(cur * 2);
    int right = graph_sum(cur * 2 + 1);

    if(left == -1 || right == -1){
        return -1;
    }

    if(abs(left - right) <= 1){
        return left + right + graph[cur];
    }else{
        return -1;
    }
}

int main(){
    int a, b;
    cin >> a >> b;
    vector<int> traverse;
    //Fill normally
    traverse.push_back(1);
    int cur = 0;

    int t_a = a, t_b = b;
    while(t_a > 0 || t_b > 0){
        if(t_b > 0){
            graph[traverse[cur]] = 2;
            t_b--;
        }else if(t_a > 0){
            graph[traverse[cur]] = 1;
            t_a--;
        }

        cur++;
        if(cur == traverse.size()){
            int sz = traverse.size();
            for(int i = 0; i < sz; i++){
                traverse[i] = traverse[i] * 2;
                traverse.push_back(traverse[i] + 1);
            }
            cur = 0;
        }
    }
    if(graph_sum(1) < 0){
        cout << -1;
        return 0;
    }

    unordered_map<int, int> hmap;
    int idx = 1;
    for(int i = 1; i <= (a + b) * 4; i++){
        if(graph[i] > 0){
            hmap[i] = idx;
            idx++;
        }
    }

    for(int i = 1; i <= (a + b) * 4; i++){
        if(graph[i] > 0){
            cout << graph[i] << " ";
            if(graph[i * 2] == 0){
                cout << 0 << " ";
            }else{
                cout << hmap[i * 2] << " ";
            }
            if(graph[i * 2 + 1] == 0){
                cout << 0 << endl;
            }else{
                cout << hmap[i * 2 + 1] << endl;
            }
        }
    }

    return 0;
}