#include <stack>
#include <string>
#include <bitset>
#include <unordered_map>
#include <cstdio>
#include <limits>
#include <vector>
#include <climits>
#include <cstring>
#include <cstdlib>
#include <fstream>
#include <numeric>
#include <sstream>
#include <cassert>
#include <iomanip>
#include <random>
#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <map>
#include <set>
#include <list>
#include <cmath>
#include <ctime>
#include <deque>
#include <queue>
#include <chrono>

#define all(x) (x).begin(),(x).end()
#define sz(x) (int)(x.size())
#define endl "\n"
#define int long long

using namespace std;

typedef long long ll;

const int N = (int)(5e5) + 322;
const int mod = (int)(1e9) + 7;
const int inf = (int)(1e18);

int w[N], l[N], r[N], timer;

int dfs(int a, int b) {
    if (!a && !b) return 0;
    int x = ++timer;
    if (b % 2 == 0) {
        if (!a) {
            cout << -1;
            exit(0);
        }
        w[x] = 1;
        a--;
    }else {
        w[x] = 2;
        b--;
    }
    assert(b % 2 == 0);
    if (!b && !a) return x;
    int La = a / 2;
    int Ra = a - La;
    l[x] = dfs(La, b / 2);
    r[x] = dfs(Ra, b / 2);
    return x;
}

void solve() {
    int a, b; cin >> a >> b;
    dfs(a, b);
    for(int i = 1; i <= timer; ++i) cout << w[i] << ' ' << l[i] << ' ' << r[i] << endl;

}

signed main () {
    ios_base::sync_with_stdio(false);cin.tie(0);
    int t = 1;
//    cin >> t;
    for(int tt = 0; tt < t; ++tt) {
        solve();
    }
    return 0;
}