#pragma region template
#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:65536000")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cmath>
using namespace std;

const double eps = 1e-9;
const double pi = 3.141592653589793238462643383279502884;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef pair<double, double> pdd;
typedef pair<string, string> pss;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define ff first
#define ss second

#define fi(n) for (int i = 0; i < (int)(n); ++i)
#define fir(l, r) for (int i = (int)(l); i < (int)(r); ++i)
#define fj(n) for (int j = 0; j < (int)(n); ++j)
#define fjr(l, r) for (int j = (int)(l); j < (int)(r); ++j)

#pragma endregion

bool DEBUG = true;

void solve() {
    int n;
    cin >> n;
    int best_ans = 1e9;
    int best_ind = -1;
    for (int i = 0; i < n; ++i) {
        string p;
        int money;
        cin >> money >> p;
        int two = 0, one = 0, zero = 0;
        for (char c : p) {
            if (c == '2')
                two++;
            if (c == '1')
                one++;
            if (c == '0')
                zero++;
        }
        if (two >= 2 && one >= 1 && zero >= 1) {
            if (best_ans > money) {
                best_ans = money;
                best_ind = i + 1;
            }
        }
    }
    cout << (best_ans == 1e9 ? 0 : best_ind);
}


int main()
{
    cin.sync_with_stdio(0);
    solve();
    return 0;
}
/*


*/