#pragma comment(linker, "/STACK:256777216")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <chrono>
#include <cmath>
#include <climits>
#include <ctime>
#include <random>
#include <iostream>
#include <cstdio>
#include <iomanip>
using namespace std;

#define forx(_name,_from, to, value) for (int name = from; name < to; name += value)
#define rforx(_name, from, to, value) for (int name = from; name > to; name -= _value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST,_SECOND) make_pair(_FIRST,_SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-9;
mt19937 rndm;

void start() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(9); cout.setf(ios::fixed);
	string FILENAME = "tickets";
	rndm.seed(time(0));
	cout << fixed << setprecision(9);
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	//freopen((FILENAME + ".in").c_str(), "rt", stdin);
	//freopen((FILENAME + ".out").c_str(), "wt", stdout);
#endif
}

const int MAX_N = 1e5 + 10;
const int MAX_M = 1e5;
const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;


void solve()
{
	int n;
	cin >> n;
	int min_c = INF, min_ind = -1;
	for (int i = 0; i < n; ++i) {
		int c;
		string s;
		cin >> c >> s;
		vector<int> cnt(10, 0);
		for (auto x : s) {
			cnt[x - '0']++;
		}
		if (cnt[2] >= 2 && cnt[0] >= 1 && cnt[1] >= 1 && c < min_c) {
			min_c = c;
			min_ind = i;
		}
	}
	cout << min_ind + 1;
}

void multitest()
{
	int t;
	cin >> t;
	while (t--)
		solve();
}

int main() {
	start();
	//multitest();
	solve();
	return 0;
}