#define F first
#define S second
 
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,mmx,abm,popcnt")
 
#include <bits/stdc++.h>
     
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef long double ld;
 
 
using namespace std;
 
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());


ll extgcd(ll a, ll b, ll& x, ll& y) {
    ll d;
    ll x1, y1;
    if (a == 0) {
        x = 0;
        y = 1;  
        return b;
    }
    d = extgcd(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    auto starttime = chrono::steady_clock::now();
#else
    // freopen("incredible.in", "r", stdin);
    // freopen("incredible.out", "w", stdout);
#endif
    ll a, b, d, x0, y0, x, y;
    int q;
    cin >> q;
    while(q--) {
        cin >> a >> b;
        d = a * a;
        ll gc = extgcd(a, b, x0, y0);
        if(d % gc != 0) {
            cout << 0 << '\n';
            continue;
        }
        d /= gc;
        x0 *= d;
        y0 *= d;
        if(x0 < 0) {
            swap(x0, y0);
            swap(a, b);
        }
        x = x0;
        y = y0;
        ll l = floor((ld)-x0 * gc / b);
        ll r = ceil((ld)y0 * gc / a) - 1;
        cout << r - l << '\n';
    }
#ifdef LOCAL
    auto endtime = chrono::steady_clock::now();
    printf("\n[Finished in %.3lfs]\n",1e-6*(ll)chrono::duration_cast
        <chrono::microseconds>(endtime-starttime).count());
#endif
    return 0;
}