#define _USE_MATH_DEFINES
#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<unordered_set>
#include<unordered_map>
#include<sstream>
#include<random>
#include<numeric>
#include <assert.h>

#pragma warning(disable : 4996)

#pragma comment(linker, "/STACK:16777216")

#define en "\n"
#define forn(i, n) for(int i = 0; i < n; i++)
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define pb push_back
#define pii pair<int, int>
#pragma warning(disable : 4996)
#define fst first
#define snd second
typedef long long ll;
typedef long double ld;

using namespace std;


template<typename T> void print(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
	{
		for (int j = 0; j < a[i].size(); j++)
			cout << a[i][j];
		cout << en;
	}
}

template <typename T> void input(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
		for (int j = 0; j < a[i].size(); j++)
			cin >> a[i][j];
}

const ll INF = 1e9 + 5;
const ll MOD = 1e9 + 7;
const int NMAX = 1e5 + 55;
double EPS = 1e-10;


struct node {
	int l = -1, r = -1;
	int w;
};


node tree[NMAX];
int cnt = 0;

int rec(int a, int b) {	
	if (a == 0 && b == 0) {
		return -1;
	}

	int node = cnt++;
	
	if (b % 2 == 0) {	
		if (a == 0) {
			cout << -1 << en;
			exit(0);
		}
		else {
			a--;
			tree[node].w = 1;
		}
	}
	else {
		tree[node].w = 2;
		b--;
	}

	if (b % 2 == 0) {
		if (a % 2 == 0) {		
			tree[node].l = rec(a / 2, b / 2);
			tree[node].r = rec(a / 2, b / 2);
		}
		else {
			if (abs((a / 2 + b / 2 * 2) - ((a / 2 + 1) + b / 2 * 2)) > 1) {
				cout << -1 << en;
				exit(0);
			}
			tree[node].l = rec(a / 2, b / 2);
			tree[node].r = rec(a / 2 + 1, b / 2);
		}
	}
	else {
		cout << -1 << en;
		exit(0);
	}

	return node;
}


void solve() {
	int a, b;
	cin >> a >> b;

	rec(a, b);

	forn(i, a + b) {
		cout << tree[i].w << " " << tree[i].l + 1 << " " << tree[i].r + 1 << en;
	}
}


int main() {
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(8);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}