#define _USE_MATH_DEFINES
#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<unordered_set>
#include<unordered_map>
#include<sstream>
#include<random>
#include<numeric>
#include <assert.h>

#pragma warning(disable : 4996)

#pragma comment(linker, "/STACK:16777216")

#define en "\n"
#define forn(i, n) for(int i = 0; i < n; i++)
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define pb push_back
#define pii pair<int, int>
#pragma warning(disable : 4996)
#define fst first
#define snd second
typedef long long ll;
typedef long double ld;

using namespace std;


template<typename T> void print(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
	{
		for (int j = 0; j < a[i].size(); j++)
			cout << a[i][j];
		cout << en;
	}
}

template <typename T> void input(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
		for (int j = 0; j < a[i].size(); j++)
			cin >> a[i][j];
}

const ll INF = 1e9 + 5;
const ll MOD = 1e9 + 7;
const int NMAX = 2e6;
double EPS = 1e-10;


int p[NMAX];
vector<int> g[NMAX];
bool used[NMAX];
int n;

bool is_good(int u, int mask, bool prev_color)
{
	bool cur_color = (mask & (1 << u));
	if (u == 0 && cur_color == 0) return false;
	if (prev_color == 0 && cur_color == 1)
		return false;

	for (int v : g[u])
	{
		bool is_ok = is_good(v, mask, cur_color);
		if (!is_ok)
			return false;
	}

	return true;
}

vector<int> ans;
int our_ans = 0;
void dfs(int mask) {
	if (used[mask] || !is_good(0, mask, 1)) {
		return;
	}
	used[mask] = true;

	if (ans.size() == our_ans) {
		cout << our_ans << en;
		for (auto to : ans) {
			cout << to << " ";
		}
		exit(0);
	}
	
	for (int j = 1; j < n; j++) {
		int next_mask = mask ^ (1 << j);
		ans.pb(j + 1);
		dfs(next_mask);
		ans.pop_back();
	}
	
	used[mask] = false;
}


void precalc_ans(int n) {
	for (int i = 1; i < (1 << n); i++) {
		if (is_good(0, i, 1))
			our_ans++;
	}
}

void solve() {
	//int n;
	cin >> n;
	forn(i, n - 1) {
		cin >> p[i + 1];
		g[p[i + 1] - 1].pb(i + 1);
	}

	precalc_ans(n);
	our_ans--;
	//cout << our_ans << en;
	//cout << is_good(0, 5, 1) << en;

    //used[1] = true;
	dfs(1);
	
}


int main() {
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(8);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}