#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <utility>
#include <map>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <cstring>
#include <sstream>
#include <cmath>


using namespace std;

//using pii = pair<long long>;
#define f first
#define s second
template <class X, class Y> pair<X,Y> operator + (pair<X,Y> a, pair<X,Y> b) {return {a.f + b.f, a.s + b.s};}
template <class X, class Y> pair<X,Y> operator - (pair<X,Y> a, pair<X,Y> b) {return {a.f - b.f, a.s - b.s};}
template <class X, class Y, class Z> pair<X,Y> operator * (pair<X,Y> a, Z b) {return {a.f * b, a.s * b};}
template <class X, class Y, class Z> pair<X,Y> operator / (pair<X,Y> a, Z b) {return {a.f / b, a.s / b};}

vector<int> _snm;
void init_snm(int n) { _snm.resize(n); for (int i =0; i < n; i++) { _snm[i] = i; } }
int par_snm(int a) { return _snm[a] == a ? a : _snm[a] = par_snm(_snm[a]); }
int uni_snm(int a, int b) { a = par_snm(a); b = par_snm(b); if (rand() & 1) swap(a, b); return _snm[a] = b; }

struct mdt {
    static const long long md = 1e9 + 7.5;
    long long x;
    mdt (long long a = 0) { x = a % md; }
    mdt pow(long long n) const { return n ? mdt(x*x).pow(n/2)*(n & 1 ? x : 1): 1; }
    mdt rev() const { return pow(md - 2); }
    friend mdt operator + (mdt a, mdt b) { return a.x + b.x; }
    friend mdt operator - (mdt a, mdt b) { return a.x - b.x + md; }
    friend mdt operator * (mdt a, mdt b) { return a.x * b.x; }
    friend mdt operator / (mdt a, mdt b) { return a * b.rev(); }
    mdt &operator += (mdt b) { return *this = *this + b; }
    mdt &operator -= (mdt b) { return *this = *this - b; }
    mdt &operator *= (mdt b) { return *this = *this * b; }
    mdt &operator /= (mdt b) { return *this = *this / b; }
    friend istream &operator >> (istream &a, mdt &b) { long long x; a >> x; b = x; return a; }
    friend ostream &operator << (ostream &a, mdt b) { return a << b.x; }
};

double calc_A(const int& begin, const int& end, const vector<int>& v, const vector<int>& sumMas){
    long sum = 0;
//    cout << "begin = " << begin<<endl;
    sum = sumMas[end-1] - ((begin != 1) ? sumMas[begin - 2] : 0);
//    for(int i = begin; i <= end; ++i){
//        sum += v[i] - v[i-1];
//    }

//    cout << "sum A = "<<sum<<endl;


    int N = end - begin + 1;
    if(sum == 0)
        return 0;
    return (double) (((double )sum )/ N);
}

double calc_D(const int& begin, const int& end, const vector<int>& v, const double& A, const vector<int>& sumMas,
        const vector<int>& sumMasUsual){
    double sum = 0;
    int N = end - begin + 1;

    sum = sumMas[end-1] - ((begin != 1) ? sumMas[begin - 2] : 0);
    long sumUsual = sumMasUsual[end-1] - ((begin != 1) ? sumMasUsual[begin - 2] : 0);
    sum = sum + N*A*A - 2 * A * sumUsual;

//    double test = 0;
//    for(int i = begin; i <= end; ++i){
//        //cout << "(v[i]-v[i-1]) = " << (v[i]-v[i-1])<<endl;
//        //cout << "A = " << A << endl;
//        test += ((v[i]-v[i-1]) - A) * ((v[i]-v[i-1]) - A);
//    }
//    cout << "test = " << test<<endl;

    // cout << " sum_D = " << sum<<endl;

    if(sum == 0)
        return 0;
    return sqrt(sum/N);
}

int main(){

    int N;
    string s;
    int price;

    cin >> N;

    int min = 100001;
    bool mask[4] = {false, false, false, false};
    int ans = 0;


    for(int i = 0; i < N; ++i){
        mask[0] = false; // 2
        mask[1] = false; // 0
        mask[2] = false; // 2
        mask[3] = false; // 1

        cin >> price;
        cin >> s;

        if(price < min){
            for(auto x : s){
                if(x == '0')
                    mask[1] = true;
                else if(x == '1')
                    mask[3] = true;
                else if(x == '2' && !mask[0])
                    mask[0] = true;
                else if(x == '2')
                    mask[2] = true;

            }

            if(mask[0] && mask[1] && mask[2] && mask[3]) {
                min = price;
                ans = i + 1;
            }
        }
    }

    cout << ans;
    

}