#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using namespace std;
using ld = long double;
using ll = int64_t;
using pii = pair<int, int>;
using ull = uint64_t;

int a[75], c[75][75], d[75][75];
int map_cdn[75];
int ans[75];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m, original_m;
    cin >> n >> m;
    original_m = m;

    for (int i = 0; i < n; ++i) {
        ans[i] = -1;
    }

    vector<pii> coord;
    for (int i = 0; i < m; ++i) {
        int x;
        cin >> x;
        coord.emplace_back(x, i);
    }
    sort(all(coord));
    m = 0;
    for (int i = 0; i < (int)coord.size(); ++i) {
        if (i > 0 && coord[i - 1].first != coord[i].first)
            ++m;
        map_cdn[coord[i].second] = m;
        a[m] = coord[i].first;
    }
    ++m;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < original_m; ++j) {
            int x;
            cin >> x;
            c[i][map_cdn[j]] += x;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> d[i][j];
        }
    }

    vector<int> candidates;
    for (int i = 0; i < n; ++i) {
        candidates.push_back(i);
    }
    for (int i = 0; i < m; ++i) {
        if (i == m - 1) {
            for (int x : candidates) {
                ans[x] = i;
            }
            candidates.clear();
        } else {
            vector<int> next_cand;
            vector<int> placed_cand;
            for (int x : candidates) {
                ll stay_here = 0;
                for (int j = i + 1; j < m; ++j)
                    stay_here += c[x][j] * ll(a[j] - a[i]);
                for (int y : next_cand)
                    stay_here += (ll)d[x][y] * abs(a[i + 1] - a[i]);

                ll go_farther = c[x][i] * ll(a[i + 1] - a[i]);
                for (int j = i + 2; j < m; ++j)
                    go_farther += c[x][j] * ll(a[j] - a[i]);
                for (int y : placed_cand)
                    go_farther += (ll)d[x][y] * abs(a[i + 1] - a[i]);

                if (stay_here < go_farther || (stay_here == go_farther && rand() % 4)) {
                    ans[x] = i;
                    placed_cand.push_back(x);
                } else {
                    next_cand.push_back(x);
                }
            }
            candidates = next_cand;
        }
    }

    // Validate
    for (int i = 0; i < n; ++i) {
        if (ans[i] < 0 || ans[i] >= m) {
            throw;
        }
    }

    ll ans_cost = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ans_cost += abs(a[ans[i]] - a[ans[j]]) * (ll)d[i][j];
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ans_cost += abs(a[ans[i]] - a[j]) * (ll)c[i][j];
        }
    }

    bool changed = true;
    while (changed) {
        changed = false;
        for (int i = n - 1; i >= 0; --i) {
            bool optimized_here = false;
            for (int new_ans = 0; new_ans < m; ++new_ans) {
                if (new_ans == ans[i]) continue;
                ll new_cost = ans_cost;
                for (int j = 0; j < n; ++j) {
                    if (i != j) {
                        new_cost -= abs(a[ans[i]] - a[ans[j]]) * (ll)d[i][j];
                        new_cost += abs(a[new_ans] - a[ans[j]]) * (ll)d[i][j];
                    }
                }
                for (int j = 0; j < m; ++j) {
                    new_cost -= abs(a[ans[i]] - a[j]) * (ll)c[i][j];
                    new_cost += abs(a[new_ans] - a[j]) * (ll)c[i][j];
                }
                if (new_cost < ans_cost) {
                    changed = true;
                    optimized_here = true;
                    ans_cost = new_cost;
                    ans[i] = new_ans;
                }
            }
        }
    }

    cout << ans_cost << endl;
    for (int i = 0; i < n; ++i)
        cout << a[ans[i]] << " ";
    cout << endl;
}
