#include <iostream>
#include <queue>

struct Person {
	int lastSeen;
};

int n;
int k;
Person p[100000];

std::queue<int> people;

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	for (int i = 0; i < 100000; i++) {
		p[i].lastSeen = 0;
	}
	
	std::cin >> n;

	int num = 0;

	for (int i = 0; i < n; i++) {
		std::cin >> k;
		int max = 0;
		for (int j = 0; j < k; j++) {
			int per;
			std::cin >> per;
			per--;
			if (p[per].lastSeen >= max) {
				max = p[per].lastSeen + 1;
			}
			people.push(per);
		}
		while (!people.empty()) {
			p[people.front()].lastSeen = max;
			people.pop();
		}
		if (max > num) {
			num = max;
		}
	}

	std::cout << num << std::endl;

	return 0;
}
