#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>

using namespace std;
struct node{
    int value;
    int lc;
    int rc;
    int childs;
    int vmax;
    int vmin;
    node(int v, int l, int r, int c=0)
    {
        value = v, lc = l, rc = r, childs = 0;
        vmax = -1e+9 -7;
        vmin = 1e+9 + 7;
    }
};

vector <node> tree;
int a;


int count_clilds(int v)
{
    if (tree[v].lc == 0 and tree[v].rc == 0)
    {
        tree[v].childs = 0;
        tree[v].vmax = tree[v].value;
        tree[v].vmin = tree[v].value;
        return 1;
    }
    int an = 0;
    if (tree[v].lc)
        an = count_clilds(tree[v].lc);
    if (tree[v].rc)
        an += count_clilds(tree[v].rc);
    tree[v].vmax = max(max(tree[tree[v].lc].vmax, tree[tree[v].rc].vmax), tree[v].value);
    tree[v].vmin = min(min(tree[tree[v].lc].vmin, tree[tree[v].lc].vmin), tree[v].value);
    tree[v].childs = an;
    return an+1;
}

int count_lookups(int v, int lb, int rb)
{
    int ans = 0;
    if (lb >= tree[v].vmin && lb <= tree[v].vmax)
    {
        ans+=1;
        ans+=count_lookups(tree[v].rc, lb, rb);
        ans+=count_lookups(tree[v].lc, lb, rb);
    }

    if (rb >= tree[v].vmin && rb <= tree[v].vmax)
    {
        ans+=1;
        ans+=count_lookups(tree[v].rc, lb, rb);
        ans+=count_lookups(tree[v].lc, lb, rb);
    }
    return ans;
}

int count_lookups2(int v, int lb, int rb)
{
    int ans = 0;
    if (lb <= tree[v].vmin && tree[v].vmax <= rb)
        return 0;
    if (tree[v].vmax < lb || rb < tree[v].vmin)
        return 0;

    ans+=count_lookups2(tree[v].lc, lb, rb);
    ans+=count_lookups2(tree[v].rc, lb, rb);
    return ans+=2;
}
int main()
{
    //freopen("input.txt", "r", stdin); //freopen("output.txt", "w", stdout);
	ios::sync_with_stdio(0);
	cin.tie(0);
    node asd(0,0,0);
    tree.push_back(asd);
    cin >> a;
    for (int i = 0; i < a; ++i)
    {
        int tml, tmr, tmv;
        cin >> tml >> tmr >> tmv;
        node tmp(tmv, tml, tmr);
        tree.push_back(tmp);
    }
    count_clilds(1);
    int n_tests;
    cin >> n_tests;
    for (int i = 0; i < n_tests; ++i)
    {
        int tlb, trb;
        cin >> tlb >> trb;
        cout << count_lookups2(1, tlb, trb) + 1 << endl;
    }
    return 0;
}