#include <iostream>
#include <cstdlib>
#include "set"
using namespace std;
#define cheat ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr)

set<int> couldBe;
long long answer = 1;
const int mod = 1000000000+7;
void addDivider(int x) {
    if(couldBe.find(x) != couldBe.end()) {
        couldBe.erase(x);
        answer*=x*x;
        answer%=mod;
    }
    else couldBe.insert(x);
}
void dividers(int x) {
    int safe = x;
    for (int i = 2; i*i <= safe; ++i) {
        while (safe%i==0) {
            addDivider(i);
            safe/=i;
        }
    }
    addDivider(safe);
}

int nod(int a, int b) {
    if(a*b==0) return a+b;
    if(a>b) return nod(b, a%b);
    return nod(a, b%a);
}

int solve(int b, int d) {
    int x = nod(d, b);
    int maxA = (b*b-b)/d;
    return (maxA)/(b/x);
}

int longSolve(int b, int d) {
    int ans =0;
    for (int a = 1; a <= (b*b-b)/d; ++a) {
        if((a*d)%b==0) ans++;
    }
    return ans;
}
int main() {
    cheat;
//    for (int b = 1; b < 10000; ++b) {
//        for (int d = 1; d < 10000; ++d) {
//            if(solve(b,d) != longSolve(b,d)) {
//                cout << b << ' ' << d <<endl;
//            }
//        }
//    }
    int n; cin >> n;
    while(n--) {
        int b,d; cin >> b >> d;
        cout << solve(b,d) << endl;
    }
    return 0;
}
