#include <iostream>
#include <cmath>
#include <algorithm>
#include <map>
#include <vector>

using namespace std;

vector<int> g[30];
int a[30];
int p[30];
map<vector<bool>, bool> m;
int n;
vector<int> ans;

void dfs(vector<bool> v) {
    if (m[v]) {
        return;
    }
    m[v] = true;
    for (int i = 2; i <= n; i++) {
        if (v[i] == false && v[p[i]] == true) {
            v[i] = !v[i];
            if (!m[v]) {
              ans.push_back(i);
              dfs(v);
              ans.push_back(i);
            }
            v[i] = !v[i];
            continue;
        }
        if (v[i] == false) {
            continue;
        }
        bool e = true;
        for (int j = 0; j < g[i].size(); j++) {
            int to = g[i][j];
            if (v[to]) {
                e = false;
                break;
            }
        }
        if (e) {
            v[i] = !v[i];
            if (!m[v]) {
              ans.push_back(i);
              dfs(v);
              ans.push_back(i);
            }
            v[i] = !v[i];
            continue;
        }
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n;

    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    a[1] = 1;
    vector<bool> v(n + 1);
    v[1] = 1;
    dfs(v);
    cout << ans.size() / 2 << "\n";
    for (int i = 0; i < ans.size() / 2; i++) {
        cout << ans[i] << " ";
    }

    return 0;
}
