#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second
 
using namespace std;
 
typedef long long ll;

const ll P = 17;
  
int last[30], value[30], revvalue[15], number[30];
bool used[30];
vector <int> answer;
string dict[300005];
map <pair <ll, ll>, vector <int> > opa;
map <pair <ll, ll>, int> anskol;
 
ll build_hash1(const string &s)
{
    for (int i = 0; i < 26; i++) last[i] = 0;
    int n = (int) s.length();
    ll hs = 0;
    for (int i = 1; i <= n; i++)
    {
        int d = i - last[s[i - 1] - 'A'];
        hs = hs * P + (ll) d;
        last[s[i - 1] - 'A'] = i;
    }
    return hs;
}

ll build_hash2(const string &s)
{
    int n = (int) s.length();
    ll hs = 0;
    for (int i = 1; i <= n; i++)
    {
        int c = s[i - 1] - 'A';
        int add = 0;
        if (used[c]) add = number[c];
        hs = hs * P + (ll) add;
    }
    return hs;
}
 
int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
     
    string s, t;
    cin >> s >> t;
    for (char c : s) used[c - 'A'] = true;
    for (char c : t) used[c - 'A'] = true;
    int kol = 0;
    for (int i = 0; i < 26; i++) kol += used[i];
    if (kol > 10) cout << "0\n", exit(0);
    int nm = 0;
    for (int i = 0; i < 26; i++)
    	if (used[i])
    	{
    	 	nm++;
    	 	number[i] = nm;
    	}
 
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> dict[i];
        ll haha1 = build_hash1(dict[i]);
        ll haha2 = build_hash2(dict[i]);
        opa[mp(haha1, haha2)].pb(i);
    }
 
    vector <int> perm(10), last(10);
    for (int i = 0; i < 10; i++) perm[i] = i;
    last = perm;
 
    do
    {
        if (perm != last)
        {
            bool fl = false;
            for (int i = 0; i < kol; i++) if (perm[i] != last[i]) fl = true;
            if (!fl) continue;
        }
        for (int i = 0; i < 26; i++) value[i] = -1;
        for (int i = 0; i < 10; i++) revvalue[i] = -1;
 
        int sch = 0;
        for (int i = 0; i < 26; i++)
            if (used[i])
            {
                value[i] = perm[sch];
                revvalue[perm[sch]] = i;
                sch++;
            }
        if (value[s[0] - 'A'] != 0 && value[t[0] - 'A'] != 0)
        {
            ll num1 = 0, num2 = 0;
            for (char c : s) num1 = num1 * 10ll + (ll) value[c - 'A'];
            for (char c : t) num2 = num2 * 10ll + (ll) value[c - 'A'];
            ll res = num1 + num2;
            
            string R = to_string(res);
            int sc = 0;
            string st = "";
            for (int i = 0; i < (int) R.length(); i++)
            {
             	int c = R[i] - '0';
             	if (revvalue[c] == -1)
             	{
             	 	while (value[sc] != -1) sc++;
             	 	revvalue[c] = sc;
             	 	value[sc] = c;
             	}
             	st += (char) ('A' + revvalue[c]);
            }
            ll hrhr = build_hash1(st);
            ll hshs = build_hash2(st);
 
       		anskol[mp(hrhr, hshs)]++;
        }   
         
        last = perm;
    } while (next_permutation(perm.begin(), perm.end()));
 
    for (auto it = anskol.begin(); it != anskol.end(); it++)
    {
     	pair <ll, ll> A = it->x;
     	if (opa.find(A) == opa.end() || it->y != 1) continue;
     	vector <int> slovo = opa[A];
     	for (int i = 0; i < (int) slovo.size(); i++)
     		answer.pb(slovo[i]);
    }

    sort(answer.begin(), answer.end());
    cout << (int) answer.size() << '\n';
    for (int i = 0; i < (int) answer.size(); i++)
    	cout << dict[answer[i]] << '\n';
    return 0;
}