// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	string a, b;
	cin >> a >> b;
	if (szof(a) < szof(b)) {
		swap(a, b);
	}
	set<char> in_ab(a.begin(), a.end());
	in_ab.insert(b.begin(), b.end());

	vector<gp_hash_table<string, vector<pii>>> mem(20);	

	int n;
	cin >> n;
	vector<string> ans;
	vector<string> strs;
	vector<int> sum_ans(n);
	{
		vector<int> inds(26);
		int tsum = 0;
		for (int sn = 0; sn < n; ++sn) {
			// cerr << sn << endl;
			string s;
			cin >> s;
			strs.push_back(s);
			// cerr << s << endl;
			int ok_cnt = 0;
			vector<int> have_ch;
			for (char c : s) {
				have_ch.push_back(c - 'A');
			}
			sort(have_ch.begin(), have_ch.end());
			have_ch.erase(unique(have_ch.begin(), have_ch.end()), have_ch.end());
			vector<int> where(26, -1);
			int mask = 0;
			for (int i = 0; i < szof(have_ch); ++i) {
				where[have_ch[i]] = i;
				// cerr << (char) ('A' + have_ch[i]) << endl;
				if (in_ab.count('A' + have_ch[i])) {
					mask |= 1 << i;
				}
			}
			// cerr << mask << endl;
			// for (int mask = 0; mask < 1 << szof(have_ch); ++mask) {
				string cur = "";
				fill(inds.begin(), inds.end(), -1);
				int ind_cnt = 0;
				for (int i = 0; i < szof(s); ++i) {
					int ch = s[i] - 'A';
					if (mask & (1 << where[ch])) {
						cur += s[i];
					} else {
						if (inds[ch] == -1) {
							inds[ch] = ind_cnt++;
						}
						cur += inds[ch] + '0';
					}
				}
				int cur_dont_have = 0;
				for (int i = 0; i < szof(have_ch); ++i) {
					if (!(mask & (1 << i))) {
						cur_dont_have |= 1 << have_ch[i];
					}
				}
				// if (mem[szof(cur)].find(cur) != mem[szof(cur)].end()) {
				// 	for (auto p : mem[szof(cur)][cur]) {
				// 		if ((p & cur_dont_have) == cur_dont_have) {
				// 			ok_cnt++;
				// 			if (ok_cnt >= 2) {
				// 				break;
				// 			}
				// 		}
				// 	}
				// }
				mem[szof(cur)][cur].push_back({cur_dont_have, sn});
				// if (ok_cnt >= 2) {
				// 	break;
				// }
			// }
			// cerr << s << " " << ok_cnt << endl;
			if (ok_cnt == 1) {
				ans.push_back(s);
			}
		}
	}

	
	{
		vector<int> ch_by_dig(10, -1);
		vector<int> dig_by_ch(26, -1);
		vector<int> res;
		function<void(int, int)> rec = [&](int pos, int carry) {
			if (pos < szof(a)) {
				vector<int> unknown;
				int c1 = a[szof(a) - 1 - pos] - 'A';
				if (dig_by_ch[c1] == -1) {
					unknown.push_back(c1);
				}
				if (pos < szof(b)) {
					int c2 = b[szof(b) - 1 - pos] - 'A';
					if (dig_by_ch[c2] == -1 && c2 != c1) {
						unknown.push_back(c2);
					}
				}
				function<void(int)> choose = [&](int pos2) {
					if (pos2 == szof(unknown)) {
						int s = carry + dig_by_ch[c1];
						if (pos < szof(b)) {
							s += dig_by_ch[b[szof(b) - 1 - pos] - 'A'];
						}
						res.push_back(s % 10);
						rec(pos + 1, s / 10);
						res.pop_back();
						return;
					}
					for (int d = 0; d < 10; ++d) {
						if (ch_by_dig[d] == -1) {
							ch_by_dig[d] = unknown[pos2];
							dig_by_ch[unknown[pos2]] = d;

							choose(pos2 + 1);

							dig_by_ch[unknown[pos2]] = -1;
							ch_by_dig[d] = -1;
						}
					}
				};
				choose(0);
			} else {
				if (carry) {
					res.push_back(carry);
				}

				if (res.back() == 0 || dig_by_ch[a.front() - 'A'] == 0 || dig_by_ch[b.front() - 'A'] == 0) {

				} else {
					string cur = "";
					vector<int> inds(10, -1);
					int ind_cnt = 0;
					for (int i = szof(res) - 1; i >= 0; --i) {
						if (ch_by_dig[res[i]] != -1) {
							cur += 'A' + ch_by_dig[res[i]];
						} else {
							if (inds[res[i]] == -1) {
								inds[res[i]] = ind_cnt++;
							}
							cur += inds[res[i]] + '0';
						}
					}
					// cerr << cur << endl;
					int left_ch = 0;
					for (int i = 0; i < 26; ++i) {
						if (dig_by_ch[i] == -1) {
							left_ch |= 1 << i;
						}
					}
					// mem[szof(cur)][cur].push_back(left_ch);
					if (mem[szof(cur)].find(cur) != mem[szof(cur)].end()) {
						for (auto& p : mem[szof(cur)][cur]) {
							if ((p.ff & left_ch) == p.ff) {
								++sum_ans[p.ss];
							}
						}
					}
				}

				if (carry) {
					res.pop_back();
				}
			}
		};
		rec(0, 0);
	}

	

	// cerr << "here" << endl;

	// for (int i = 2; i <= 15; ++i) {
	// 	cerr << szof(vars[i]) << endl;
	// }

	for (int i = 0; i < n; ++i) {
		if (sum_ans[i] == 1) {
			ans.push_back(strs[i]);
		}
	}

	// cerr << tsum * 1000 / CLOCKS_PER_SEC << endl;

	cout << szof(ans) << "\n";
	for (string s : ans) {
		cout << s << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}