#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 mt(736);


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;

	cin >> n;

	vector<string> arr(n);

	for (auto &it : arr)
		cin >> it;

	vector<bool> ans(n);

	for (int i = (int) arr.size() - 1; i >= 0; i--)
		for (int j = 1; j <= 8 && i + j < arr.size(); j++)
			if (!ans[i + j])
			{
				int d = 0;

				for (int t = 0; t < arr[i].size(); t++)
					if (arr[i][t] == arr[i + j][t])
						d++;

				if (j <= d)
					ans[i] = true;
			}

	reverse(ans.begin(), ans.end());

	for (int i = 0; i < ans.size(); i++)
		cout << (ans[i] ? 1 : 2);
	cout << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
