#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 mt(736);


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;

	cin >> n;

	vector<string> arr(n);

	for (auto &it : arr)
		cin >> it;

	array<bool, 1u << 8u> dp{}, ndp{};

	for (int i = 0; i < dp.size(); i++)
		dp[i] = i % 2 != 0;

	string ans;
	ans.reserve(arr.size());

	auto cnt_d = [&arr](int x, int y)
	{
		int d = 0;

		for (int t = 0; t < arr[x].size(); t++)
			if (arr[x][t] == arr[y][t])
				d++;

		return d;
	};

	for (int i = 0; i < arr.size(); i++)
	{
		unsigned val = 0;

		for (int pos = 0; pos < 8 && pos <= i; pos++)
			for (int j = 0; j < pos; j++)
				if ((val & (1u << j)) == 0)
				{
					int d = cnt_d(i - j, i - pos);

					if (pos - j <= d)
						val |= 1u << pos;
				}

		ans += dp[val] ? '1' : '2';

		if (i + 1 < arr.size())
			for (unsigned mask = 0; mask < ndp.size(); mask++)
			{
				bool last = false;

				if (i >= 7)
				{
					int pos = i - 7;

					for (int j = 1; j <= 8; j++)
					{
						int d = cnt_d(pos, pos + j);

						if (j <= d)
							last = last || ((mask >> (8u - j)) & 1u) == 0;
					}
				}

				ndp[mask] = dp[(last ? (mask >> 1u) | (1u << 7u) : mask >> 1u)];
			}

		dp.swap(ndp);
	}

	cout << ans << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
