#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define forrn(i, s, n) for (int i = (int)(s); i < (int)(n); i++)
#define PYMOD(a, m) ((((a) % (m)) + (m)) % (m))
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define mp make_pair
#define ff first
#define ss second

struct node {
    int w, l, r;
};

optional<vector<node>> build(int ones, int twos) {
    if (ones + twos == 0) {
        return vector<node>{};
    }
    if (ones + twos == 1) {
        return vector<node>{node{ones ? 1 : 2, -1, -1}};
    }
    int rootw = twos == 0 ? 1 : 2;
    if (rootw == 2)
        twos--;
    else
        ones--;
    int lo = 0, lt = 0, ro = 0, rt = 0;
    forn(i, ones) {
        if (lo < ro)
            lo++;
        else
            ro++;
    }
    forn(i, twos) {
        if (lo + 2 * lt < ro + 2 * rt)
            lt++;
        else
            rt++;
    }
    if (abs(lo + 2 * lt - (ro + 2* rt)) >= 2)
        return {};
    auto la = build(lo, lt);
    if (!la.has_value())
        return {};
    auto ra = build(ro, rt);
    if (!ra.has_value())
        return {};
    vector<node> ret = la.value();
    int ss = ret.size();
    for (auto node : ra.value()) {
        if (node.l != -1)
            node.l += ss;
        if (node.r != -1)
            node.r += ss;
        ret.emplace_back(move(node));
    }
    int rr = ra.value().size() ? ret.size() - 1 : -1;
    ret.emplace_back(node{rootw, ss - 1, rr});
    return ret;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // Code here:

    int a, b;
    cin >> a >> b;

    auto tree = build(a, b);
    if (!tree.has_value()) {
        cout << -1 << endl;
        return 0;
    }
    for (auto [w, l, r] : tree.value()) {
        cout << w << " " << l + 1 << " " << r + 1 << endl;
    }

    return 0;
}
