#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <cstddef>
#include <cstring>
#include <bitset>
#include <random>
#include <memory>
#include <iomanip>

typedef long long ll;
typedef long double ld;

using namespace std;

const int MX = 20;
vector<int> g[MX];
int p[MX];

vector<int> merge(vector<int> a, vector<int> b) {
    vector<int> c;
    for (int i : a) {
        c.push_back(i);
        for (int j : b) c.push_back(j);
        reverse(b.begin(), b.end());
    }
    return c;
}

vector<int> dfs(int v) {
    vector<vector<int>> a;
    for (int i : g[v]) {
        a.push_back(dfs(i));
    }
    vector<int> ans;
    ans.push_back(v);

    while (!a.empty()) {
        ans = merge(ans, a.back());
        a.pop_back();
    }
    return ans;
}

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    vector<int> ans = dfs(0);
    cout << (int)ans.size() - 1 << '\n';
    for (int i : ans) if (i != 0) cout << i + 1 << ' ';
    cout << '\n';



    return 0;
}
