def gcd(a, b):
    if b == 0:
        return (1, 0, a)
    x1, y1, d = gcd(b, a % b)
    x = y1
    y = x1 - y1 * (a // b)
    return (x, y, d)

def solve(b, d):
    x, y, g = gcd(d, b)
    x *= b // g * b
    y *= b // g * b
    
    u = b // g
    v = d // g
    t1 = (-x) // u
    while t1 * u + x > 0:
        t1 -= 1
    while t1 * u + x <= 0:
        t1 += 1
    t2 = y // v
    while y - t2 * v > 0:
        t2 += 1
    while y - t2 * v <= 0:
        t2 -= 1
    if y - t1 * v <= 0:
        return 0
    if x + t2 * u <= 0:
        return 0
    return t2 - t1 + 1

n = int(input())
for i in range(int(n)):
    b, d = map(int, input().split())
    print(solve(b, d))

