
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const int mod = 1e9 + 7;

ll binpow(ll a, ll p) {
    ll res = 1;
    while (p) {
        if (p & 1) {
            (res *= a) %= mod;
        }
        p >>= 1;
        (a *= a) %= mod;
    }
    return res;
}

const int N = 3e5 + 5;
const int M = 1 << 8;

int dp[N][M];
int dist[N][8];
string w[N];
int mem[8];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < min(n, i + 9); j++) {
            for (int k = 0; k < 8; k++) {
                dist[i][j - i - 1] += w[i][k] == w[j][k];
            }
        }
    }
    for (int mask = 0; mask < M; mask++) {
        int x = 0;
        for (int j = 1; j < min(n, 9); j++) {
            if (dist[0][j - 1] >= j) {
                int val = mask >> (j - 1) & 1;
                x |= !val;
            }
        }
        dp[0][mask] = x;
    }
    for (int i = 1; i < n; i++) {
        for (int mask = 0; mask < M; mask++) {
            int x = 0;
            for (int j = i + 1; j < min(n, i + 9); j++) {
                if (dist[i][j - i - 1] >= j - i) {
                    int val = mask >> (j - i - 1) & 1;
                    x |= !val;
                }
            }
            int new_mask = (mask << 1) & 255;
            new_mask += x;
            dp[i][mask] = dp[i - 1][new_mask];
        }
    }
    cout << '2';
    for (int i = 1; i < n; i++) {
        cout << "21"[dp[i - 1][254]];
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    for (int tc = 1; tc <= T; tc++) {
        // cout << "Case " << tc << ": ";
        solve();
    }
    return 0;
}