#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>

using namespace std;
// using namespace __gnu_pbds;

//-----------------------------------------------
#define LOG
#ifdef LOG
  #define db(x)     cerr << #x << ": " << x << endl;
  #define dbA(x, s) cerr << #x << ": "; for (int i = 0; i < s; i++) cerr << x[i] << " "; cerr << endl;
#else
  #define db(x)
  #define dbA(x, s)
#endif
//-----------------------------------------------
template<class K, class V> ostream& operator << (ostream& out, const pair<K, V>& obj) { out << "{ " << obj.first << ", " << obj.second << " }"; return out; }
template<class T> ostream& operator << (ostream& out, const vector<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const deque<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const unordered_set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class K, class V> ostream& operator << (ostream& out, const map<K, V>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class K, class V> ostream& operator << (ostream& out, const unordered_map<K, V>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
//-----------------------------------------------
#define all(x)  x.begin(), x.end()
#define sz(x)   (int)x.size()
#define sq(x)   (x) * (x)
#define fr      first
#define sc      second
//-----------------------------------------------
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<ll, int>;
//-----------------------------------------------
const int N   = 1000 * 1000 + 5;
const ll mod  = 1000000007;
const ll mod3 = 998244353;
const ll INFL = 1000000000 * 1ll * 1000000000 + 500000;
const ll INF  = 1000000000;
const ld pi   = acosl(-1.0);
//-----------------------------------------------

int n, p;
string s;

void input() {
  cin >> n;
}

void solve(int test_id) {
  int ans = INF, best_id = 0;
  int ind = 1;
  while (n--) {
    cin >> p >> s;
    int cnts[] = {1, 1, 2, 0, 0, 0, 0, 0, 0, 0};
    for (char c : s) {
      cnts[c - '0']--;
    }
    if (cnts[0] <= 0 && cnts[1] <= 0 && cnts[2] <= 0) {
      if (p < ans) {
        best_id = ind;
        ans = p;
      }
    }
    ind++;
  }
  cout << best_id << endl;
}

int main() {
  int testcases = 1;
  // scanf("%d", &testcases);
  for(int test_id = 1; test_id <= testcases; test_id++) {
    input();
    solve(test_id);
  }
  return 0;
}
