///////////////////////////////     _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update> oset;

const int N = 1000005;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());

int n, q;
pair <int, int> seg[N];

int k[N];
vector <int> g[N];
int answ[N];

void dfs(int v) {
    seg[v].first = seg[v].second = k[v];
    for (int i = 0; i < (int)g[v].size(); i++) {
        int to = g[v][i];
        if (to == 0) continue;
        dfs(to);
        seg[v].first = min(seg[v].first, seg[to].first);
        seg[v].second = max(seg[v].second, seg[to].second);
    }
}

int l[N], r[N];
vector <int> X;

oset t[4 * N];
void update(int v, int s, int e, int pos, int val) {
    t[v].insert(val);
    if (s == e) return ;
    int m = (s + e) / 2;
    if (pos <= m) {
        update(2 * v, s, m, pos, val);
    } else {
        update(2 * v + 1, m + 1, e, pos, val);
    }
}

int get(int v, int s, int e, int l, int r, int x) {
    if (l > r) return 0;
    if (s == l && e == r) return t[v].order_of_key(x + 1);
    int m = (s + e) / 2;
    return get(2 * v, s, m, l, min(r, m), x) + get(2 * v + 1, m + 1, e, max(m + 1, l), r, x);
}

int main() {
    scanf("%d", &n);

    for (int i = 1; i <= n; i++) {
        int a, b;
        scanf("%d%d%d", &a, &b, &k[i]);
        g[i].push_back(a);
        g[i].push_back(b);
    }

    dfs(1);

    for (int i = 1; i <= n; i++) {
        X.push_back(seg[i].first);
        X.push_back(seg[i].second);
    }

    scanf("%d", &q);
    for (int i = 1; i <= q; i++) {
        scanf("%d%d", &l[i], &r[i]);
        X.push_back(l[i]);
        X.push_back(r[i]);
    }

    sort(X.begin(), X.end());
    X.resize( unique(X.begin(), X.end()) - X.begin() );

    vector <int> R, L;
    for (int i = 1; i <= n; i++) {
        seg[i].first = X[ lower_bound(X.begin(), X.end(), seg[i].first) - X.begin() ];
        seg[i].second = X[ lower_bound(X.begin(), X.end(), seg[i].second) - X.begin() ];
        ///
        R.push_back(seg[i].second);
        L.push_back(seg[i].first);
    }
    sort(L.begin(), L.end());
    sort(R.begin(), R.end());

    sort(seg + 1, seg + n + 1);

    vector < pair<int, int> > mas;
    for (int i = 1; i <= q; i++) {
        l[i] = X[ lower_bound(X.begin(), X.end(), l[i]) - X.begin() ];
        r[i] = X[ lower_bound(X.begin(), X.end(), r[i]) - X.begin() ];
        ///
        int ind = upper_bound(R.begin(), R.end(), l[i] - 1) - R.begin() - 1;
        answ[i] += ind + 1;
        ind = upper_bound(L.begin(), L.end(), r[i]) - L.begin();
        answ[i] += (int)L.size() - ind;
        ///
        mas.push_back(make_pair(-l[i], i));
    }

    sort(mas.begin(), mas.end());
    int it = n;

    for (int i = 0; i < q; i++) {
        int id = mas[i].second;

        while (it >= 1 && seg[it].first >= l[id]) {
            update(1, 0, (int)X.size() - 1, seg[it].first, seg[it].second);
            --it;
        }

        answ[id] += get(1, 0, (int)X.size() - 1, l[id], r[id], r[id]);
    }

    for (int i = 1; i <= q; i++) {
        answ[i] = n - answ[i];
        printf("%d\n", 2 * answ[i] + 1);
    }
    return 0;
}
