#include <iostream>

bool contains_digits(std::string s) {
    int two = 0;
    int zero = 0;
    int one = 0;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] == '2') {
            two++;
        } else if (s[i] == '1') {
            one++;
        } else if (s[i] == '0') {
            zero++;
        }
    }

    return (two >= 2) && (zero >= 1) && (one >= 1);
}

int main() {
    int n;
    std::cin >> n;
    int min_price = std::numeric_limits<int>::max();
    int min_index = 0;
    for (int i = 0; i < n; i++) {
        int p;
        std::string s;
        std::cin >> p;
        std::cin >> s;
        if (contains_digits(s)) {
            if (p < min_price) {
                min_price = p;
                min_index = i + 1;
            }
        }
    }

    std::cout << min_index << std::endl;
}