#include <iostream>
#include <string>
#include <vector>

class A
{
public:
	int p;
	int index;
	std::string str;
};

void qs(std::vector<A>& vec, int start, int end)
{
	if (start >= end)
		return;
	int i = start;
	auto bf = vec[0];
	for (int j = start; j < end; ++j)
	{
		if (vec[j].p < vec[end].p)
		{
			bf = vec[j];
			vec[j] = vec[i];
			vec[i++] = bf;
		}
	}
	bf = vec[end];
	vec[end] = vec[i];
	vec[i] = bf;
	qs(vec, start, i - 1);
	qs(vec, i + 1, end);
}

void qucksort(std::vector<A>& vec)
{
	qs(vec, 0, vec.size() - 1);
}

bool check(std::string str)
{
	int k[3] = { 2,1,1 };
	for (int i = 0; i < str.size(); ++i)
	{
		if (str[i] == '0')
		{
			--k[1];
		}
		if (str[i] == '1')
		{
			--k[2];
		}
		if (str[i] == '2')
		{
			--k[0];
		}
		if (k[0] <= 0 && k[1] <= 0 && k[1] <= 0)
		{
			return true;
		}
	}
	return false;
}



int main()
{
	int n;
	std::cin >> n;
	std::vector<A> arr(n);
	
	for (int i = 0; i < n; ++i)
	{
		std::cin >> arr[i].p >> arr[i].str;
		arr[i].index = i + 1;
	}
	qucksort(arr);
	for (int i = 0; i < arr.size(); ++i)
	{
		if (check(arr[i].str))
		{
			std::cout << arr[i].index;
			return 0;
		}
	}
	std::cout << 0;
	return 0;
}