#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sp(n) fixed << setprecision(n)
#define _  << " " <<
#define pb push_back
#define eb emplace_back
#define ff first
#define ss second

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int N = 22;
vector<int> g[N];
vector<int> res[N];

vector<int> cur;
bool rev_cur = true;

void push(vector<int>& a, vector<int> b, bool rev = false) {
    if (rev) reverse(all(b));
    a.insert(a.end(), all(b));
    return;
}

void dfs(int v = 1, int p = -1) {
    if (v != 1) {
        res[v] = vector<int>(1, v);
        if (!cur.empty()) {
            push(res[v], cur, rev_cur);
            rev_cur = !rev_cur;
        }
    }

    vector<int> cur_v;
    for (auto to : g[v]) if (to != p) {
        dfs(to, v);
        push(res[v], res[to]);
        push(cur_v, res[to]);
        cur = cur_v;
    }

    cur = res[v];

    return;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << sp(10);

#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;

    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;

        g[p].pb(i);
    }

    dfs();

    cout << res[1].size() << endl;
    for (auto i : res[1])
        cout << i << " ";
    cout << endl;

#ifdef LOCAL_DEBUG
    cerr << "Execution time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s.\n";
#endif

    return 0;
}
