#include <bits/stdc++.h>

using namespace std;

struct Ans {
    int p = 0, l, r;
};

Ans tree[400000];
bool failed = false;

int dfs(int i, int a, int b) {
    if (!a && !b) {
        return 0;
    }

    int r = (i + 1) * 2;
    int l = r - 1;

    bool two = a > 0;

    if (two) a--;
    else b--;

    int la, lb, ra, rb;

    if (a % 2 == 0) {
        la = a / 2;
        lb = b / 2;
        ra = a - la;
        rb = b - lb;
    } else {
        la = a / 2;
        ra = a - la;

        if (b == 0) {
            failed = true;

            return 0;
        }

        if (b % 2 == 0) {
            lb = b / 2;
            rb = b - lb;
            rb--;
            lb++;
        } else {
            rb = b / 2;
            lb = b - rb;
        }
    }

    int indl = dfs(l, la, lb);
    int indr = dfs(r, ra, rb);

    if (failed) return 0;

    tree[i] = {two ? 2 : 1, indl, indr};

    return i + 1;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int a, b;

    cin >> b >> a;

    dfs(0, a, b);

    int minv = 1;

    if (failed) goto fail;

    for (int i = 0, j = 0; j < a + b; i++) {
        if (tree[i].p == 0) continue;

        cout << tree[i].p << " ";

        if (tree[i].l == 0) cout << 0 << " ";
        else {
            minv = min(minv + 1, tree[i].l);
            cout << minv << " ";
        }

        if (tree[i].r == 0) cout << 0 << endl;
        else {
            minv = min(minv + 1, tree[i].r);
            cout << minv << endl;
        }

        j++;
    }

    return 0;

    fail:

    cout << -1 << endl;

    return 0;
}