#include <bits/stdc++.h> 
using namespace std; 

struct Node 
{ 
    int data;
    int index = 0;
    Node* left, * right; 
}; 
  

Node* newNode(int data, int idx) 
{ 
    Node* node = (Node*)malloc(sizeof(Node)); 
    node->data = data;
    node->index = idx;
    node->left = node->right = NULL; 
    return (node); 
} 
  
Node* INSERT(int arr[], Node* root, 
                       int i, int n) 
{ 
    if (i < n) 
    { 
        Node* temp = newNode(arr[i], i + 1); 
        root = temp; 
  
        root->left = INSERT(arr, 
                   root->left, 2 * i + 1, n); 
                   
        root->right = INSERT(arr, 
                  root->right, 2 * i + 2, n); 
    } 
    return root; 
} 
  

void PRINT(struct Node* node) 
{ 
    if (node == NULL) 
        return; 
    
    cout << node->data << ' ' ;
	if(node->left != NULL)
		cout << node->left->index << ' ';
	else
		cout << 0 << ' ';
	if(node->right != NULL)
		cout << node->right->index << endl;
	else
		cout << 0 << endl;
    
    PRINT(node->left); 
  
    PRINT(node->right); 
}

int a, b, n;
int main() 
{ 
	cin >> a >> b;
	if(b % 2 == 0 && a == 0)
		cout << -1;
	else
	{
		n = a + b;
	    int arr[n];
	    for(int i = 0; i < b; i++)
	    	arr[i] = 2;
	    for(int i = b; i < n; i++)
	    	arr[i] = 1;
	    Node* root = INSERT(arr, root, 0, n); 
	    PRINT(root);
	}

    return 0;
}