#include <iostream>
#include <cmath>
#include <vector>

typedef long long int LL;

using namespace std;

const int N = 131072;

int tree[200010];
int sum[200010];
int rev[200010];
vector <int> nov;

bool check(int v) {
    if(!tree[v]) return true;
    if(abs(sum[2*v]-sum[2*v+1]) > 1) return false;
    else return check(2*v)&&check(2*v+1);
}

int main() {
    ios::sync_with_stdio(0);
    int A, B, n;
    cin >> A >> B;
    n = A+B;
    int curr = 1;
    if(B) {
        tree[curr] = 2; B--;
        sum[curr] = 2;
    }
    else {
        tree[curr] = 1; A--;
        sum[curr] = 1;
    }

    while(B) {
        curr = 1;
        while(1) {
            sum[curr] += 2;
            if(sum[2*curr] > sum[2*curr+1]) curr = 2*curr+1;
            else curr = 2*curr;
            if(!tree[curr]) {
                tree[curr] = 2;
                sum[curr] = 2;
                B--;
                break;
            }
        }
    }
    while(A) {
        curr = 1;
        while(1) {
            sum[curr] += 1;
            if(sum[2*curr] > sum[2*curr+1]) curr = 2*curr+1;
            else curr = 2*curr;
            if(!tree[curr]) {
                tree[curr] = 1;
                sum[curr] = 1;
                A--;
                break;
            }
        }
    }

    if(!check(1)) {cout << -1; return 0;}
    for(int i=1; i<2*n; i++) {
        if(tree[i]) {
            nov.push_back(i);
            rev[i] = nov.size();
        }
    }

    for(int i=0; i<nov.size(); i++) {
        cout << tree[nov[i]] << " ";
        if(tree[2*nov[i]]) {
            cout << rev[2*nov[i]] << " ";
        }
        else cout << "0 ";
        if(tree[2*nov[i]+1]) {
            cout << rev[2*nov[i]+1] << " ";
        }
        else cout << "0 ";
        cout << endl;

    }



    return 0;
}
