#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <iomanip>
#include <fstream>
#include <cmath>
#include <random>

#define ll long long
#define ld long double
#define INF 10e+9

using namespace std;

int main() {
    cin.tie(nullptr);
    std::istream::sync_with_stdio(false);

    ll a, b;
    cin >> a >> b;

    ll p = a + b;

    ll step = 1;
    for (step = 1; step <= p; step *= 2);

    ll stepB = 1;
    for (stepB = 1; stepB <= b; stepB *= 2);

    if (stepB - 1 > p) {
        cout << "-1";
        return 0;
    }

    vector<pair<ll, ll>> v = vector<pair<ll, ll>>(step);
    vector<ll> massV = vector<ll>(step * 2, 0);
    for (ll i = 1; i < step; i++) {
        if (i == 1) v[i] = pair<ll, ll>(2, 3);
        else {
            ll ii = pow(2, floor(log2(i)));
            v[i] = pair<ll, ll>(i + ii, i + 2 * ii);
        }
    }

    for (ll i = 1; i <= p; i++) {
        massV[i] = 1;
    }

    ll stepBNew1323xfd = stepB, lb, rb;
    lb = stepBNew1323xfd / 2;
    rb = stepBNew1323xfd - 1;

    while (b != 0) {
        if (b >= stepBNew1323xfd) {
            b -= stepBNew1323xfd;
            for (ll i = lb; i <= rb; i++) {
                massV[i] = 2;
            }
        }

        stepBNew1323xfd /= 2;

        lb = stepBNew1323xfd;
        rb = stepBNew1323xfd * 2 - 1;
    }

    for (int i = 1; i <= p; i++) {
        cout << massV[i] << " " << ((massV[v[i].first] == 0 || v[i].first > p) ? 0 : v[i].first) << " "
             << ((massV[v[i].second] == 0 || v[i].second > p) ? 0 : v[i].second) << endl;
    }


    return 0;
}