#include <bits/stdc++.h>

using namespace std;

//#define MULTITEST

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define sqr(a) ((a) * (a))
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < int(n); i++) 
#define fore(i, l, r) for(int i = int(l); i < int(r); i++)

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template <class A, class B> ostream& operator << (ostream& out, const pair<A, B> &a) {
	return out << "(" << a.x << ", " << a.y << ")";
}

template <class A> ostream& operator << (ostream& out, const vector<A> &v) {
	out << "[";
	forn(i, sz(v)) {
		if(i) out << ", ";
		out << v[i];
	}
	return out << "]";
}

mt19937 rnd(time(NULL));

const int INF = int(1e9);
const li INF64 = li(1e18);
const int MOD = int(1e9) + 7;
const ld EPS = 1e-9;
const ld PI = acos(-1.0);

const int N = 20;

int n;
vector<int> g[N];

bool read () {
	if (scanf("%d", &n) != 1)
		return false;
	forn(i, n)
		g[i].clear();
	fore(i, 1, n){
		int p;
		scanf("%d", &p);
		--p;
		g[p].pb(i);
	}
	return true;
}

vector<int> res[N];
vector<int> dir;

void brute(int x, int v){
	if (x == sz(g[v]))
		return;
	forn(i, sz(res[g[v][x]]) + 1){
		if (dir[x] == 1){
			if (i != 0)
				res[v].pb(res[g[v][x]][i - 1]);
			brute(x + 1, v);
		}
		else{
			if (i != 0)
				res[v].pb(res[g[v][x]][sz(res[g[v][x]]) - i]);
			brute(x + 1, v);
		}
	}
	dir[x] = -dir[x];
}

void dfs(int v){
	res[v] = vector<int>(1, v);
	if (g[v].empty())
		return;
	for (int u : g[v])
		dfs(u);
	dir.assign(sz(g[v]), 1);
	brute(0, v);
}

void solve() {
	dfs(0);
	res[0].erase(res[0].begin());
	printf("%d\n", sz(res[0]));
	for (auto it : res[0])
		printf("%d ", it + 1);
	puts("");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	
	int tt = clock();
	
#endif
	
	cerr.precision(15);
	cout.precision(15);
	cerr << fixed;
	cout << fixed;

#ifdef MULTITEST
	int tc;
	scanf("%d", &tc);
	while(tc--){
		read();
#else
	while(read()) {	
#endif
		solve();
		
#ifdef _DEBUG
	cerr << "TIME = " << clock() - tt << endl;
	tt = clock();
#endif

	}
}