#include <bits/stdc++.h>

using namespace std;

typedef struct vert
{
    int left, right;
    int minn, maxx, coun, key;


};
vector <vert> g;
int n;
pair<int, int> lookup(int vI, int L, int R)
{
    vert v = g[vI];
    if (vI == 0)
    {
        return {0,0};
    }
    if (L <= v.minn && v.maxx <= R)
    {
        return {v.coun, 0};
    }
    if (L >  v.maxx || R < v.minn)
    {
        return {0, 0};
    }
    pair<int, int> res = {0, 0};
    if (L <= v.key && v.key <= R)
    {
        res.first++;
    }
    pair<int, int > a = lookup(v.left, L, R);
    res.first += a.first;
    res.second += a.second + 1;

    a = lookup(v.right, L, R);
    res.first += a.first;
    res.second += a.second + 1;
    return res;
}

void build(int i)
{
    if (i == 0)
        return;
    vert v = g[i];
    build(v.left);
    build(v.right);

    g[i].coun = 1;
    g[i].maxx = g[i].key;
    g[i].minn = g[i].key;

    if (g[i].right != 0)
    {
        g[i].maxx = g[g[i].right].maxx;
    }
    if (g[i].left != 0)
    {
        g[i].minn = g[g[i].left].minn;
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    g.resize(n+1);

    for (int i = 1; i <= n; i++)
    {
        int l, r, k;
        cin >> l >> r >> k;
        g[i] = vert{l, r, (int)1e9, 0, 0, k};
    }
    build(1);
    int m;
    cin >> m;
    for (int i = 0; i < m; i++){
        int l, r;
        cin >> l >> r;
        pair<int,int> ans = lookup(1, l, r);
        cout << ans.second + 1 << endl;
    }

    return 0;
}
