#include <iostream>
#include <cstdio>
#include <string>
#include <cstdlib>
#include <set>
#include <utility>
#include <vector>
#include <list>
#include <algorithm>
#include <regex>
#include <cmath>
#include <map>
#include <iterator>
#include <climits>
#include <numeric>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <queue>
#include <deque>
#include <stack>
#include <array>
#include <valarray>
#include <complex>
#include <random>
#include <functional>
#include <cassert>
#include <chrono>
#include <memory>

using namespace std;

#define int long long
//region TEMPLATE
////@formatter:off
typedef long long ll;
typedef unsigned long long ull;
template<typename T>void __read(T&a){cin >> a;}
template<typename T,typename ... Args>void __read(T&a,Args&... args){cin >> a;__read(args...);}
#define make(t, ...) t __VA_ARGS__; __read(__VA_ARGS__)
#define makev(a, n) VI a(n); for(auto&v:(a)) cin >> v;
#define ALL(x) (x).begin(), (x).end()
#define RALL(x) (x).rbegin(), (x).rend()
typedef vector<int> VI;
typedef vector<vector<int>> VVI;
typedef pair<int, int> PII;
constexpr ll M7 = 1000000007;
constexpr ll M9 = 1000000009;
constexpr ll MFFT = 998244353;
constexpr double PI = 3.14159265358979323846;
template<class T> void outv(const T&a,char d=' ', bool nl=false){for(auto&x:a)cout<<x<<d;if(nl)cout<<'\n';}
static mt19937_64 rnd(static_cast<unsigned>(chrono::steady_clock::now().time_since_epoch().count())); // NOLINT(cert-err58-cpp)
auto __fast_io__=(ios_base::sync_with_stdio(false),cin.tie(nullptr)); // NOLINT(cert-err58-cpp,cppcoreguidelines-interfaces-global-init)
////@formatter:on
//endregion




int32_t main() {
    make(int, a, b);
    int n = a + b;
    VI l(n, -1);
    VI r(n, -1);
    VI c(n, -1);
    VI sm(n, 0);
    if (b > 0){
        c[0] = 2;
        sm[0] = 2;
        b--;
    } else {
        c[0] = 1;
        sm[0] = 1;
        a--;
    }
    function<void(int, int, int)> add = [&](int v, int num, int cost){
        if (l[v] == -1){
            l[v] = num;
            sm[num] = cost;
            c[num] = cost;
            sm[v] += cost;
            return;
        }
        if (r[v] == -1){
            r[v] = num;
            sm[num] = cost;
            c[num] = cost;
            sm[v] += cost;
            return;
        }
        int u = sm[l[v]] <= sm[r[v]] ? l[v] : r[v];
        add(u, num, cost);
        sm[v] += cost;
    };
    int v = 1;
    while(b > 0){
        add(0, v, 2);
        v++;
        b--;
    }
    while(a > 0){
        add(0, v, 1);
        v++;
        a--;
    }

    function<bool(int v)> check = [&](int v){
        if (v == -1){
            return true;
        }
        bool lCheck = check(l[v]);
        bool rCheck = check(r[v]);
        int lSm = l[v] == -1 ? 0 : sm[l[v]];
        int rSm = r[v] == -1 ? 0 : sm[r[v]];
        return lCheck && rCheck && abs(lSm - rSm) <= 1;
    };

    if (check(0)){
        for(int i = 0; i < n; ++i){
            cout << c[i] << ' ' << l[i] + 1 << ' ' << r[i] + 1 << '\n';
        }
    } else {
        cout << -1;
    }

    return 0;
}