﻿#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;

#ifndef DEBUG
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#endif

#define int long long
#define double long double

template<typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename S, typename T>
using ordered_map = tree<S, T, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const bool MULTI_TEST = false;


struct Node {
    int a, b;
    int val = -1;
    int l = -1, r = -1;
};
vector<Node> nodes;
bool ok = true;

int make_node(int a, int b) {
    nodes.push_back({a, b});
    return nodes.size() - 1;
}

int make_tree(int a, int b) {
    if (a == 0 && b == 0) {
        return -1;
    }
    int v = make_node(a, b);
    if (b > 0) {
        b--;
        nodes[v].val = 2;
        if (b % 2 == 0) {
            nodes[v].l = make_tree(a / 2, b / 2);
            nodes[v].r = make_tree(a - a / 2, b / 2);
        } else {
            if (a == 0) {
                ok = false;
                return -1;
            } else {
                nodes[v].l = make_tree((a - 2) / 2, b - b / 2);
                nodes[v].r = make_tree(a - (a - 2) / 2, b / 2);
            }
        }
    } else {
        a--;
        nodes[v].val = 1;
        nodes[v].l = make_tree(a / 2, 0);
        nodes[v].r = make_tree(a - a / 2, 0);
    }
    return v;
}

void print(int v) {
    if (v == -1) {
        return;
    }
    cout << nodes[v].val << ' ' << nodes[v].l + 1 << ' ' << nodes[v].r + 1 << '\n';
    print(nodes[v].l);
    print(nodes[v].r);
}

void solve() {
    int a, b;
    cin >> a >> b;
    int root = make_tree(a, b);
    if (ok) {
        print(root);
    } else {
        cout << -1;
    }
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    if (MULTI_TEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }

    return 0;
}


