﻿#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;

#ifndef DEBUG
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#endif

#define int long long
#define double long double

template<typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename S, typename T>
using ordered_map = tree<S, T, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const bool MULTI_TEST = false;

const int MAXN = 1e5;
vector<int> people[MAXN];
int last[MAXN];

void solve() {
    int n;
    cin >> n;
    for (int i = 0, k; i < n; i++) {
        cin >> k;
        for (int j = 0, x; j < k; j++) {
            cin >> x;
            x--;
            people[i].push_back(x);
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        int mx = 0;
        for (int j : people[i]) {
            mx = max(mx, last[j] + 1);
        }
        for (int j : people[i]) {
            last[j] = mx;
        }
    }
    int mx = 0;
    for (int x : last) {
        mx = max(mx, x);
    }
    cout << mx;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    if (MULTI_TEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }

    return 0;
}


