#include<bits/stdc++.h>

using namespace std;

// ordered_set (insert, find_by_order, order_of_key)
//
//#include <ext/pb_ds/assoc_container.hpp> // Common file
//#include <ext/pb_ds/tree_policy.hpp> // Including tree_order_statistics_node_update
//#include <ext/pb_ds/detail/standard_policies.hpp>
//
//using namespace __gnu_pbds;
//
//typedef tree<
//        int,
//        null_type, less_equal<int>,
//        rb_tree_tag,
//        tree_order_statistics_node_update>
//        ordered_set;

template<class T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &x : v) { in >> x; }
    return in;
}

template<class T, class U>
istream &operator>>(istream &in, pair<T, U> &v) {
    in >> v.X >> v.Y;
    return in;
}

template<class T, class U>
ostream &operator<<(ostream &out, pair<T, U> &v) {
    out << v.X << " " << v.Y;
    return out;
}

//#define eps 1e-8
#define sq(x) (x) * (x)
#define PI 3.14159265358979323846
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define sz(x) ((int) (x).size())
#define mp make_pair
#define re return
#define fill(A, value) memset(A,value,sizeof(A))
#define unq(x) (x.resize(unique(all(x)) - x.begin()))
#define forn(i, n) for (int i = 0; i < n; i++)
#define fore(i, e, n) for (int i  = e; i < n; i++)
//#define mt make_tuple

#define pdd pair<double, double>
#define pii pair<int, int>
#define ll long long
#define pll pair<long long, long long>
#define fori(i, a, b) for (int i = a; i < b; i++)
#define vi vector<int>
#define vll vector<long long>

#define ull unsigned long long
#define double long double
#define int long long

int mpow(int n, int p, int M) {
    if (p == 0)
        return 1 % M;
    int ans = mpow(n, p / 2, M);
    ans = (ans * ans) % M;
    if (p % 2 == 1)
        ans = (ans * n) % M;
    return ans % M;
}

int mpow(int n, int p) {
    if (p == 0)
        return 1;
    int ans = mpow(n, p / 2);
    ans = (ans * ans);
    if (p % 2 == 1)
        ans = (ans * n);
    return ans;
}

vector<int> z_function(string s) {
    int n = (int) s.length();
    vector<int> z(n);
    for (int i = 1, l = 0, r = 0; i < n; ++i) {
        if (i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while (i + z[i] < n && s[z[i]] == s[i + z[i]])
            ++z[i];
        if (i + z[i] - 1 > r)
            l = i, r = i + z[i] - 1;
    }
    return z;
}

vector<int> prefix_function(string s) {
    int n = (int) s.length();
    vector<int> pi(n);
    for (int i = 1; i < n; ++i) {
        int j = pi[i - 1];
        while (j > 0 && s[i] != s[j])
            j = pi[j - 1];
        if (s[i] == s[j]) ++j;
        pi[i] = j;
    }
    return pi;
}


// find min and adding on segment

const int INF = 2e18;

// on segment

class treeSumMin {

public:

    treeSumMin *ru, *lu;
    int r, l;
    int v = 0;
    int sum = 0;

    treeSumMin(int l, int r) {
        ru = lu = nullptr;
        this->l = l, this->r = r;
    }


    void static add(treeSumMin *t, int p, int x) {

        if (t->l == t->r) {
            t->sum = x;
            return;
        }

        t->sum += x;

        int c = (t->l + t->r) / 2;

        if (p <= c) {
            if (t->lu == nullptr)
                t->lu = new treeSumMin(t->l, c);
            add(t->lu, p, x);
        } else {
            if (t->ru == nullptr)
                t->ru = new treeSumMin(c + 1, t->r);
            add(t->ru, p, x);
        }

    }

// root, l and r (bounds), v - value for adding, v2 = 0

    void static update(treeSumMin *t, int L, int R, int V, int V2) {

        if (t->r < L || t->l > R) {
            t->v += V2;
            return;
        }

        if (t->l >= L && t->r <= R) {
            t->v += V + V2;
            return;
        }

        t->sum = 0;

        if (t->lu != nullptr) {
            update(t->lu, L, R, V, V2 + t->v);
            t->sum += t->lu->sum + t->lu->v;
        }

        if (t->ru != nullptr) {
            update(t->ru, L, R, V, V2 + t->v);
            t->sum += t->ru->sum + t->ru->v;
        }

        t->v = 0;

    }

// root, l and r (bounds), v = 0

    int static getSum(treeSumMin *t, int L, int R, int V) {

        if (t == nullptr || t->r < L || t->l > R)
            return 0;

        if (t->l >= L && t->r <= R)
            return t->sum + t->v * (t->r - t->l + 1) + V * (t->r - t->l + 1);

        int ans = 0;
        if (t->lu != nullptr) {
            ans += getSum(t->lu, L, R, V + t->v);
        }
        if (t->ru != nullptr) {
            ans += getSum(t->ru, L, R, V + t->v);
        }

        return ans;

    }

};

signed main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++){
        int b, d;
        cin >> b >> d;
        int g = __gcd(b, d);
        int D = d/g;
        cout << (b - 1)/D << "\n";
    }
    return 0;

}