#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <string>
#include <string.h>
#include <algorithm>
#include <functional>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <numeric>
#include <queue>
#include <cassert>
#include <math.h>
#include <array>
#include <valarray>
#include <stack>

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define fore(i, l, r) for (int i = int(l); i < ll(r); i++)
#define forr(i, n) for (ll i = ll(n) - 1; i >= 0; i--)
#define all(a) a.begin(), a.end()
#define mp make_pair
#define pb(a) push_back(a)
#define sz(a) int((a).size())
#define ft first
#define sc second
#define l_b lower_bound
#define u_b upper_bound
#define min_el min_element
#define max_el max_element

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<double, double> pdd;
typedef pair<ld, ld> pld;

const int INF = 1e9;
const ll INF64 = 1e18;
const int N = 2004;
const int M = 20;
const ll MOD = 1000000007;
const ld Pi = 3.1415926535897932384626433832795;
const ld EPS = 1e-8;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	vector<string> b(n);
	forn(i, n) {
		cin >> a[i] >> b[i];
	}

	int min_cost = INF;
	int ans = 0;
	forn(i, n) {
		int need[3] = { 1, 1, 2 };
		forn(j, sz(b[i])) {
			if (b[i][j] - '0' <= 2) {
				need[b[i][j] - '0']--;
			}
		}
		if (need[0] <= 0 && need[1] <= 0 && need[2] <= 0 && a[i] < min_cost) {
			min_cost = a[i];
			ans = i + 1;
		}
	}
	cout << ans << endl;

}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	srand(time(NULL));

	solve();
}