#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/stack:512000000")
#include<utility>
#include<iostream>
#include<fstream>
#include<vector>
#include<array>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<ctime>
#include<functional>
#include<random>
#include<climits>
#include<queue>
#include<stack>
#include<deque>
#include<bitset>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<cassert>
#include<ccomplex>
#include<chrono>
#include<iomanip>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("unroll-loops")
#define int128 __int128
#else
#define int128 long long
#endif

#define all(x) x.begin(), x.end()
#define make_unique(x) sort(all((x))); (x).resize(unique(all((x))) - (x).begin())
#define mp make_pair
#define X first
#define Y second
#define forn(i, n) for (int i = 0; i < n; i++)
#define sz(x) x.size()

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
mt19937_64 gen(time(nullptr));

namespace {
    struct custom_hash {
        static uint64_t splitmix64(uint64_t x) {
            // http://xorshift.di.unimi.it/splitmix64.c
            x += 0x9e3779b97f4a7c15;
            x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
            x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
            return x ^ (x >> 31);
        }

        size_t operator()(uint64_t x) const {
            static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
            return splitmix64(x + FIXED_RANDOM);
        }
    };

    template<typename T, typename F>
    using HashMap = unordered_map<T, F, custom_hash>;

    template<typename T>
    using HashSet = unordered_set<T, custom_hash>;
}

ll mod = 1e9 + 7;

namespace {
    ll mul(ll a, ll b) {
        ll val = a * b - (ll)((ld)a * b / mod) * mod;
        if (val < 0) val += mod;
        if (val >= mod) val -= mod;
        return val;
    }
    ll poww(ll a, ll b) {
        ll val = 1;
        a %= mod;
        while (b > 0) {
            if (b % 2) val = mul(a, val);
            a = mul(a, a);
            b >>= 1;
        }
        return val % mod;
    }
    ll inv(ll a) {
        return poww(a, mod - 2);
    }
    ll gcd(ll a, ll b) {
        return (a == 0 ? b : gcd(b % a, a));
    }
    ll gcdex(ll a, ll b, ll& x, ll& y) {
        if (a == 0) {
            x = 0; y = 1;
            return b;
        }
        ll x1, y1;
        ll d = gcdex(b % a, a, x1, y1);
        x = y1 - (b / a) * x1;
        y = x1;
        return d;
    }

    ll inv_eu(ll a, ll m) {
        ll x, y;
        ll g = gcdex(a, m, x, y);
        if (g != 1)
            assert(0);
        else {
            x = (x % m + m) % m;
            return x;
        }
    }
}

ll const inf = 1e9 + 9;
ll const maxk = 51;
ll const maxn = 3e5 + 3;

#define db(x) print(#x), print(" = "), print(x), print('\n');

namespace {

    template<class T>
    void print(const T& value) {
        std::cerr << value;
    }

    template<class X, class Y>
    void print(const pair<X, Y>& p) {
        const auto& [a, b] = p;
        print("("), print(a), print(", "), print(b), print(")");
    }

    template<class T>
    void print(const vector<T>& v) {
        print("[ ");
        for (const auto& e : v) {
            print(e);
            print(' ');
        }
        print(']');
    }

    template<class X, class Y>
    void print(const map<X, Y>& m) {
        print("{\n");
        for (const auto& [k, v] : m) {
            print('\t'), print(k), print(" -> "), print(v), print('\n');
        }
        print('}');
    }

    template<class T>
    void print(const set<T>& v) {
        print("{ ");
        for (const auto& e : v) {
            print(e);
            print(' ');
        }
        print('}');
    }

    template<class X, class Y>
    void print(const unordered_map<X, Y>& m) {
        print("{\n");
        for (const auto& [k, v] : m) {
            print('\t'), print(k), print(" -> "), print(v), print('\n');
        }
        print('}');
    }

    template<class T>
    void print(const unordered_set<T>& v) {
        print("{ ");
        for (const auto& e : v) {
            print(e);
            print(' ');
        }
        print('}');
    }

}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

vector<vector<int>> g;
vector<vector<int>> dp;

vector<int> traversal[25];

void rec1(int u) {    
    vector<int> kek;
    //kek.push_back(u);
    for (int v : g[u]) {
        rec1(v);
        vector<int> kek1;
        bool rev = false;
        for (int vv : traversal[v]) {
            kek1.push_back(vv);            
            for (auto vvv : kek) {
                kek1.push_back(vvv);
            }            
            reverse(all(kek));
        }
        kek = kek1;
    }
    traversal[u].push_back(u);
    for (auto v : kek) {
        traversal[u].push_back(v);
    }
}

void rec(int u) {
    if (g[u].size()) {
        vector<int> tmp;
        bool reversed2 = true;
        for (int v : g[u]) {
            rec(v);
            bool reversed = true;
            vector<int> tmpnext;
            for (int x : traversal[v]) {
                tmpnext.push_back(x);
                if (reversed2) {
                    for (int i = (int)tmp.size() - 1; i >= 0; i--) {
                        tmpnext.push_back(tmp[i]);
                    }
                } else {
                    for (int y : tmp) {
                        tmpnext.push_back(y);
                    }
                }
                reversed2 ^= 1;
            }
            for (int w : tmpnext) {
                tmp.push_back(w);
            }
        }
        traversal[u].push_back(u);
        for (int v : tmp) {
            traversal[u].push_back(v);
        }
    } else {
        traversal[u] = { u };
    }
}

void solve() {
    int n; cin >> n;
    g.resize(n);
    vector<int>p(n);
    forn(i, n - 1) {
        int u; cin >> u;
        u--;
        g[u].push_back(i + 1);
        p[i + 1] = u;
    }

    vector<int>color(n);
    color[0] = 1;

    rec(0);

    cout << (int)traversal[0].size() - 1 << endl;
    for (int i = 1; i < traversal[0].size(); i++) {
        cout << traversal[0][i] + 1 << " ";
        color[traversal[0][i]] ^= 1;
        if (color[traversal[0][i]] == 1 and color[p[traversal[0][i]]] == 0) {
            assert(0);
        }
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t = 1;
    while (t--) {
        solve();
    }
}
