def gcd (a: int, b: int):
    if a == 0:
        return (b, 0, 1)
    d, x1, y1 = gcd(b % a, a)
    x = y1 - (b // a) * x1
    y = x1
    # print (a, b, d, x, y)
    return (int(d), int(x), int(y))


def find_any_solution (a: int, b: int, c: int):
    g, x0, y0 = gcd(abs(a), abs(b))
    if c % g != 0:
        return (False, 0, 0, 0)
    x0 *= c // g
    y0 *= c // g
    if a < 0:
        x0 *= -1
    if b < 0:
        y0 *= -1
    # print(int(x0), int(y0), int(g))
    return (True, int(x0), int(y0), int(g))


def shift_solution (x: int, y: int, a: int, b: int, cnt: int):
    x += cnt * b
    y -= cnt * a
    return (int(x), int(y))


def find_all_solutions(a: int, b: int, c: int, minx: int, maxx: int, miny: int, maxy: int):
    isOk, x, y, g = find_any_solution (a, b, c)
    if not isOk:
        return 0
    a //= g
    b //= g

    sign_a = +1 if a > 0 else -1
    sign_b = +1 if b > 0 else -1

    x, y = shift_solution (x, y, a, b, (minx - x) // b)
    if x < minx:
        x, y = shift_solution (x, y, a, b, sign_b)
    if x > maxx:
        return 0
    lx1 = x

    x, y = shift_solution (x, y, a, b, (maxx - x) // b)
    if x > maxx:
        x, y = shift_solution (x, y, a, b, -sign_b)
    rx1 = x

    x, y = shift_solution (x, y, a, b, - (miny - y) // a)
    if y < miny:
        x, y = shift_solution (x, y, a, b, -sign_a)
    if y > maxy:
        return 0
    lx2 = x

    x, y = shift_solution (x, y, a, b, - (maxy - y) // a)
    if y > maxy:
        x, y = shift_solution (x, y, a, b, sign_a)
    rx2 = x

    if lx2 > rx2:
        lx2, rx2 = rx2, lx2
    lx = max (lx1, lx2)
    rx = min (rx1, rx2)

    return (rx - lx) // abs(b) + 1


# b, d = map(int, input().split())
# print(gcd(b,d))
t = int(input())
while t > 0:
    t -= 1
    b, d = map(int, input().split())
    v = b * b // d
    v += 1
    print(find_all_solutions(d, b, b * b, 1, v, 1, b))
