
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define sz(a) ((int)(a).size())
#define X first
#define Y second

using ll = long long;
using ull = unsigned long long;
using dbl = long double;
using pii = pair<int, int>;

const int N = (int)1e5 + 5;

int n;
vector<int> gr[N];
vector<int> where[N];
int d[N];

void solve() {
    cin >> n;
    for(int i = 0; i < n; i++){
        int sz;
        cin >> sz;
        for(int j = 0; j < sz; j++){
            int id;
            cin >> id;
            where[id].push_back(i);
        }
    }
    for(int i = 0; i < N; i++){
        if(where[i].empty())
            continue;
        for(size_t j = 1; j < where[i].size(); j++){
            int v = where[i][j - 1], u = where[i][j];
            gr[v].push_back(u);
        }
    }
    for(int i = n - 1; i >= 0; i--){
        for(int j: gr[i])
            d[i] = max(d[i], 1 + d[j]);
    }
    cout << 1 + *max_element(d, d + n) << endl;
}

signed main() {
#ifdef LOCAL
     assert(freopen("input.txt", "r", stdin));
     //assert(freopen("output.txt", "w", stdout));
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);
    int T;
    T = 1;
    while(T--)
	    solve();

#ifdef LOCAL
    cout << endl << endl << "time = " << clock() / (double)CLOCKS_PER_SEC << endl;
#endif
}


