#include <stdio.h>
#include <bits/stdc++.h>

typedef long long ll;

#define fi first
#define se second

using namespace std;

const int N = 25;

vector<int> g0[N];
int p0[N];
vector<int> g[N];
int p[N];

int num[N];
int real_num[N];
int id = 0;

void dfs(int v, int par) {
    num[v] = id++;
    real_num[num[v]] = v;
    p[num[v]] = par;
    for (int to : g0[v]) {
        dfs(to, num[v]);
        g[num[v]].push_back(num[to]);
    }
}

vector<pair<int, int> > gr[2000000];
bool used[2000000];

bool check(int mask, int n) {
    if (!(mask & 1)) {
        return false;
    }
    for (int i = 1; i < n; ++i) {
        if (mask & (1 << i)) {
            if (!(mask & (1 << p[i]))) {
                return false;
            }
        }
    }
    return true;
}

void printMask(int mask, int n) {
    for (int i = 0; i < n; ++i) {
        if (mask & (1 << i)) {
            cerr << 1;
        } else {
            cerr << 0;
        }
    }
    cerr << endl;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "rt", stdin);
    freopen("output.txt", "wt", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 2; i <= n; ++i) {
        cin >> p0[i];
        g0[p0[i]].push_back(i);
    }

    dfs(1, 0);

    /*cerr << "g: " << endl;
    for (int i = 0; i < n; ++i) {
        cerr << i << ' ' << g[i].size() << endl;
        for (int j : g[i]) {
            cerr << j << ' ';
        }
        cerr << endl;
    }*/

    for (int v = 0; v < (1 << n); ++v) if (check(v, n)) {
        for (int j = 0; j < n; ++j) {
            int to = v ^ (1 << j);
            if (check(to, n)) {
                /*cerr << "edge:" << endl;
                printMask(v, n);
                printMask(to, n);*/
                gr[v].push_back({to, j});
            }
        }
    }

    int v = 1;
    used[v] = true;
    vector<int> ans;
    while (true) {
        bool found = false;
        for (pair<int, int> to : gr[v]) {
            if (!used[to.fi]) {
                used[to.fi] = 1;
                v = to.fi;
                ans.push_back(real_num[to.se]);
                found = true;
                break;
            }
        }

        if (!found) {
            break;
        }
    }

    cout << ans.size() << '\n';
    for (int i : ans) {
        cout << i << ' ';
    }
    return 0;
}
