#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define inb push_back

int solve() {
	int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            a[i].push_back(x);
        }
    }
    auto check = [&](int x) {
        vector<int> cur(100007, x + 1);
        for (int i = 0; i < n; ++i) {
            int candidate = x + 1;
            for (auto &chel : a[i]) {
                candidate = min(candidate, cur[chel]);
            }
            if (candidate <= 1) {
                return 0;
            }
            for (auto &chel : a[i]) {
                cur[chel] = candidate - 1;
            }
        }
        return 1;
    };
    int l = -1, r = n;
    while (r - l > 1) {
        int mid = l + r >> 1;
        if (check(mid)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    printf("%d\n", r);
	return 0;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie();
	solve();
	return 0;
}