#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;
 
#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define endl '\n'
#define x first
#define y second
#define int long long
#define double long double
#define pii pair<int, int>
#define pb push_back
#define vec vector
#define beg begin
#define dbg(x) cout << #x << " = " << x << endl;
 
template<class T> ostream& operator<<(ostream& str, const vector<T>& a) {
    for (auto &i : a) {
        str << i << " ";
    }
    return str;
}
 
template<class T> istream& operator>>(istream& str, vector<T>& a) {
    for (auto &i : a) {
        str >> i;
    }
    return str;
}
 
template<class T> ostream& operator<<(ostream& str, const pair<T, T>& a) {
    str << a.first << " " << a.second;
    return str;
}
 
template<class T> istream& operator>>(istream& str, pair<T, T>& a) {
    str >> a.first >> a.second;
    return str;
}
 
void solve(); signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cout.setf(ios::fixed); cout.precision(20);
    solve();
    return 0;
}

const int INF = 1e9 + 10, MAXN = 1e6 + 10;
vec<int> g[MAXN];
vec<int> p[MAXN];
vec<int> g2[MAXN];

void solve() {
	int n;
	cin >> n;

	for (int i = 1; i <= n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int cur;
			cin >> cur;
			p[i].pb(cur);
			g[cur].pb(i);
		}
	}

	for (int k = 1; k <= 1e5; ++k) {
		for (int i = 0; i < sz(g[k]) - 1; ++i) {
			g2[g[k][i]].pb(g[k][i + 1]);
		}
	}

	vec<int> dp(MAXN);
	for (int i = n - 1; i >= 1; --i) {
		int mx = -1;
		for (auto nxt : g2[i]) {
			mx = max(mx, dp[nxt]);
		}
		dp[i] = mx + 1;
	}

	cout << dp[1] + 1 << endl;
}