#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <string>
#include <unordered_map>
using namespace std;
#pragma warning (disable:4996)

bool check (int u, vector<vector<int>>& v, vector<int>& st, int mask) {
    bool ans = true;
    st[u] = 1;
    for (auto i = 0; i < v[u].size(); ++i) {
        if (st[v[u][i]] == 1)
            continue;
        if ((mask & (1 << v[u][i])) != 0 && (mask & (1 << u)) == 0) {
            return false;
        }
        ans = ans & check(v[u][i], v, st, mask);
    }
    return ans;
}

bool find(int u, vector<vector<int>>& v, vector<int>& st, vector<int>& ans, int end) {
    st[u] = 1;
    for (auto i = 0; i < v[u].size(); ++i) {
        if (ans.size() == end) {
            return true;
        }
        if (st[v[u][i]] == 0) {
            ans.push_back((v[u][i] ^ u));
            if (find(v[u][i], v, st, ans, end)) {
                return true;
            }
            ans.pop_back();
            st[v[u][i]] = 0;
        }
    }
    return false;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    vector<int> con(n, 0);
    for (auto i = 1; i < n; ++i) {
        int x;
        cin >> x;
        v[x - 1].push_back(i);
        v[i].push_back(x - 1);
    }
    vector<int> ans_m;
    unordered_map<int, int> was;
    was[1] = 1;
    for (auto m = 0; m < (1 << n); ++m) {
        vector<int> st(n, 0);
        if ((m & 1) != 0 && check(0, v, st, m)) {
            ans_m.push_back(m);
            was[m] = 1;
        }
    }
    int now = 1;
    vector<vector<int>> v_m((1 << n));
    vector<int> ans;
    for (int i = 0; i < ans_m.size(); ++i) {
        for (int j = 0; j < n; ++j) {
            int new_m = (ans_m[i] ^ (1 << j));
            if (was[new_m] == 1) {
                v_m[new_m].push_back(ans_m[i]);
            }
        }
    }
    vector<int> st((1 << n), 0);
    find(1, v_m, st, ans, ans_m.size() - 1);
    cout << ans.size() << '\n';
    for (auto i = 0; i < ans.size(); ++i) {
        for (auto j = 0; j < n; ++j) {
            if ((ans[i] & (1 << j))) {
                cout << j + 1 << ' ';
                break;
            }
        }
    }
    return 0;
}