#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <string>
#include <unordered_map>
using namespace std;
#pragma warning (disable:4996)

bool check (int u, vector<vector<int>>& v, vector<int>& st, int mask) {
    bool ans = true;
    st[u] = 1;
    for (auto i = 0; i < v[u].size(); ++i) {
        if (st[v[u][i]] == 0) {
            if ((mask & (1 << v[u][i])) != 0 && (mask & (1 << u)) == 0) {
                return false;
            }
            ans = ans & check(v[u][i], v, st, mask);
            if (!ans) {
                return false;
            }
        }
    }
    return ans;
}

bool find(int u, vector<vector<int>>& v, vector<int>& st, vector<int>& ans, int end) {
    st[u] = 1;
    for (auto i = 0; i < v[u].size(); ++i) {
        if (ans.size() == end) {
            return true;
        }
        if (st[v[u][i]] == 0) {
            ans.push_back((v[u][i] ^ u));
            if (find(v[u][i], v, st, ans, end)) {
                return true;
            }
            ans.pop_back();
            st[v[u][i]] = 0;
        }
    }
    return false;
}

vector<int>* f(int u, vector<vector<int>>& v, vector<int>& st) {
    st[u] = 1;
    vector<int>* ans = new vector<int>;
    vector<vector<int>*> sub_ans;
    for (auto i = 0; i < v[u].size(); ++i) {
        if (st[v[u][i]] == 0) {
            sub_ans.push_back(f(v[u][i], v, st));
        }
    }
    int kek = 0;
    int last = -1;
    if (u != 0) {
        ans->push_back(u + 1);
        kek = 1;
        last = 0;
    }
    for (auto i = 0; i < sub_ans.size(); ++i) {
        for (auto j = 0; j < sub_ans[i]->size(); ++j) {
            ans->push_back((*sub_ans[i])[j]);
            for (int k = last/*static_cast<int>(ans->size()) - 2*/; k >= kek; --k) {
                ans->push_back((*ans)[k]);
            }
        }
        last = ans->size() - 1;
    }
    return ans;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    vector<int> con(n, 0);
    for (auto i = 1; i < n; ++i) {
        int x;
        cin >> x;
        v[x - 1].push_back(i);
        v[i].push_back(x - 1);
    }
    vector<int> st(n, 0);
    auto kek = f(0, v, st);
    cout << kek->size() << '\n';
    for (auto i = 0; i < kek->size(); ++i) {
        cout << (*kek)[i] << ' ';
    }
    return 0;
}